/******/ (function(modules) { // webpackBootstrap
/******/ 	// The module cache
/******/ 	var installedModules = {};
/******/
/******/ 	// The require function
/******/ 	function __webpack_require__(moduleId) {
/******/
/******/ 		// Check if module is in cache
/******/ 		if(installedModules[moduleId]) {
/******/ 			return installedModules[moduleId].exports;
/******/ 		}
/******/ 		// Create a new module (and put it into the cache)
/******/ 		var module = installedModules[moduleId] = {
/******/ 			i: moduleId,
/******/ 			l: false,
/******/ 			exports: {}
/******/ 		};
/******/
/******/ 		// Execute the module function
/******/ 		modules[moduleId].call(module.exports, module, module.exports, __webpack_require__);
/******/
/******/ 		// Flag the module as loaded
/******/ 		module.l = true;
/******/
/******/ 		// Return the exports of the module
/******/ 		return module.exports;
/******/ 	}
/******/
/******/
/******/ 	// expose the modules object (__webpack_modules__)
/******/ 	__webpack_require__.m = modules;
/******/
/******/ 	// expose the module cache
/******/ 	__webpack_require__.c = installedModules;
/******/
/******/ 	// define getter function for harmony exports
/******/ 	__webpack_require__.d = function(exports, name, getter) {
/******/ 		if(!__webpack_require__.o(exports, name)) {
/******/ 			Object.defineProperty(exports, name, {
/******/ 				configurable: false,
/******/ 				enumerable: true,
/******/ 				get: getter
/******/ 			});
/******/ 		}
/******/ 	};
/******/
/******/ 	// getDefaultExport function for compatibility with non-harmony modules
/******/ 	__webpack_require__.n = function(module) {
/******/ 		var getter = module && module.__esModule ?
/******/ 			function getDefault() { return module['default']; } :
/******/ 			function getModuleExports() { return module; };
/******/ 		__webpack_require__.d(getter, 'a', getter);
/******/ 		return getter;
/******/ 	};
/******/
/******/ 	// Object.prototype.hasOwnProperty.call
/******/ 	__webpack_require__.o = function(object, property) { return Object.prototype.hasOwnProperty.call(object, property); };
/******/
/******/ 	// __webpack_public_path__
/******/ 	__webpack_require__.p = "";
/******/
/******/ 	// Load entry module and return exports
/******/ 	return __webpack_require__(__webpack_require__.s = 0);
/******/ })
/************************************************************************/
/******/ ([
/* 0 */
/***/ (function(module, exports, __webpack_require__) {

"use strict";

Object.defineProperty(exports, "__esModule", { value: true });
var Service = __webpack_require__(1);
var service = new Service("com.lg.app.signage.scapservice");
var serviceStarted = false;
service.register('init', function (message) {
    try {
        if (serviceStarted) {
            message.respond({
                returnValue: true,
                message: 'OK - Scap service already started'
            });
        }
        else {
            Promise.resolve()
                .then(function () {
                var scapLibraryManager = new ScapLibraryManager(service);
                return scapLibraryManager.initialize();
            })
                .then(function (scapLibraryManager) {
                new ScapPower(service, scapLibraryManager);
            })
                .then(function () {
                serviceStarted = true;
                message.respond({
                    returnValue: true,
                    message: 'OK - Scap service started'
                });
            });
        }
    }
    catch (e) {
        console.log('Exception', e.message, e.stack);
        message.respond({
            returnValue: false,
            message: 'Exception: ' + e.message + ', Stacktrace: ' + e.stack
        });
    }
});
service.activityManager.idleTimeout = 60;
var keepAlive;
service.activityManager.create('keepAliveScapService', function (activity) {
    keepAlive = activity;
});
var ScapPower = /** @class */ (function () {
    function ScapPower(service, scapLibraryManager) {
        var _this = this;
        this.library = scapLibraryManager.getLibrary('power');
        service.register('power_reboot', function (message) {
            _this.reboot();
        });
    }
    ScapPower.prototype.reboot = function () {
        this.library.executePowerCommand(function () {
            // Rebooting now
        }, function () {
            // Call failed
        }, {
            powerCommand: "reboot"
        });
    };
    return ScapPower;
}());
exports.ScapPower = ScapPower;
var ScapLibraryManager = /** @class */ (function () {
    function ScapLibraryManager(service) {
        this.service = service;
        this.scapLibraries = {};
        this.scapLibraries['1.5'] = {};
        this.scapLibraries['1.5']['configuration'] = __webpack_require__(2);
        this.scapLibraries['1.5']['deviceInfo'] = __webpack_require__(3);
        this.scapLibraries['1.5']['power'] = __webpack_require__(4);
        this.scapLibraries['1.5']['security'] = __webpack_require__(5);
        this.scapLibraries['1.5']['signage'] = __webpack_require__(6);
        this.scapLibraries['1.5']['sound'] = __webpack_require__(7);
        this.scapLibraries['1.5']['storag'] = __webpack_require__(8);
        this.scapLibraries['1.5']['time'] = __webpack_require__(9);
        this.scapLibraries['1.5']['utility'] = __webpack_require__(10);
        this.scapLibraries['1.6'] = {};
        this.scapLibraries['1.6']['configuration'] = __webpack_require__(11);
        this.scapLibraries['1.6']['deviceInfo'] = __webpack_require__(12);
        this.scapLibraries['1.6']['power'] = __webpack_require__(13);
        this.scapLibraries['1.6']['security'] = __webpack_require__(14);
        this.scapLibraries['1.6']['signage'] = __webpack_require__(15);
        this.scapLibraries['1.6']['sound'] = __webpack_require__(16);
        this.scapLibraries['1.6']['storag'] = __webpack_require__(17);
        this.scapLibraries['1.6']['time'] = __webpack_require__(18);
        this.scapLibraries['1.6']['utility'] = __webpack_require__(19);
    }
    ScapLibraryManager.prototype.initialize = function () {
        var _this = this;
        return this.determineScapLibrary()
            .then(function (scapVersion) {
            _this.scapLibrary = _this.scapLibraries[scapVersion];
            console.log('Initialized library');
            return _this;
        });
    };
    ScapLibraryManager.prototype.getLibrary = function (library) {
        var LibraryClass = this.scapLibrary[library];
        return new LibraryClass(this.service);
    };
    ScapLibraryManager.prototype.determineScapLibrary = function () {
        return this.scapCall("luna://com.webos.service.tv.systemproperty/getSystemInfo", {
            "keys": ["sdkVersion"]
        })
            .then(function (data) {
            var sdkVersion = data.sdkVersion;
            var scapVersion = '1.5';
            if (sdkVersion.indexOf('4.') === 0)
                scapVersion = '1.6';
            console.log('SDK version: ' + sdkVersion + '. Determined scap library version: ' + scapVersion);
            return scapVersion;
        });
    };
    ScapLibraryManager.prototype.scapCall = function (url, params) {
        var _this = this;
        return new Promise(function (resolve, reject) {
            _this.service.call(url, params, function (message) {
                if (message && message.payload && message.payload.returnValue) {
                    resolve(message.payload);
                }
                else {
                    reject(new Error(JSON.stringify(message)));
                }
            });
        });
    };
    ;
    return ScapLibraryManager;
}());
exports.ScapLibraryManager = ScapLibraryManager;


/***/ }),
/* 1 */
/***/ (function(module, exports) {

module.exports = require("webos-service");

/***/ }),
/* 2 */
/***/ (function(module, exports) {

Configuration=(function(){var Configuration,service;function log(msg){}
if(typeof window==='object'){cordova.define('cordova/plugin/configuration',function(require,exports,module){Configuration=function(){};if(window.PalmSystem){log("Window.PalmSystem Available");service=require('cordova/plugin/webos/service')}else{service={Request:function(uri,params){log(uri+" invoked. But I am a dummy because PalmSystem is not available");if(typeof params.onFailure==='function'){params.onFailure({returnValue:!1,errorText:"PalmSystem Not Available. Cordova is not installed?"})}}}}
module.exports=Configuration});Configuration=cordova.require('cordova/plugin/configuration')}
else{Configuration=function(serviceInstance){service=serviceInstance;service.Request=function(serviceUri,reqParams){var commandURI=serviceUri+"/"+reqParams.method;var parameters={};if(reqParams.hasOwnProperty("parameters")===!0)
parameters=reqParams.parameters;var convertedRes={};var callback=function(res){console.log("res : "+JSON.stringify(res));if(res.payload.returnValue===!0){convertedRes=res.payload;reqParams.onSuccess(convertedRes)}else{convertedRes.returnValue=!1;convertedRes.errorCode=res.payload.errorCode;convertedRes.errorText=res.payload.errorText;reqParams.onFailure(convertedRes)}}
if(service){service.call(commandURI,parameters,callback)}}};module.exports=Configuration}
function checkErrorCodeNText(result,errorCode,errorText){if(result.errorCode===undefined||result.errorCode===null){result.errorCode=errorCode}
if(result.errorText===undefined||result.errorText===null){result.errorText=errorText}}
Configuration.PictureMode={VIVID:"vivid",STANDARD:"normal",APS:"eco",CINEMA:"cinema",GAME:"game",SPORTS:"sports",EXPERT1:"expert1",EXPERT2:"expert2"};Configuration.AppMode={LOCAL:"local",USB:"usb",REMOTE:"remote"};Configuration.AppType={IPK:"ipk",ZIP:"zip"};Configuration.LocaleList=[{'language':'čeština','languageCode':'cs','countries':[{'name':'','specifier':'cs-CZ'}]},{'language':'dansk','languageCode':'da','countries':[{'name':'','specifier':'da-DK'}]},{'language':'Deutsch','languageCode':'de','countries':[{'name':'','specifier':'de-DE'}]},{'language':'English','languageCode':'en','countries':[{'name':'','specifier':'en-US'}]},{'language':'Español','languageCode':'es','countries':[{'name':'','specifier':'es-ES'}]},{'language':'ελληνική γλώσσα','languageCode':'el','countries':[{'name':'','specifier':'el-GR'}]},{'language':'Français','languageCode':'fr','countries':[{'name':'','specifier':'fr-FR'}]},{'language':'italiano','languageCode':'it','countries':[{'name':'','specifier':'it-IT'}]},{'language':'Nederlands','languageCode':'nl','countries':[{'name':'','specifier':'nl-NL'}]},{'language':'norsk','languageCode':'nb','countries':[{'name':'','specifier':'nb-NO'}]},{'language':'português','languageCode':'pt','countries':[{'name':'Portugal','specifier':'pt-PT'},{'name':'Brasil','specifier':'pt-BR'}]},{'language':'русский','languageCode':'ru','countries':[{'name':'','specifier':'ru-RU'}]},{'language':'suomi','languageCode':'fi','countries':[{'name':'','specifier':'fi-FI'}]},{'language':'svenska','languageCode':'sv','countries':[{'name':'','specifier':'sv-SE'}]},{'language':'한국어','languageCode':'ko','countries':[{'name':'','specifier':'ko-KR'}]},{'language':'中文','languageCode':'zh-Hans','countries':[{'name':'中国','specifier':'zh-Hans-CN'}]},{'language':'日本語','languageCode':'ja','countries':[{'name':'','specifier':'ja-JP'}]},{'language':'中文','languageCode':'zh','countries':[{'name':'香港','specifier':'zh-Hant-HK'}]}];function isValidSpecifier(value){var arr=Configuration.LocaleList;for(var i=0;i<arr.length;i++){var countries=arr[i].countries;for(var j=0;j<countries.length;j++){if(countries[j].specifier===value){return!0}}}
return!1}
function isValidLanguageCode(value){var arr=Configuration.LocaleList;for(var i=0;i<arr.length;i++){if(arr[i].languageCode===value){return!0}}
return!1}
var version=null;function checkPlatformVersion(cb){if(version===null){service.Request('luna://com.webos.service.tv.systemproperty',{method:'getSystemInfo',parameters:{keys:["sdkVersion"]},onSuccess:function(result){log("getPlatformInfo: onSuccess");var temp=result.sdkVersion.split('.');if(temp.length>=1&&temp[0]==='1'){version=1}else if(temp.length>=1&&temp[0]==='2'){version=2}else if(temp.length>=1&&temp[0]==='3'){version=3}else{version=0}
delete result.returnValue;cb(version)},onFailure:function(error){log("getPlatformInfo: onFailure");delete error.returnValue;version=0;cb(version)}})}else{cb(version)}}
Configuration.prototype.setPictureMode=function(successCallback,errorCallback,options){log("setPictureMode: "+JSON.stringify(options));service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"set",parameters:{category:"picture",settings:{"pictureMode":options.mode}},onSuccess:function(result){log("setPictureMode: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){successCallback()}}},onFailure:function(result){log("setPictureMode: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"CSPM","Configuration.setPictureMode returns failure.");errorCallback(result)}}});log("Configuration.setPictureMode Done")};Configuration.prototype.getPictureMode=function(successCallback,errorCallback){log("getPictureMode: ");service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"get",parameters:{category:"picture",keys:["pictureMode"]},onSuccess:function(result){log("getPictureMode: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){var cbObj={};cbObj.mode=result.settings.pictureMode;successCallback(cbObj)}}},onFailure:function(result){log("getPictureMode: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"CGPM","Configuration.getPictureMode returns failure.");errorCallback(result)}}});log("Configuration.getPictureMode Done")};Configuration.prototype.setPictureProperty=function(successCallback,errorCallback,options){log("setPictureProperty: "+JSON.stringify(options));checkPlatformVersion(function(ver){var sets={};for(var key in options){if(key!==undefined&&key!==null){sets[key]=options[key];if(key==='tint'||key==='colorTemperature'){sets[key]-=50}else if(key==='blackLevel'){sets[key]={"unknown":options[key]};if(options[key]!=="low"&&options[key]!=="high"){log("setPictureProperty: gamma value error "+JSON.stringify(options));var result={};checkErrorCodeNText(result,"CSPP","Configuration.setPictureProperty, There is No matched item : blackLevel.");errorCallback(result);return}}else if(key==='gamma'&&(ver===2||ver===3)&&options[key]==="high"){sets[key]="high1"}}}
log(JSON.stringify(sets));service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"set",parameters:{category:"picture",settings:sets},onSuccess:function(result){log("setPictureProperty: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){successCallback()}}},onFailure:function(result){log("setPictureProperty: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"CSPP","Configuration.setPictureProperty returns failure.");errorCallback(result)}}});log("Configuration.setPictureProperty Done")})};Configuration.prototype.getPictureProperty=function(successCallback,errorCallback){log("getPictureProperty: ");service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"get",parameters:{category:"picture",keys:["brightness","contrast","color","tint","backlight","sharpness","hSharpness","vSharpness","colorTemperature","dynamicContrast","superResolution","colorGamut","dynamicColor","noiseReduction","mpegNoiseReduction","blackLevel","gamma"]},onSuccess:function(result){log("getPictureProperty: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){var cbObj={};for(var key in result.settings){if(key!==undefined&&key!==null){cbObj[key]=(isNaN(result.settings[key])?result.settings[key]:Number(result.settings[key]));if(key==='tint'||key==='colorTemperature'){cbObj[key]+=50}else if(key==='blackLevel'){cbObj[key]=result.settings[key].unknown}else if(key==='gamma'&&result.settings[key]==="high1"){cbObj[key]="high"}}}
successCallback(cbObj)}}},onFailure:function(result){log("getPictureProperty: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"CGPP","Configuration.getPictureProperty returns failure.");errorCallback(result)}}});log("Configuration.getPictureProperty Done")};var mapTable={"alias":"signageName"};Configuration.prototype.setProperty=function(successCallback,errorCallback,options){log("setProperty: "+JSON.stringify(options));var ret=JSON.parse(options);var sets={};var params={};checkPlatformVersion(function(ver){if(ver===3){mapTable.alias="deviceName";params.category="network"}else{mapTable.alias="signageName";params.category="commercial"}
for(var key in ret){if(mapTable[key]!==undefined){sets[(mapTable[key])]=ret[key]}}
params.settings=sets;service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"set",parameters:params,onSuccess:function(result){log("setProperty: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){successCallback()}}},onFailure:function(result){log("setProperty: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"CSP","Configuration.setProperty returns failure.");errorCallback(result)}}})});log("Configuration.setProperty Done")};Configuration.prototype.getProperty=function(successCallback,errorCallback,options){log("getProperty: ");var ret=JSON.parse(options);var keys=ret.keys;var params={};var arrayKeys=[];checkPlatformVersion(function(ver){if(ver===3){mapTable.alias="deviceName";params.category="network"}else{mapTable.alias="signageName";params.category="commercial"}
for(var key in keys){if(key!==null&&key!==undefined){log("key"+keys[key]);arrayKeys.push(mapTable[keys[key]])}}
params.keys=arrayKeys;log(arrayKeys);service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"get",parameters:params,onSuccess:function(result){log("getProperty: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){var cbObj={};for(var key in keys){if(key!==null||key!==undefined){log("key"+keys[key]);if(result.settings[mapTable[keys[key]]]!==undefined||result.settings[mapTable[keys[key]]]!==null){cbObj[keys[key]]=result.settings[mapTable[keys[key]]]}}}
successCallback(JSON.stringify(cbObj))}}},onFailure:function(result){log("getProperty: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"CGP","Configuration.getProperty returns failure.");errorCallback(result)}}})});log("Configuration.getProperty Done")};Configuration.prototype.setCurrentTime=function(successCallback,errorCallback,options){log("setCurrentTime: "+JSON.stringify(options));var input=new Date(options.year,options.month-1,options.day,options.hour,options.minute,options.sec);if(options.year<2000||options.year>2037||options.month<1||options.month>12||options.day<1||options.day>31||options.hour<0||options.hour>23||options.minute<0||options.minute>59||options.sec<0||options.sec>59||input.getFullYear()!==options.year||input.getMonth()!==(options.month-1)||input.getDate()!==options.day||input.getHours()!==options.hour||input.getMinutes()!==options.minute||input.getSeconds()!==options.sec){if(typeof errorCallback==='function'){log("setCurrentTime: out of range or invalid parameter type");var result={};checkErrorCodeNText(result,"CSCT","Configuration.setCurrentTime returns failure for out of range.");errorCallback(result);return}}
log("setCurrentTime: "+JSON.stringify(options));var time={};time.year=options.year;time.month=options.month;time.day=options.day;time.hour=options.hour;time.minute=options.minute;time.sec=options.sec;service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"setSystemTime",parameters:{time:time,ntp:options.ntp},onSuccess:function(){log("setCurrentTime: On Success");if(typeof successCallback==='function'){successCallback()}},onFailure:function(result){log("setCurrentTime: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"CSCT","Configuration.setCurrentTime returns failure.");errorCallback(result)}}});log("Configuration.setCurrentTime Done")};Configuration.prototype.getCurrentTime=function(successCallback,errorCallback){log("getCurrentTime: ");service.Request("luna://com.palm.systemservice/time/",{method:"getEffectiveBroadcastTime",onSuccess:function(result){log("getCurrentTime : On Success");if(result.returnValue===!0){var cbObj={};var d=new Date(result.adjustedUtc*1000);cbObj.year=d.getFullYear();cbObj.month=d.getMonth()+1;cbObj.day=d.getDate();cbObj.hour=d.getHours();cbObj.minute=d.getMinutes();cbObj.sec=d.getSeconds();service.Request("luna://com.palm.systemservice/",{method:"getPreferences",parameters:{keys:["useNetworkTime"]},onSuccess:function(res){log("getPreferences : On Success");if(res.returnValue===!0){cbObj.ntp=res.useNetworkTime;if(typeof successCallback==='function'){successCallback(cbObj)}}else{if(typeof errorCallback==='function'){checkErrorCodeNText(result,"CGCT","Configuration.getCurrentTime returns failure.");errorCallback(result)}}},onFailure:function(result){log("getCurrentTime: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"CGCT","Configuration.getCurrentTime returns failure.");errorCallback(result)}}})}else{if(typeof errorCallback==='function'){checkErrorCodeNText(result,"CGCT","Configuration.getCurrentTime returns failure.");errorCallback(result)}}},onFailure:function(result){log("getCurrentTime: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"CGCT","Configuration.getCurrentTime returns failure.");errorCallback(result)}}});log("Configuration.getCurrentTime Done")};Configuration.prototype.restartApplication=function(successCallback,errorCallback){log("restartApp: ");service.Request("luna://com.webos.service.commercial.signage.storageservice/",{method:"restart_application",onSuccess:function(result){log("restartApp: On Success");if(typeof successCallback==='function'){successCallback(result)}},onFailure:function(result){log("restartApp: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"CRA","Configuration.restartApp returns failure.");errorCallback(result)}}});log("Configuration.restartApp Done")};Configuration.prototype.getServerProperty=function(successCallback,errorCallback){log("getServerProperty: ");service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"get",parameters:{category:"commercial",keys:["serverIpPort","siServerIp","secureConnection","appLaunchMode","fqdnAddr","fqdnMode","appType"]},onSuccess:function(result){log("getPictureProperty: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){var cbObj={};cbObj.serverIp=result.settings.siServerIp;cbObj.serverPort=parseInt(result.settings.serverIpPort,10);cbObj.secureConnection=(result.settings.secureConnection==="off"?!1:!0);cbObj.appLaunchMode=result.settings.appLaunchMode;cbObj.appType=result.settings.appType;cbObj.fqdnMode=(result.settings.fqdnMode==="off"?!1:!0);cbObj.fqdnAddr=result.settings.fqdnAddr;successCallback(cbObj)}}},onFailure:function(result){log("getServerProperty: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"CGSP","Configuration.getServerProperty returns failure.");errorCallback(result)}}});log("Configuration.getServerProperty Done")};Configuration.prototype.setServerProperty=function(successCallback,errorCallback,options){log("setServerProperty: "+JSON.stringify(options));if(options===undefined||typeof options.serverIp!=='string'||/^(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)\.(25[0-5]|2[0-4][0-9]|[01]?[0-9][0-9]?)$/.test(options.serverIp)===!1||isNaN(options.serverPort)||options.serverPort<0||options.serverPort>65535||typeof options.serverPort!=='number'||typeof options.secureConnection!=='boolean'||typeof options.appLaunchMode!=='string'||(options.appLaunchMode!==Configuration.AppMode.USB&&options.appLaunchMode!==Configuration.AppMode.LOCAL&&options.appLaunchMode!==Configuration.AppMode.REMOTE)||typeof options.fqdnMode!=='boolean'||typeof options.fqdnAddr!=='string'){if(typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"CSSP","Configuration.setServerProperty, Invalid parameters.");log("options.serverIp : "+typeof options.serverIp+" options.serverPort : "+typeof options.serverPort+" options.secureConnection : "+typeof options.secureConnection+" options.appLaunchMode : "+typeof options.appLaunchMode+" options.fqdnMode : "+typeof options.fqdnMode+" options.fqdnAddr : "+options.fqdnAddr);errorCallback(result);return}}
var sets={};sets.siServerIp=options.serverIp;sets.serverIpPort=options.serverPort+'';sets.secureConnection=(options.secureConnection===!0?"on":"off");sets.appLaunchMode=options.appLaunchMode;sets.fqdnMode=(options.fqdnMode===!0?"on":"off");sets.fqdnAddr=options.fqdnAddr;if(typeof options.appType!=='undefined')
sets.appType=options.appType;log(JSON.stringify(sets));service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"set",parameters:{category:"commercial",settings:sets},onSuccess:function(result){log("setServerProperty: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){successCallback()}}},onFailure:function(result){log("setServerProperty: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"CSSP","Configuration.setServerProperty returns failure.");errorCallback(result)}}});log("Configuration.setServerProperty Done")};Configuration.prototype.clearCache=function(successCallback,errorCallback){log("clearCache: ");service.Request("luna://com.webos.service.commercial.signage.storageservice/",{method:"clearCache",onSuccess:function(result){log("clearCache: On Success");if(typeof successCallback==='function'){successCallback()}},onFailure:function(result){log("clearCache: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"CCC","Configuration.clearCache returns failure.");errorCallback(result)}}});log("Configuration.clearCache Done")};Configuration.prototype.getTimeZoneList=function(successCallback,errorCallback){log("getTimeZoneList: ");service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"getTimeZoneList",onSuccess:function(result){log("getTimeZoneList: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){delete result.returnValue;successCallback(result)}}},onFailure:function(result){log("getTimeZoneList: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"CGTL","Configuration.getTimeZoneList returns failure.");errorCallback(result)}}});log("Configuration.getTimeZoneList Done")};Configuration.prototype.getTimeZone=function(successCallback,errorCallback){log("getTimeZone: ");service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"getTimeZone",onSuccess:function(result){log("getTimeZone: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){delete result.returnValue;successCallback(result)}}},onFailure:function(result){log("getTimeZone: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"CGTZ","Configuration.getTimeZone returns failure.");errorCallback(result)}}});log("Configuration.getTimeZone Done")};Configuration.prototype.setTimeZone=function(successCallback,errorCallback,options){log("setTimeZone: ");service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"get",parameters:{category:"time",keys:["autoClock"]},onSuccess:function(result){if(result.returnValue===!0){if(typeof successCallback==='function'){if(result.settings.autoClock==="off"){delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"CSTZ","Configuration.setTimeZone returns failure. autoClock is off");errorCallback(result)}}else{service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"setTimeZone",parameters:options,onSuccess:function(result){log("setTimeZone: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){delete result.returnValue;successCallback(result)}}},onFailure:function(result){log("setTimeZone: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"CSTZ","Configuration.setTimeZone returns failure.");errorCallback(result)}}})}}}},onFailure:function(result){log("setTimeZone: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"CSTZ","Configuration.setTimeZone returns failure.");errorCallback(result)}}});log("Configuration.setTimeZone Done")};Configuration.prototype.debug=function(successCallback,errorCallback,options){log("debug: "+options.enabled);service.Request("luna://com.webos.service.commercial.signage.storageservice/",{method:"debug",parameters:{enabled:options.enabled},onSuccess:function(result){log("debug: On Success");if(typeof successCallback==='function'){successCallback(result)}},onFailure:function(result){log("debug: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"CD","Configuration.debug returns failure.");errorCallback(result)}}});log("Configuration.debug Done")};Configuration.prototype.setUSBLock=function(successCallback,errorCallback,options){log("setUSBLock: "+options.enabled);if(options.enabled===null&&typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"CSUL","Configuration.setUSBLock returns failure. command was not defined.");errorCallback(result);log("Configuration.setUSBLock invalid ");return}
service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"set",parameters:{category:"commercial",settings:{"enableUsb":(options.enabled===!0)?"off":"on"}},onSuccess:function(result){log("setUSBLock: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){successCallback()}}},onFailure:function(result){log("setUSBLock: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"CSUL","Configuration.setUSBLock returns failure.");errorCallback(result)}}});log("Configuration.setUSBLock Done")};Configuration.prototype.getUSBLock=function(successCallback,errorCallback){log("getUSBLock: ");service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"get",parameters:{category:"commercial",keys:["enableUsb"]},onSuccess:function(result){log("getUSBLock: On Success");if(result.returnValue===!0){var cbObj={};cbObj.enabled=(result.settings.enableUsb==="off")?!0:!1;if(typeof successCallback==='function'){successCallback(cbObj)}}},onFailure:function(result){log("getUSBLock: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"CGUL","Configuration.getUSBLock returns failure.");errorCallback(result)}}});log("Configuration.getUSBLock Done")};Configuration.prototype.setOSDLock=function(successCallback,errorCallback,options){log("setOSDLock: "+options.enabled);if(options.enabled===null&&typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"CSOL","Configuration.setOSDLock returns failure. command was not defined.");errorCallback(result);log("Configuration.setOSDLock invalid ");return}
service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"set",parameters:{category:"hotelMode",notifySelf:!1,settings:{"enableMrcu":(options.enabled===!0)?"off":"on","enableOsdVisibility":(options.enabled===!0)?"off":"on"}},onSuccess:function(result){log("setOSDLock: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){successCallback()}}},onFailure:function(result){log("setOSDLock: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"CSOL","Configuration.setOSDLock returns failure.");errorCallback(result)}}});log("Configuration.setOSDLock Done")};Configuration.prototype.getOSDLock=function(successCallback,errorCallback){log("getOSDLock: ");service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"get",parameters:{category:"hotelMode",keys:["enableMrcu","enableOsdVisibility"]},onSuccess:function(result){log("getOSDLock: On Success");if(result.returnValue===!0){var cbObj={};cbObj.enabled=(result.settings.enableMrcu==="on"&&result.settings.enableOsdVisibility==="on")?!1:!0;if(typeof successCallback==='function'){successCallback(cbObj)}}},onFailure:function(result){log("getOSDLock: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"CGOL","Configuration.getOSDLock returns failure.");errorCallback(result)}}});log("Configuration.getOSDLock Done")};Configuration.prototype.getLocaleList=function(successCallback,errorCallback){log("getLocaleList: ");var cbObj={};cbObj.localeList=Configuration.LocaleList;if(typeof successCallback==='function'){successCallback(cbObj)}
log("Configuration.getLocaleList Done")};Configuration.prototype.setOSDLanguage=function(successCallback,errorCallback,options){log("setOSDLanguage: "+options.specifier);if((options.specifier===null||typeof options.specifier!=='string')&&typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"CSOL","Configuration.setOSDLanguage returns failure. command was not defined.");errorCallback(result);log("Configuration.setOSDLanguage invalid ");return}
if(isValidSpecifier(options.specifier)===!0){log("Specifier is valid");service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"get",parameters:{keys:["localeInfo"]},onSuccess:function(result){if(result.returnValue===!0){var localeInfo={};localeInfo=result.settings.localeInfo;localeInfo.locales.UI=options.specifier;localeInfo.locales.FMT=options.specifier;localeInfo.locales.TV=options.specifier;log("localeInfo : "+JSON.stringify(localeInfo));service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"set",parameters:{settings:{localeInfo:localeInfo}},onSuccess:function(result){log("setOSDLanguage: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){successCallback()}}},onFailure:function(result){log("setOSDLanguage: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"CSOL","Configuration.setOSDLanguage returns failure.");errorCallback(result)}}})}},onFailure:function(result){delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"CSOL","Configuration.setOSDLanguage returns failure.");errorCallback(result)}}})}else{var result={};checkErrorCodeNText(result,"CSOL","Configuration.setOSDLanguage returns failure. specifier is not valid.");errorCallback(result);log("Configuration.setOSDLanguage invalid ");return}
log("Configuration.setOSDLanguage Done")};Configuration.prototype.getOSDLanguage=function(successCallback,errorCallback){log("getOSDLanguage: ");service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"get",parameters:{keys:["localeInfo"]},onSuccess:function(result){log("getOSDLanguage: On Success");if(result.returnValue===!0){var cbObj={};log("localeInfo : "+JSON.stringify(result.settings.localeInfo));cbObj.specifier=result.settings.localeInfo.locales.UI;if(typeof successCallback==='function'){successCallback(cbObj)}}},onFailure:function(result){log("getOSDLanguage: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"CGOL","Configuration.getOSDLanguage returns failure.");errorCallback(result)}}});log("Configuration.getOSDLanguage Done")};Configuration.prototype.setVirtualKeyboardLanguage=function(successCallback,errorCallback,options){log("setVirtualKeyboardLanguage: "+options.languageCodeList);if(options.languageCodeList===null&&typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"CSKL","Configuration.setVirtualKeyboardLanguage returns failure. command was not defined.");errorCallback(result);log("Configuration.setVirtualKeyboardLanguage invalid ");return}
for(var i=0;i<options.languageCodeList.length;i++){if(isValidLanguageCode(options.languageCodeList[i])===!1){var result={};checkErrorCodeNText(result,"CSKL","Configuration.setVirtualKeyboardLanguage returns failure. language code is not valid.");errorCallback(result);log("Configuration.setVirtualKeyboardLanguage invalid ");return}}
log("languageCodeList is valid");service.Request("luna://com.webos.service.commercial.signage.storageservice/configuration/",{method:"setVirtualKeyboardLanguage",parameters:{languageCodeList:options.languageCodeList},onSuccess:function(result){log("setVirtualKeyboardLanguage: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){successCallback()}}},onFailure:function(result){log("setVirtualKeyboardLanguage: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"CSKL","Configuration.setVirtualKeyboardLanguage returns failure.");errorCallback(result)}}});log("Configuration.setVirtualKeyboardLanguage Done")};Configuration.prototype.getVirtualKeyboardLanguage=function(successCallback,errorCallback){log("getVirtualKeyboardLanguage: ");service.Request("luna://com.webos.service.commercial.signage.storageservice/configuration/",{method:"getVirtualKeyboardLanguage",parameters:{},onSuccess:function(result){log("getVirtualKeyboardLanguage: On Success");if(result.returnValue===!0){var cbObj={};log("keyboards : "+JSON.stringify(result.languageCodeList));cbObj.languageCodeList=result.languageCodeList;if(typeof successCallback==='function'){successCallback(cbObj)}}},onFailure:function(result){log("getVirtualKeyboardLanguage: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"CGKL","Configuration.getVirtualKeyboardLanguage returns failure.");errorCallback(result)}}});log("Configuration.getVirtualKeyboardLanguage Done")};return Configuration}())

/***/ }),
/* 3 */
/***/ (function(module, exports) {

DeviceInfo=(function(){var DeviceInfo,service;function log(msg){}
if(typeof window==='object'){cordova.define('cordova/plugin/deviceInfo',function(require,exports,module){DeviceInfo=function(){};if(window.PalmSystem){log("Window.PalmSystem Available");service=require('cordova/plugin/webos/service')}else{service={Request:function(uri,params){log(uri+" invoked. But I am a dummy because PalmSystem is not available");if(typeof params.onFailure==='function'){params.onFailure({returnValue:!1,errorText:"PalmSystem Not Available. Cordova is not installed?"})}}}}
module.exports=DeviceInfo});DeviceInfo=cordova.require('cordova/plugin/deviceInfo')}
else{DeviceInfo=function(serviceInstance){service=serviceInstance;service.Request=function(serviceUri,reqParams){var commandURI=serviceUri+"/"+reqParams.method;var parameters={};if(reqParams.hasOwnProperty("parameters")===!0)
parameters=reqParams.parameters;var convertedRes={};var callback=function(res){console.log("res : "+JSON.stringify(res));if(res.payload.returnValue===!0){convertedRes=res.payload;reqParams.onSuccess(convertedRes)}else{convertedRes.returnValue=!1;convertedRes.errorCode=res.payload.errorCode;convertedRes.errorText=res.payload.errorText;reqParams.onFailure(convertedRes)}}
if(service){service.call(commandURI,parameters,callback)}}};module.exports=DeviceInfo}
function checkErrorCodeNText(result,errorCode,errorText){if(result.errorCode===undefined||result.errorCode===null){result.errorCode=errorCode}
if(result.errorText===undefined||result.errorText===null){result.errorText=errorText}}
DeviceInfo.EddystoneFrame={UUID:"uid",URL:"url"};DeviceInfo.prototype.getNetworkInfo=function(successCallback,errorCallback){log("getNetworkInfo: ");service.Request('luna://com.webos.service.commercial.signage.storageservice/network/',{method:'getNetworkInfo',parameters:{},onSuccess:function(result){if(typeof successCallback==='function'){delete result.returnValue;successCallback(result)}},onFailure:function(error){log("getNetworkInfo: onFailure");if(error.errorText.indexOf('Unknown method')!==-1){service.Request('luna://com.palm.connectionmanager',{method:'getstatus',parameters:{},onSuccess:function(result){log("getNetworkInfo: onSuccess");delete result.returnValue;if(typeof successCallback==='function'){successCallback(result)}},onFailure:function(error){log("getNetworkInfo: onFailure");delete error.returnValue;if(typeof errorCallback==='function'){errorCallback(error)}}})}
else{delete error.returnValue;if(typeof errorCallback==='function'){errorCallback(error)}}}});log("DeviceInfo.getNetworkInfo Done")};DeviceInfo.prototype.setNetworkInfo=function(successCallback,errorCallback,options){log("setNetworkInfo: ");service.Request('luna://com.webos.service.commercial.signage.storageservice/network/',{method:'setNetworkInfo',parameters:options,onSuccess:function(result){log("setNetworkInfo: onSuccess");if(typeof successCallback==='function'){successCallback()}},onFailure:function(error){log("setNetworkInfo: onFailure");delete error.returnValue;if(typeof errorCallback==='function'){errorCallback(error)}}});log("DeviceInfo.setNetworkInfo Done")};DeviceInfo.prototype.getBeaconInfo=function(successCallback,errorCallback){log("getBeaconInfo: ");service.Request("luna://com.webos.service.commercial.signage.storageservice/network/",{method:'getBeaconInfo',parameters:{},onSuccess:function(result){log("getBeaconInfo: onSuccess");delete result.returnValue;if(typeof successCallback==='function'){successCallback(result)}},onFailure:function(error){log("getBeaconInfo: onFailure");delete error.returnValue;if(typeof errorCallback==='function'){errorCallback(error)}}});log("DeviceInfo.getBeaconInfo Done")};DeviceInfo.prototype.setBeaconInfo=function(successCallback,errorCallback,options){log("setBeaconInfo: ");var regex=function(uuid){if(typeof uuid==="undefined"||uuid===null||uuid.length!=32){return!1}
var reg=new RegExp(/^[a-fA-F0-9]*$/g);return reg.exec(uuid)!==null?!0:!1};if(options.enabled===!0&&(regex(options.uuid)===!1||isNaN(options.major)||options.major<0||options.major>65535||isNaN(options.minor)||options.minor<0||options.minor>65535)){log("setBeaconInfo: options are invalid.");if(typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"DSBI","DeviceInfo.setBeaconInfo. Invalid options.");errorCallback(result)}
return}
service.Request('luna://com.webos.service.commercial.signage.storageservice/network/',{method:'setBeaconInfo',parameters:options,onSuccess:function(result){log("setBeaconInfo: onSuccess");if(typeof successCallback==='function'){successCallback()}},onFailure:function(error){log("setBeaconInfo: onFailure");delete error.returnValue;if(typeof errorCallback==='function'){errorCallback(error)}}});log("DeviceInfo.setBeaconInfo Done")};DeviceInfo.prototype.getSoftApInfo=function(successCallback,errorCallback){log("getSoftApInfo: ");service.Request("luna://com.webos.service.commercial.signage.storageservice/network/",{method:'getSoftApInfo',parameters:{},onSuccess:function(result){log("getSoftApInfo: onSuccess");delete result.returnValue;if(typeof successCallback==='function'){successCallback(result)}},onFailure:function(error){log("getSoftApInfo: onFailure");delete error.returnValue;if(typeof errorCallback==='function'){errorCallback(error)}}});log("DeviceInfo.getSoftApInfo Done")};DeviceInfo.prototype.setSoftApInfo=function(successCallback,errorCallback,options){log("setSoftApInfo: ");if(options.enabled===!0&&((options.ssid!==null&&options.ssid.length>32)||(options.securityKey!==null&&options.securityKey.length!==6))){log("setSoftApInfo: options are invalid.");if(typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"DSSI","DeviceInfo.setSoftApInfo. Invalid options.");errorCallback(result)}
return}
service.Request("luna://com.webos.service.commercial.signage.storageservice/network/",{method:'setSoftApInfo',parameters:options,onSuccess:function(result){log("setSoftApInfo: onSuccess");if(typeof successCallback==='function'){successCallback()}},onFailure:function(error){log("setSoftApInfo: onFailure");delete error.returnValue;if(typeof errorCallback==='function'){errorCallback(error)}}});log("DeviceInfo.setSoftApInfo Done")};DeviceInfo.prototype.getWifiList=function(successCallback,errorCallback){log("getWifiList: ");service.Request('luna://com.webos.service.commercial.signage.storageservice/network/',{method:'getWifiList',parameters:{},onSuccess:function(result){log("getWifiList: onSuccess");delete result.returnValue;if(typeof successCallback==='function'){successCallback(result)}},onFailure:function(error){log("getWifiList: onFailure");delete error.returnValue;if(typeof errorCallback==='function'){errorCallback(error)}}});log("DeviceInfo.getWifiList Done")};DeviceInfo.prototype.connectWifi=function(successCallback,errorCallback,options){log("connectWifi: ");service.Request('luna://com.webos.service.commercial.signage.storageservice/network/',{method:'connectWifi',parameters:options,onSuccess:function(result){log("connectWifi: onSuccess");if(typeof successCallback==='function'){successCallback()}},onFailure:function(error){log("connectWifi: onFailure");delete error.returnValue;if(typeof errorCallback==='function'){errorCallback(error)}}});log("DeviceInfo.connectWifi Done")};DeviceInfo.prototype.startWps=function(successCallback,errorCallback,options){log("startWps: ");service.Request('luna://com.webos.service.commercial.signage.storageservice/network/',{method:'startWps',parameters:options,onSuccess:function(result){log("startWps: onSuccess");delete result.returnValue;if(typeof successCallback==='function'){successCallback(result)}},onFailure:function(error){log("startWps: onFailure");delete error.returnValue;if(typeof errorCallback==='function'){errorCallback(error)}}});log("DeviceInfo.startWps Done")};DeviceInfo.prototype.stopWps=function(successCallback,errorCallback){log("stopWps: ");service.Request('luna://com.webos.service.commercial.signage.storageservice/network/',{method:'stopWps',parameters:{},onSuccess:function(result){log("stopWps: onSuccess");if(typeof successCallback==='function'){successCallback()}},onFailure:function(error){log("stopWPS: onFailure");delete error.returnValue;if(typeof errorCallback==='function'){errorCallback(error)}}});log("DeviceInfo.stopWps Done")};DeviceInfo.prototype.getNetworkMacInfo=function(successCallback,errorCallback){log("getNetworkMacInfo: ");service.Request('luna://com.webos.service.tv.signage',{method:'getinfo',parameters:{},onSuccess:function(result){log("getNetworkMacInfo: onSuccess");delete result.returnValue;if(typeof successCallback==='function'){successCallback(result)}},onFailure:function(error){log("getNetworkMacInfo: onFailure");delete error.returnValue;if(typeof errorCallback==='function'){errorCallback(error)}}});log("DeviceInfo.getNetworkMacInfo Done")};DeviceInfo.prototype.getPlatformInfo=function(successCallback,errorCallback){log("getPlatformInfo: ");service.Request('luna://com.webos.service.tv.systemproperty',{method:'getSystemInfo',parameters:{keys:["modelName","serialNumber","firmwareVersion","hardwareVersion","sdkVersion"]},onSuccess:function(result){log("getPlatformInfo: onSuccess");result.manufacturer="LGE";result.sdkVersion="0.0.0";delete result.returnValue;if(typeof successCallback==='function'){successCallback(result)}},onFailure:function(error){log("getPlatformInfo: onFailure");delete error.returnValue;if(typeof errorCallback==='function'){errorCallback(error)}}});log("DeviceInfo.getPlatformInfo Done")};DeviceInfo.prototype.getSystemUsageInfo=function(successCallback,errorCallback,options){log("getSystemUsageInfo: ");service.Request("luna://com.webos.service.commercial.signage.storageservice",{method:"getSystemUsageInfo",parameters:{cpus:options.cpus,memory:options.memory},onSuccess:function(result){if(result.returnValue===!0){var ret={};if(typeof result.memory!=='undefined'){ret.memory=result.memory}
if(typeof result.cpus!=='undefined'){ret.cpus=result.cpus}
if(typeof successCallback==='function'){successCallback(ret)}}else{if(typeof errorCallback==='function'){errorCallback({errorCode:result.errorCode,errorText:result.errorText})}}},onFailure:function(result){if(typeof errorCallback==='function'){errorCallback({errorCode:result.errorCode,errorText:result.errorText})}}});log("DeviceInfo.getSystemUsageInfo Done")};DeviceInfo.prototype.setProxyInfo=function(successCallback,errorCallback,options){var proxyInfo={};log("setProxyInfo: "+options.enabled);if(typeof options.enabled!=='boolean'&&typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"DSPI","DeviceInfo.setProxyInfo returns failure. enabled is not boolean.");errorCallback(result);return}else if(typeof options.ipAddress!=='string'&&typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"DSPI","DeviceInfo.setProxyInfo returns failure. ipAddress is not string.");errorCallback(result);return}else if(typeof options.port!=='number'&&typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"DSPI","DeviceInfo.setProxyInfo returns failure. port is not number.");errorCallback(result);return}
if(options.enabled==!1){proxyInfo.proxyEnable="off"}else{proxyInfo.proxyEnable="on";if((options.ipAddress===null||options.ipAddress===undefined||options.ipAddress===""||options.port===null||options.port===undefined||isNaN(options.port))&&typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"DSPI","DeviceInfo.setProxyInfo returns failure. ipAddress and port are required.");errorCallback(result);return}else{proxyInfo.proxySingleAddress=options.ipAddress;proxyInfo.proxySinglePort=options.port.toString()}}
if(typeof options.userName==='string'&&options.userName!==undefined&&options.userName!==null&&typeof options.password==='string'&&options.password!==undefined&&options.password!==null){proxyInfo.proxySingleUsername=options.userName;proxyInfo.proxySinglePassword=options.password}
log("proxyInfo : "+JSON.stringify(proxyInfo));service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"set",parameters:{category:"commercial",settings:proxyInfo},onSuccess:function(result){log("setProxyInfo: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){successCallback()}}},onFailure:function(result){log("setSoundOut: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"DSPI","DeviceInfo.setProxyInfo returns failure.");errorCallback(result)}}});log("DeviceInfo.setProxyInfo Done")};DeviceInfo.prototype.getProxyInfo=function(successCallback,errorCallback){log("getProxyInfo: ");service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"get",parameters:{category:"commercial",keys:["proxyEnable","proxySingleAddress","proxySinglePort"]},onSuccess:function(result){log("getProxyInfo: On Success");if(result.returnValue===!0){var cbObj={};cbObj.enabled=(result.settings.proxyEnable==="on")?!0:!1;cbObj.ipAddress=result.settings.proxySingleAddress;cbObj.port=parseInt(result.settings.proxySinglePort);if(typeof successCallback==='function'){successCallback(cbObj)}}},onFailure:function(result){log("getProxyInfo: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"DGPI","DeviceInfo.getProxyInfo returns failure.");errorCallback(result)}}});log("DeviceInfo.getProxyInfo Done")};DeviceInfo.prototype.setiBeaconInfo=function(successCallback,errorCallback,options){var regex=function(uuid){if(typeof uuid==="undefined"||uuid===null||uuid.length!=32){return!1}
var reg=new RegExp(/^[a-fA-F0-9]*$/g);return reg.exec(uuid)!==null?!0:!1};var iBeaconInfo={};if((options.enabled===null||options.enabled===undefined||typeof options.enabled!=='boolean')&&typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"DSIB","DeviceInfo.setiBeaconInfo returns failure. enabled is required.");errorCallback(result);log("DeviceInfo.setiBeaconInfo invalid ");return}
if(options.enabled==!1){iBeaconInfo.beaconMode="off"}else{if((options.uuid===null||options.uuid===undefined||regex(options.uuid)===!1)&&typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"DSIB","DeviceInfo.setiBeaconInfo returns failure. uuid is not valid.");errorCallback(result);log("DeviceInfo.setiBeaconInfo invalid ");return}
if((options.major===null||options.major===undefined||isNaN(options.major)||options.major<0||options.major>65535||options.minor===null||options.minor===undefined||isNaN(options.minor)||options.minor<0||options.minor>65535)&&typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"DSIB","DeviceInfo.setiBeaconInfo returns failure. major and minor are not valid.");errorCallback(result);log("DeviceInfo.setiBeaconInfo invalid ");return}
iBeaconInfo.beaconMode="on";iBeaconInfo.beaconType="iBeacon";iBeaconInfo.iBeaconUuid=options.uuid;iBeaconInfo.iBeaconMajor=options.major.toString();iBeaconInfo.iBeaconMinor=options.minor.toString()}
log("iBeaconInfo: "+JSON.stringify(iBeaconInfo));service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"set",parameters:{category:"commercial",settings:iBeaconInfo},onSuccess:function(result){log("setiBeaconInfo: On Success");if(result.returnValue===!0){service.Request('luna://com.webos.service.commercial.signage.storageservice/network/',{method:'notifyUpdatingBeaconInfo',parameters:{},onSuccess:function(result){log("notifyUpdatingBeaconInfo: onSuccess");delete result.returnValue;if(typeof successCallback==='function'){successCallback(result)}},onFailure:function(error){log("notifyUpdatingBeaconInfo: onFailure");delete error.returnValue;if(typeof errorCallback==='function'){errorCallback(error)}}})}},onFailure:function(result){log("setiBeaconInfo: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"DSIB","DeviceInfo.setiBeaconInfo returns failure.");errorCallback(result)}}});log("DeviceInfo.setiBeaconInfo Done")};DeviceInfo.prototype.getiBeaconInfo=function(successCallback,errorCallback){log("getiBeaconInfo: ");service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"get",parameters:{category:"commercial",keys:["beaconMode","iBeaconUuid","iBeaconMajor","iBeaconMinor"]},onSuccess:function(result){log("getiBeaconInfo: On Success");if(result.returnValue===!0){var cbObj={};cbObj.enabled=(result.settings.beaconMode==="on")?!0:!1;cbObj.uuid=result.settings.iBeaconUuid;cbObj.major=parseInt(result.settings.iBeaconMajor);cbObj.minor=parseInt(result.settings.iBeaconMinor);if(typeof successCallback==='function'){successCallback(cbObj)}}},onFailure:function(result){log("getiBeaconInfo: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"DGIB","DeviceInfo.getiBeaconInfo returns failure.");errorCallback(result)}}});log("DeviceInfo.getiBeaconInfo Done")};DeviceInfo.prototype.setEddystoneInfo=function(successCallback,errorCallback,options){var chkuuid=function(uuid){if(typeof uuid==="undefined"||uuid===null||uuid.length!=32){return!1}
var reg=new RegExp(/^[a-fA-F0-9]*$/g);return reg.exec(uuid)!==null?!0:!1};var eddystoneInfo={};log("setEddystoneInfo: "+options.enabled);if((options.enabled===null||options.enabled===undefined||typeof options.enabled!=='boolean')&&typeof errorCallback==='function')
{var result={};checkErrorCodeNText(result,"DSEI","DeviceInfo.setEddystoneInfo returns failure. enabled is required.");errorCallback(result);log("DeviceInfo.setEddystoneInfo invalid ");return}
if(options.enabled===!1)
{eddystoneInfo.beaconMode="off"}
else{eddystoneInfo.beaconMode="on";eddystoneInfo.beaconType="eddystone";if(options.frame===DeviceInfo.EddystoneFrame.UUID)
{if(chkuuid(options.frameData)===!1&&typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"DSEI","DeviceInfo.setEddystoneInfo returns failure. frameData is not valid.");errorCallback(result);log("DeviceInfo.setEddystoneInfo invalid ");return}
eddystoneInfo.eddyStoneFrame=options.frame;eddystoneInfo.eddyStoneUuid=options.frameData}
else if(options.frame===DeviceInfo.EddystoneFrame.URL)
{if((options.frameData===null||options.frameData===undefined||typeof options.frameData!=='string'||options.frameData.search("://")<0||options.frameData.substring(0,4).toUpperCase()!=="HTTP")&&typeof errorCallback==='function')
{var result={};checkErrorCodeNText(result,"DSEI","DeviceInfo.setEddystoneInfo returns failure. frameData is not valid.");errorCallback(result);log("DeviceInfo.setEddystoneInfo invalid ");return}
eddystoneInfo.eddyStoneFrame=options.frame;eddystoneInfo.eddyStoneUrlPrefix=options.frameData.substring(0,options.frameData.search("://"));if(options.frameData.substring(options.frameData.search("://")+3,3).toUpperCase()==="WWW"){eddystoneInfo.eddyStoneUrlPrefix=eddystoneInfo.eddyStoneUrlPrefix+"Ex"}
var lengthPrefix=0;if(eddystoneInfo.eddyStoneUrlPrefix.toUpperCase()==="HTTP"){lengthPrefix=7}else if(eddystoneInfo.eddyStoneUrlPrefix.toUpperCase()==="HTTPEX"){lengthPrefix=11}else if(eddystoneInfo.eddyStoneUrlPrefix.toUpperCase()==="HTTPS"){lengthPrefix=8}else if(eddystoneInfo.eddyStoneUrlPrefix.toUpperCase()==="HTTPSEX"){lengthPrefix=12}
if(options.frameData.length-lengthPrefix>17)
{var result={};checkErrorCodeNText(result,"DSEI","DeviceInfo.setEddystoneInfo returns failure. url size is over.");errorCallback(result);log("DeviceInfo.setEddystoneInfo invalid ");return}
eddystoneInfo.eddyStoneUrl=options.frameData.substring(lengthPrefix,options.frameData.length);eddystoneInfo.eddyStoneUrlExCode="noneValue"}
else{var result={};checkErrorCodeNText(result,"DSEI","DeviceInfo.setEddystoneInfo returns failure. frame is not valid.");errorCallback(result);log("DeviceInfo.setEddystoneInfo invalid ");return}}
log("eddystoneInfo : "+JSON.stringify(eddystoneInfo));service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"set",parameters:{category:"commercial",settings:eddystoneInfo},onSuccess:function(result){log("setEddystoneInfo: On Success");if(result.returnValue===!0){service.Request('luna://com.webos.service.commercial.signage.storageservice/network/',{method:'notifyUpdatingBeaconInfo',parameters:{},onSuccess:function(result){log("notifyUpdatingBeaconInfo: onSuccess");delete result.returnValue;if(typeof successCallback==='function'){successCallback(result)}},onFailure:function(error){log("notifyUpdatingBeaconInfo: onFailure");delete error.returnValue;if(typeof errorCallback==='function'){errorCallback(error)}}})}},onFailure:function(result){log("setEddystoneInfo: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"DSEI","DeviceInfo.setEddystoneInfo returns failure.");errorCallback(result)}}})};DeviceInfo.prototype.getEddystoneInfo=function(successCallback,errorCallback){log("getEddystoneInfo: ");service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"get",parameters:{category:"commercial",keys:["beaconMode","eddyStoneFrame","eddyStoneUuid","eddyStoneUrlPrefix","eddyStoneUrl","eddyStoneUrlExCode"]},onSuccess:function(result){log("getEddystoneInfo: On Success");if(result.returnValue===!0){var cbObj={};cbObj.enabled=(result.settings.beaconMode==="on")?!0:!1;cbObj.frame=result.settings.eddyStoneFrame;if(result.settings.eddyStoneFrame===DeviceInfo.EddystoneFrame.UUID){cbObj.frameData=result.settings.eddyStoneUuid}else{if(result.settings.eddyStoneUrlPrefix==="http"){cbObj.frameData="http://"+result.settings.eddyStoneUrl}else if(result.settings.eddyStoneUrlPrefix==="httpEx"){cbObj.frameData="http://www."+result.settings.eddyStoneUrl}else if(result.settings.eddyStoneUrlPrefix==="https"){cbObj.frameData="https://"+result.settings.eddyStoneUrl}else{cbObj.frameData="https://www."+result.settings.eddyStoneUrl}}
if(typeof successCallback==='function'){successCallback(cbObj)}}},onFailure:function(result){log("getEddystoneInfo: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"DGEI","DeviceInfo.getEddystoneInfo returns failure.");errorCallback(result)}}});log("DeviceInfo.getEddystoneInfo Done")};return DeviceInfo}())

/***/ }),
/* 4 */
/***/ (function(module, exports) {

Power=(function(){var Power,service;function log(msg){}
if(typeof window==='object'){cordova.define('cordova/plugin/power',function(require,exports,module){Power=function(){};if(window.PalmSystem){log("Window.PalmSystem Available");service=require('cordova/plugin/webos/service')}else{service={Request:function(uri,params){log(uri+" invoked. But I am a dummy because PalmSystem is not available");if(typeof params.onFailure==='function'){params.onFailure({returnValue:!1,errorText:"PalmSystem Not Available. Cordova is not installed?"})}}}}
module.exports=Power});Power=cordova.require('cordova/plugin/power')}
else{Power=function(serviceInstance){service=serviceInstance;service.Request=function(serviceUri,reqParams){var commandURI=serviceUri+"/"+reqParams.method;var parameters={};if(reqParams.hasOwnProperty("parameters")===!0)
parameters=reqParams.parameters;var convertedRes={};var callback=function(res){console.log("res : "+JSON.stringify(res));if(res.payload.returnValue===!0){convertedRes=res.payload;reqParams.onSuccess(convertedRes)}else{convertedRes.returnValue=!1;convertedRes.errorCode=res.payload.errorCode;convertedRes.errorText=res.payload.errorText;reqParams.onFailure(convertedRes)}}
if(service){service.call(commandURI,parameters,callback)}}};module.exports=Power}
function checkErrorCodeNText(result,errorCode,errorText){if(result.errorCode===undefined||result.errorCode===null){result.errorCode=errorCode}
if(result.errorText===undefined||result.errorText===null){result.errorText=errorText}}
var version=null;var platformInfoObj={};function checkPlatformVersion(cb){if(version===null){service.Request('luna://com.webos.service.tv.systemproperty',{method:'getSystemInfo',parameters:{keys:["sdkVersion","boardType"]},onSuccess:function(result){log("getPlatformInfo: onSuccess");log("version : "+result.sdkVersion);var temp=result.sdkVersion.split('.');if(temp.length>=1&&temp[0]==='1'){platformInfoObj={webOSVer:1,chipset:result.boardType.split("_")[0]}}else if(temp.length>=1&&temp[0]==='2'){platformInfoObj={webOSVer:2,chipset:result.boardType.split("_")[0]}}else if(temp.length>=1&&temp[0]==='3'){platformInfoObj={webOSVer:3,chipset:result.boardType.split("_")[0]}}else{platformInfoObj={webOSVer:0,chipset:""}}
version=platformInfoObj.webOSVer;delete result.returnValue;cb(platformInfoObj)},onFailure:function(error){log("getPlatformInfo: onFailure");delete error.returnValue;platformInfoObj={webOSVer:0,chipset:""}
cb(platformInfoObj)}})}else{cb(platformInfoObj)}}
function convertExternal(extStr){if(platformInfoObj.chipset=='H15'){switch(extStr){case "ext://hdmi:1":return "HDMI1";case "ext://hdmi:2":return "HDMI2";case "ext://hdmi:3":return "OPS/HDMI3/DVI";case "ext://dvi:1":return "OPS/HDMI3/DVI";case "ext://dp:1":return "DISPLAYPORT";case "ext://rgb:1":return "RGB";case "ext://ops:1":return "OPS/HDMI3/DVI";case "HDMI1":return "ext://hdmi:1";case "HDMI2":return "ext://hdmi:2";case "HDMI3":return "ext://hdmi:3";case "DVI":return "ext://dvi:1";case "DISPLAYPORT":return "ext://dp:1";case "RGB":return "ext://rgb:1";case "OPS":return "ext://ops:1";case "OPS/HDMI3/DVI":return "ext://hdmi:3"}}else{switch(extStr){case "ext://hdmi:1":return "HDMI1";case "ext://hdmi:2":return "HDMI2";case "ext://hdmi:3":return "HDMI3";case "ext://dvi:1":return "DVI";case "ext://dp:1":return "DISPLAYPORT";case "ext://rgb:1":return "RGB";case "ext://ops:1":return "OPS";case "HDMI1":return "ext://hdmi:1";case "HDMI":return "ext://hdmi:1";case "HDMI2":return "ext://hdmi:2";case "HDMI3":return "ext://hdmi:3";case "DVI":return "ext://dvi:1";case "DISPLAYPORT":return "ext://dp:1";case "RGB":return "ext://rgb:1";case "OPS":return "ext://ops:1";case "OPS/HDMI3/DVI":return "ext://hdmi:3"}}
return null}
Power.PowerCommand={SHUTDOWN:"powerOff",REBOOT:"reboot"};Power.DisplayMode={DISPLAY_OFF:"Screen Off",DISPLAY_ON:"Active"};Power.TimerWeek={MONDAY:1,TUESDAY:2,WEDNESDAY:4,THURSDAY:8,FRIDAY:16,SATURDAY:32,SUNDAY:64,EVERYDAY:127};Power.DPMSignalType={CLOCK:"clock",CLOCK_WITH_DATA:"clockAndData"};Power.PMMode={PowerOff:"powerOff",SustainAspectRatio:"sustainAspectRatio",ScreenOff:"screenOff",ScreenOffAlways:"screenOffAlways",ScreenOffBacklight:"screenOffBacklight"};Power.prototype.getPowerStatus=function(successCallback,errorCallback){log("getPowerStatus: ");service.Request("luna://com.webos.service.tv.signage/",{method:"getPowerState",onSuccess:function(result){log("getPowerStatus: On Success");var cbObj={};if(result.returnValue===!0){cbObj.displayMode=result.state}
service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"get",parameters:{category:"commercial",keys:["wolEnable"]},onSuccess:function(result){log("getPowerStatus: On Success 2");if(result.returnValue===!0){cbObj.wakeOnLan=(result.settings.wolEnable==="1"?!0:!1)}
service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"get",parameters:{category:"time",keys:["onTimerEnable","offTimerEnable"]},onSuccess:function(result){log("getPowerStatus: On Success 3");if(result.returnValue===!0){cbObj.allOnTimer=(result.settings.onTimerEnable==="on"?!0:!1);cbObj.allOffTimer=(result.settings.offTimerEnable==="on"?!0:!1);if(typeof successCallback==='function'){successCallback(cbObj)}}},onFailure:function(result){log("getPowerStatus: On Failure 3");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"PGPS","Power.getPowerStatus returns failure.");errorCallback(result)}}})},onFailure:function(result){log("getPowerStatus: On Failure 2");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"PGPS","Power.getPowerStatus returns failure.");errorCallback(result)}}})},onFailure:function(result){log("getPowerStatus: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"PGPS","Power.getPowerStatus returns failure.");errorCallback(result)}}});log("Power.getPowerStatus Done")};Power.prototype.enableAllOnTimer=function(successCallback,errorCallback,options){log("enableAllOnTimer: "+JSON.stringify(options));var op=null;switch(options.allOnTimer){case true:op="on";break;case false:op="off";break;default:if(typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"PEAOT","Power.enableAllOnTimer returns failure. Invalid option value.");errorCallback(result)}
return}
service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"set",parameters:{category:"time",settings:{"onTimerEnable":op}},onSuccess:function(){if(options.clearOnTimer===!0){var count=0;var hour=["0","0","0","0","0","0","0"],min=["0","0","0","0","0","0","0"],week=["0","0","0","0","0","0","0"],source=["0","0","0","0","0","0","0"],schedule=[];service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"set",parameters:{category:"commercial",settings:{"multiOnTimerHour":hour,"multiOnTimerMinute":min,"multiOnTimerWeekday":week,"multiOnTimerSource":source,"onTimerCount":count,"onTimerSchedule":schedule}},onSuccess:function(){log("enableAllOnTimer: On Success 2");if(typeof successCallback==='function'){successCallback()}},onFailure:function(result){log("enableAllOnTimer: On Failure 2");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"PEAOT","Power.enableAllOnTimer returns failure. / clearOnTimer");errorCallback(result)}}})}else{if(typeof successCallback==='function'){log("enableAllOnTimer: On Success");successCallback()}}},onFailure:function(result){delete result.returnValue;if(typeof errorCallback==='function'){log("enableAllOnTimer: On Failure");checkErrorCodeNText(result,"PEAOT","Power.enableAllOnTimer returns failure.");errorCallback(result)}}});log("Power.enableAllOnTimer Done")};Power.prototype.enableAllOffTimer=function(successCallback,errorCallback,options){log("enableAllOffTimer: "+JSON.stringify(options));var op=null;switch(options.allOffTimer){case true:op="on";break;case false:op="off";break;default:if(typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"PEAOT","Power.enableAllOffTimer returns failure. Invalid option value.");errorCallback(result)}
return}
service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"set",parameters:{category:"time",settings:{"offTimerEnable":op}},onSuccess:function(){if(options.clearOffTimer===!0){var count=0;var hour=["0","0","0","0","0","0","0"],min=["0","0","0","0","0","0","0"],week=["0","0","0","0","0","0","0"],schedule=[];service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"set",parameters:{category:"commercial",settings:{"multiOffTimerHour":hour,"multiOffTimerMinute":min,"multiOffTimerWeekday":week,"offTimerCount":count,"offTimerSchedule":schedule}},onSuccess:function(){log("enableAllOffTimer: On Success 2");if(typeof successCallback==='function'){successCallback()}},onFailure:function(result){log("enableAllOffTimer: On Failure 2");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"PEAOT","Power.enableAllOffTimer returns failure. / clearOffTimer");errorCallback(result)}}})}else{if(typeof successCallback==='function'){log("enableAllOffTimer: On Success");successCallback()}}},onFailure:function(result){delete result.returnValue;if(typeof errorCallback==='function'){log("enableAllOffTimer: On Failure");checkErrorCodeNText(result,"PEAOT","Power.enableAllOffTimer returns failure.");errorCallback(result)}}});log("Power.enableAllOffTimer Done")};Power.prototype.enableWakeOnLan=function(successCallback,errorCallback,options){log("enableWakeOnLan: "+JSON.stringify(options));var op=null;switch(options.wakeOnLan){case true:op="1";break;case false:op="0";break;default:if(typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"PSWOL","Power.enableWakeOnLan returns failure. Invalid option value.");errorCallback(result)}
return}
service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"set",parameters:{category:"commercial",settings:{"wolEnable":op}},onSuccess:function(){if(typeof successCallback==='function'){log("enableWakeOnLan: On Success");successCallback()}},onFailure:function(result){delete result.returnValue;if(typeof errorCallback==='function'){log("enableWakeOnLan: On Failure");checkErrorCodeNText(result,"PSWOL","Power.enableWakeOnLan returns failure.");errorCallback(result)}}});log("Power.enableWakeOnLan Done")};Power.prototype.addOnTimer=function(successCallback,errorCallback,options){log("addOnTimer: "+JSON.stringify(options));if(options.hour===undefined||isNaN(options.hour)||typeof options.hour!=='number'||options.hour<0||options.hour>23||options.minute===undefined||isNaN(options.minute)||typeof options.minute!=='number'||options.minute<0||options.minute>59||options.week===undefined||isNaN(options.week)||typeof options.week!=='number'||options.week<0||options.week>127||options.inputSource===undefined||typeof options.inputSource!=='string'||options.inputSource.indexOf("ext://")!==0){if(typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"PAOT","Power.addOnTimer returns failure. invalid parameters or out of range.");errorCallback(result)}
return}
checkPlatformVersion(function(info){service.Request("luna://com.webos.service.eim/",{method:"getAllInputStatus",onSuccess:function(result){log("getInputSourceStatus: On Success");if(result.returnValue===!0){var hasInputSource=!1;for(var i=0;i<result.totalCount;i++){var deviceName=result.devices[i].deviceName.toLowerCase();var originDeviceName=deviceName;var inputSourceParam=options.inputSource.substring(6).split(":");var port='1';if(isNaN(deviceName.substring(deviceName.length-1,deviceName.length))===!1)
{deviceName=deviceName.substring(0,deviceName.length-1);port=result.devices[i].id.split("_")[1]}
if(deviceName.toUpperCase()==='DISPLAYPORT')
deviceName='DP';if(deviceName.toUpperCase().indexOf(inputSourceParam[0].toUpperCase())>=0&&port===inputSourceParam[1]){hasInputSource=!0;break}}
if(hasInputSource===!1){log("addOnTimer: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"PAOT","Power.addOnTimer returns failure.");errorCallback(result)}
return}
service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"get",parameters:{category:"commercial",keys:["multiOnTimerHour","multiOnTimerMinute","multiOnTimerWeekday","multiOnTimerSource","onTimerSchedule","onTimerCount"]},onSuccess:function(result){if(result.returnValue===!0){log("version : "+info.webOSVer);if(typeof result.settings.multiOnTimerHour==='string'){result.settings.multiOnTimerHour=JSON.parse(result.settings.multiOnTimerHour)}
if(typeof result.settings.multiOnTimerMinute==='string'){result.settings.multiOnTimerMinute=JSON.parse(result.settings.multiOnTimerMinute)}
if(typeof result.settings.multiOnTimerWeekday==='string'){result.settings.multiOnTimerWeekday=JSON.parse(result.settings.multiOnTimerWeekday)}
if(typeof result.settings.multiOnTimerSource==='string'){result.settings.multiOnTimerSource=JSON.parse(result.settings.multiOnTimerSource)}
if(typeof result.settings.onTimerSchedule==='string'){result.settings.onTimerSchedule=JSON.parse(result.settings.onTimerSchedule)}
var index=(result.settings.onTimerSchedule===null||result.settings.onTimerSchedule===undefined?0:result.settings.onTimerSchedule.length);if(result.settings.multiOnTimerHour.length<=index){if(typeof errorCallback==='function'){checkErrorCodeNText(result,"PSOT","Power.addOnTimer returns failure. No space to add timer.");errorCallback(result)}
return}
if(info.webOSVer===3){if(options.week>=64)
options.week=1+(options.week-64)*2;else options.week=options.week*2}
result.settings.multiOnTimerHour[index]=options.hour;result.settings.multiOnTimerMinute[index]=options.minute;result.settings.multiOnTimerWeekday[index]=options.week;result.settings.multiOnTimerSource[index]=originDeviceName.toUpperCase();var seed=360;result.settings.onTimerSchedule[index]={"_id":""+seed++,"hour":options.hour,"input":originDeviceName.toUpperCase(),"minute":options.minute,"weekday":options.week};service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"set",parameters:{category:"commercial",settings:{"multiOnTimerHour":result.settings.multiOnTimerHour,"multiOnTimerMinute":result.settings.multiOnTimerMinute,"multiOnTimerWeekday":result.settings.multiOnTimerWeekday,"multiOnTimerSource":result.settings.multiOnTimerSource,"onTimerCount":index+1,"onTimerSchedule":result.settings.onTimerSchedule}},onSuccess:function(){log("addOnTimer: On Success 2");if(typeof successCallback==='function'){successCallback()}},onFailure:function(result){log("addOnTimer: On Failure 2");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"PAOT","Power.addOnTimer returns failure.");errorCallback(result)}
return}})}},onFailure:function(result){log("addOnTimer: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"PAOT","Power.addOnTimer returns failure.");errorCallback(result)}
return}})}},onFailure:function(result){log("getInputSourceStatus: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"PAOT","Power.addOnTimer returns failure on gathering input list.");errorCallback(result)}
return}})});log("Power.addOnTimer Done")};Power.prototype.deleteOnTimer=function(successCallback,errorCallback,options){log("deleteOnTimer: "+JSON.stringify(options));if(options.hour===undefined||isNaN(options.hour)||typeof options.hour!=='number'||options.hour<0||options.hour>23||options.minute===undefined||isNaN(options.minute)||typeof options.minute!=='number'||options.minute<0||options.minute>59||options.week===undefined||isNaN(options.week)||typeof options.week!=='number'||options.week<0||options.week>127||options.inputSource===undefined||typeof options.inputSource!=='string'||options.inputSource.indexOf("ext://")!==0){if(typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"PDOT","Power.deleteOnTimer returns failure. invalid parameters or out of range.");errorCallback(result)}
return}
service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"get",parameters:{category:"commercial",keys:["multiOnTimerHour","multiOnTimerMinute","multiOnTimerWeekday","multiOnTimerSource","onTimerSchedule","onTimerCount"]},onSuccess:function(result){if(result.returnValue===!0){checkPlatformVersion(function(info){service.Request("luna://com.webos.service.eim/",{method:"getAllInputStatus",onSuccess:function(inputResult){log("getInputSourceStatus: On Success");if(result.returnValue===!0){log("version : "+info.webOSVer);if(typeof result.settings.multiOnTimerHour==='string'){result.settings.multiOnTimerHour=JSON.parse(result.settings.multiOnTimerHour)}
if(typeof result.settings.multiOnTimerMinute==='string'){result.settings.multiOnTimerMinute=JSON.parse(result.settings.multiOnTimerMinute)}
if(typeof result.settings.multiOnTimerWeekday==='string'){result.settings.multiOnTimerWeekday=JSON.parse(result.settings.multiOnTimerWeekday)}
if(typeof result.settings.multiOnTimerSource==='string'){result.settings.multiOnTimerSource=JSON.parse(result.settings.multiOnTimerSource)}
if(typeof result.settings.onTimerSchedule==='string'){result.settings.onTimerSchedule=JSON.parse(result.settings.onTimerSchedule)}
var addIndex=0,count=(result.settings.onTimerSchedule===null||result.settings.onTimerSchedule===undefined?0:result.settings.onTimerSchedule.length);var hour=["0","0","0","0","0","0","0"],min=["0","0","0","0","0","0","0"],week=["0","0","0","0","0","0","0"],source=["0","0","0","0","0","0","0"],schedule=[];var inputSource=convertExternal(options.inputSource);for(var i=0;i<inputResult.totalCount;i++){var deviceName=inputResult.devices[i].deviceName;var originDeviceName=deviceName;var inputSourceParam=options.inputSource.substring(6).split(":");var port='1';if(isNaN(deviceName.substring(deviceName.length-1,deviceName.length))===!1)
{deviceName=deviceName.substring(0,deviceName.length-1);port=inputResult.devices[i].id.split("_")[1]}
if(deviceName.toUpperCase()==='DISPLAYPORT')
deviceName='DP';if(deviceName.toUpperCase().indexOf(inputSourceParam[0].toUpperCase())>=0&&port===inputSourceParam[1]){inputSource=originDeviceName;break}}
var deleted=!1;if(info.webOSVer===3){if(options.week>=64)
options.week=1+(options.week-64)*2;else options.week=options.week*2}
for(var i=0;i<count;i++){log("deleteOnTimer: "+inputSource);if(result.settings.onTimerSchedule[i]===null){continue}
log("options.week : "+options.week+" result.settings.onTimerSchedule["+i+"].weekday : "+result.settings.onTimerSchedule[i].weekday);if(deleted===!1&&options.hour===result.settings.onTimerSchedule[i].hour&&options.minute===result.settings.onTimerSchedule[i].minute&&options.week==result.settings.onTimerSchedule[i].weekday&&result.settings.onTimerSchedule[i].input.toUpperCase()===inputSource.toUpperCase()){log("deleteOnTimer: index "+i);deleted=!0}else{hour[addIndex]=result.settings.multiOnTimerHour[i];min[addIndex]=result.settings.multiOnTimerMinute[i];week[addIndex]=result.settings.multiOnTimerWeekday[i];source[addIndex]=result.settings.multiOnTimerSource[i];schedule[addIndex]=result.settings.onTimerSchedule[i];addIndex++}}
if(deleted===!0){count--}
if(count===0){schedule=[]}
if(result.settings.onTimerSchedule.length===count){if(typeof errorCallback==='function'){checkErrorCodeNText(result,"PDOT","Power.deleteOnTimer returns failure. There is no 'on timer' matched in the list.");errorCallback(result)}
return}
service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"set",parameters:{category:"commercial",settings:{"multiOnTimerHour":hour,"multiOnTimerMinute":min,"multiOnTimerWeekday":week,"multiOnTimerSource":source,"onTimerCount":count,"onTimerSchedule":schedule}},onSuccess:function(){log("deleteOnTimer: On Success 2");if(typeof successCallback==='function'){successCallback()}},onFailure:function(result){log("deleteOnTimer: On Failure 2");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"PDOT","Power.deleteOnTimer returns failure.");errorCallback(result)}}})}},onFailure:function(result){log("getInputSourceStatus: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"PDOT","Power.deleteOnTimer returns failure");errorCallback(result)}
return}})})}},onFailure:function(result){log("deleteOnTimer: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"PDOT","Power.deleteOnTimer returns failure.");errorCallback(result)}}});log("Power.deleteOnTimer Done")};Power.prototype.addOffTimer=function(successCallback,errorCallback,options){log("addOffTimer: "+JSON.stringify(options));if(options.hour===undefined||isNaN(options.hour)||typeof options.hour!=='number'||options.hour<0||options.hour>23||options.minute===undefined||isNaN(options.minute)||typeof options.minute!=='number'||options.minute<0||options.minute>59||options.week===undefined||isNaN(options.week)||typeof options.week!=='number'||options.week<0||options.week>127){if(typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"PAOT","Power.addOffTimer returns failure. Invalid parameter.");errorCallback(result)}
return}
service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"get",parameters:{category:"commercial",keys:["multiOffTimerHour","multiOffTimerMinute","multiOffTimerWeekday","offTimerSchedule","offTimerCount"]},onSuccess:function(result){if(result.returnValue===!0){if(typeof result.settings.multiOffTimerHour==='string'){result.settings.multiOffTimerHour=JSON.parse(result.settings.multiOffTimerHour)}
if(typeof result.settings.multiOffTimerMinute==='string'){result.settings.multiOffTimerMinute=JSON.parse(result.settings.multiOffTimerMinute)}
if(typeof result.settings.multiOffTimerWeekday==='string'){result.settings.multiOffTimerWeekday=JSON.parse(result.settings.multiOffTimerWeekday)}
if(typeof result.settings.offTimerSchedule==='string'){result.settings.offTimerSchedule=JSON.parse(result.settings.offTimerSchedule)}
var index=(result.settings.offTimerSchedule===null||result.settings.offTimerSchedule===undefined?0:result.settings.offTimerSchedule.length);if(result.settings.multiOffTimerHour.length<=index){if(typeof errorCallback==='function'){checkErrorCodeNText(result,"PAOT","Power.addOffTimer returns failure. No space to add timer.");errorCallback(result)}
return}
checkPlatformVersion(function(info){log("version : "+info.webOSVer);if(info.webOSVer===3){if(options.week>=64)
options.week=1+(options.week-64)*2;else options.week=options.week*2}
result.settings.multiOffTimerHour[index]=options.hour;result.settings.multiOffTimerMinute[index]=options.minute;result.settings.multiOffTimerWeekday[index]=options.week;log("add hour: "+options.hour+", min : "+options.minute+", week : "+options.week);var seed=360;result.settings.offTimerSchedule[index]={"_id":""+seed++,"hour":options.hour,"minute":options.minute,"weekday":options.week};service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"set",parameters:{category:"commercial",settings:{"multiOffTimerHour":result.settings.multiOffTimerHour,"multiOffTimerMinute":result.settings.multiOffTimerMinute,"multiOffTimerWeekday":result.settings.multiOffTimerWeekday,"offTimerCount":index+1,"offTimerSchedule":result.settings.offTimerSchedule}},onSuccess:function(){log("addOffTimer: On Success 2");if(typeof successCallback==='function'){successCallback()}},onFailure:function(result){log("addOffTimer: On Failure 2");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"PAOT","Power.addOffTimer returns failure.");errorCallback(result)}}})})}},onFailure:function(result){log("addOffTimer: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"PAOT","Power.addOffTimer returns failure.");errorCallback(result)}}});log("Power.addOffTimer Done")};Power.prototype.deleteOffTimer=function(successCallback,errorCallback,options){log("deleteOffTimer: "+JSON.stringify(options));if(options.hour===undefined||isNaN(options.hour)||typeof options.hour!=='number'||options.hour<0||options.hour>23||options.minute===undefined||isNaN(options.minute)||typeof options.minute!=='number'||options.minute<0||options.minute>59||options.week===undefined||isNaN(options.week)||typeof options.week!=='number'||options.week<0||options.week>127){if(typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"PDOT","Power.deleteOffTimer returns failure. invalid parameters or out of range.");errorCallback(result)}
return}
service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"get",parameters:{category:"commercial",keys:["multiOffTimerHour","multiOffTimerMinute","multiOffTimerWeekday","offTimerSchedule","offTimerCount"]},onSuccess:function(result){if(result.returnValue===!0){if(typeof result.settings.multiOffTimerHour==='string'){result.settings.multiOffTimerHour=JSON.parse(result.settings.multiOffTimerHour)}
if(typeof result.settings.multiOffTimerMinute==='string'){result.settings.multiOffTimerMinute=JSON.parse(result.settings.multiOffTimerMinute)}
if(typeof result.settings.multiOffTimerWeekday==='string'){result.settings.multiOffTimerWeekday=JSON.parse(result.settings.multiOffTimerWeekday)}
if(typeof result.settings.offTimerSchedule==='string'){result.settings.offTimerSchedule=JSON.parse(result.settings.offTimerSchedule)}
var addIndex=0,count=(result.settings.offTimerSchedule===null||result.settings.offTimerSchedule===undefined?0:result.settings.offTimerSchedule.length);var hour=["0","0","0","0","0","0","0"],min=["0","0","0","0","0","0","0"],week=["0","0","0","0","0","0","0"],schedule=[];var deleted=!1;checkPlatformVersion(function(info){log("version : "+info.webOSVer);if(info.webOSVer===3){if(options.week>=64)
options.week=1+(options.week-64)*2;else options.week=options.week*2}});for(var i=0;i<count;i++){if(result.settings.offTimerSchedule[i]===null){continue}
log("options.week : "+options.week+" result.settings.offTimerSchedule["+i+"].weekday : "+result.settings.offTimerSchedule[i].weekday);if(deleted===!1&&options.hour===result.settings.offTimerSchedule[i].hour&&options.minute===result.settings.offTimerSchedule[i].minute&&options.week===result.settings.offTimerSchedule[i].weekday){deleted=!0}else{hour[addIndex]=result.settings.multiOffTimerHour[i];min[addIndex]=result.settings.multiOffTimerMinute[i];week[addIndex]=result.settings.multiOffTimerWeekday[i];schedule[addIndex]=result.settings.offTimerSchedule[i];addIndex++}}
if(deleted===!0){count--}
if(count===0){schedule=[]}
if(result.settings.offTimerSchedule.length===count){if(typeof errorCallback==='function'){checkErrorCodeNText(result,"PDOT","Power.deleteOffTimer returns failure. There is no 'off timer' matched in the list.");errorCallback(result)}
return}
service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"set",parameters:{category:"commercial",settings:{"multiOffTimerHour":hour,"multiOffTimerMinute":min,"multiOffTimerWeekday":week,"offTimerCount":count,"offTimerSchedule":schedule}},onSuccess:function(){log("deleteOffTimer: On Success 2");if(typeof successCallback==='function'){successCallback()}},onFailure:function(result){log("deleteOffTimer: On Failure 2");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"PDOT","Power.deleteOffTimer returns failure.");errorCallback(result)}}})}},onFailure:function(result){log("deleteOffTimer: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"PDOT","Power.deleteOffTimer returns failure.");errorCallback(result)}}});log("Power.deleteOffTimer Done")};Power.prototype.getOnTimerList=function(successCallback,errorCallback){log("getOnTimerList: ");service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"get",parameters:{category:"commercial",keys:["onTimerSchedule"]},onSuccess:function(result){if(result.returnValue===!0){checkPlatformVersion(function(info){log("version : "+info.webOSVer);var cbObj={};if(typeof result.settings.onTimerSchedule==='string'){result.settings.onTimerSchedule=JSON.parse(result.settings.onTimerSchedule)}
var timerList=new Array(result.settings.onTimerSchedule===null||result.settings.onTimerSchedule===undefined?0:result.settings.onTimerSchedule.length);for(var index=0,i=0;i<timerList.length;i++){if(result.settings.onTimerSchedule[i]===null||result.settings.onTimerSchedule[i]===undefined){continue}
timerList[index]={hour:0,minute:0,week:0,inputSource:0};if(info.webOSVer===3){var tempWeek=result.settings.onTimerSchedule[i].weekday;if(tempWeek%2)
{var remainder=tempWeek%2;tempWeek=64+((tempWeek-remainder)/2)}else tempWeek=tempWeek/2}else result.settings.onTimerSchedule[i].weekday;timerList[index].hour=result.settings.onTimerSchedule[i].hour;timerList[index].minute=result.settings.onTimerSchedule[i].minute;timerList[index].week=tempWeek;var inputlabel="ext://"
var deviceName=result.settings.onTimerSchedule[i].input.toUpperCase();var port='1';if(isNaN(deviceName.substring(deviceName.length-1,deviceName.length))===!1)
{port=deviceName.substring(deviceName.length-1,deviceName.length)
deviceName=deviceName.substring(0,deviceName.length-1)}
deviceName=deviceName.split("/")[0];if(deviceName.toUpperCase()==="DISPLAYPORT")
inputlabel=inputlabel+"dp:"+port;else inputlabel=inputlabel+deviceName.toLowerCase()+":"+port;timerList[index++].inputSource=inputlabel}
cbObj.timerList=timerList;if(typeof successCallback==='function'){successCallback(cbObj)}})}},onFailure:function(result){log("getOnTimerList: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"PGOTL","Power.getOnTimerList returns failure.");errorCallback(result)}}});log("Power.getOnTimerList Done")};Power.prototype.getOffTimerList=function(successCallback,errorCallback){log("getOffTimerList: ");service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"get",parameters:{category:"commercial",keys:["offTimerSchedule"]},onSuccess:function(result){log("getOffTimerList: On Success");checkPlatformVersion(function(info){log("version : "+info.webOSVer);if(result.returnValue===!0){var cbObj={};if(typeof result.settings.offTimerSchedule==='string'){result.settings.offTimerSchedule=JSON.parse(result.settings.offTimerSchedule)}
var timerList=new Array(result.settings.offTimerSchedule===null||result.settings.offTimerSchedule===undefined?0:result.settings.offTimerSchedule.length);for(var index=0,i=0;i<timerList.length;i++){if(result.settings.offTimerSchedule[i]===null||result.settings.offTimerSchedule[i]===undefined){continue}
timerList[index]={hour:0,minute:0,week:0};if(info.webOSVer===3){var tempWeek=result.settings.offTimerSchedule[i].weekday;if(tempWeek%2)
{var remainder=tempWeek%2;tempWeek=64+((tempWeek-remainder)/2)}else tempWeek=tempWeek/2}else tempWeek=result.settings.offTimerSchedule[i].weekday;timerList[index].hour=result.settings.offTimerSchedule[i].hour;timerList[index].minute=result.settings.offTimerSchedule[i].minute;timerList[index++].week=tempWeek}
cbObj.timerList=timerList;if(typeof successCallback==='function'){successCallback(cbObj)}}})},onFailure:function(result){log("getOffTimerList: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"PGOTL","Power.getOffTimerList returns failure.");errorCallback(result)}}});log("Power.getOffTimerList Done")};Power.prototype.setDisplayMode=function(successCallback,errorCallback,options){log("setDisplayMode: "+JSON.stringify(options));var command=null;switch(options.displayMode){case Power.DisplayMode.DISPLAY_OFF:command="turnOffScreen";break;case Power.DisplayMode.DISPLAY_ON:command="turnOnScreen";break;default:if(typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"PSDM","Power.setDisplayMode returns failure. Invalid option value.");errorCallback(result)}
return}
log("setDisplayMode: "+command);if(command===null&&typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"PSDM","Power.setDisplayMode returns failure. command was not defined.");errorCallback(result);log("Power.setDisplayMode invalid ");return}
service.Request("luna://com.webos.service.tv.signage/",{method:"getPowerState",onSuccess:function(result){log("setDisplayMode: On Success");if(result.returnValue===!0&&result.state===options.displayMode){if(typeof successCallback==='function'){log("setDisplayMode: no need to do any action.");successCallback()}
return}
service.Request("luna://com.webos.service.tv.signage/",{method:command,onSuccess:function(result){log("setDisplayMode: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){successCallback()}}},onFailure:function(result){log("setDisplayMode: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"PSDM","Power.setDisplayMode returns failure.");errorCallback(result)}}})},onFailure:function(result){log("setDisplayMode: On Failure 2");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"PSDM","Power.setDisplayMode returns failure.");errorCallback(result)}}});log("Power.setDisplayMode Done")};Power.prototype.executePowerCommand=function(successCallback,errorCallback,options){log("executePowerCommand: "+JSON.stringify(options));if(options.powerCommand===undefined||typeof options.powerCommand!=='string'||options.powerCommand===null||options.powerCommand.length<=0){if(typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"PEPM","Power.executePowerCommand returns failure. invalid argument or out of range. ");errorCallback(result)}
return}
if((options.powerCommand!==Power.PowerCommand.REBOOT)&&(options.powerCommand!==Power.PowerCommand.SHUTDOWN)){var result={};checkErrorCodeNText(result,"PEPM","Power.executePowerCommand returns failure. invalid argument.");errorCallback(result);return}
service.Request("luna://com.webos.service.tv.signage/",{method:options.powerCommand,parameters:{reason:"unknown"},onSuccess:function(result){log("executePowerCommand: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){successCallback()}}},onFailure:function(result){log("executePowerCommand: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"PEPM","Power.executePowerCommand returns failure.");errorCallback(result)}}});log("Power.executePowerCommand Done")};Power.prototype.setDPMWakeup=function(successCallback,errorCallback,options){var signalType=null;switch(options.dpmSignalType){case Power.DPMSignalType.CLOCK:signalType="clock";break;case Power.DPMSignalType.CLOCK_WITH_DATA:signalType="clockAndData";break}
log("setDPMWakeup: "+signalType);if(signalType===null&&typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"PSDW","Power.setDPMWakeup returns failure. command was not defined.");errorCallback(result);log("Power.setDPMWakeup invalid ");return}
service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"set",parameters:{category:"commercial",settings:{"dpmWakeUpControl":signalType}},onSuccess:function(result){log("setDPMWakeup: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){successCallback()}}},onFailure:function(result){log("setDPMWakeup: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"PSDW","Power.setDPMWakeup returns failure.");errorCallback(result)}}});log("Power.setDPMWakeup Done")};Power.prototype.getDPMWakeup=function(successCallback,errorCallback){log("getDPMWakeup: ");service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"get",parameters:{category:"commercial",keys:["dpmWakeUpControl"]},onSuccess:function(result){log("getDPMWakeup: On Success");if(result.returnValue===!0){var cbObj={};cbObj.dpmSignalType=result.settings.dpmWakeUpControl;if(typeof successCallback==='function'){successCallback(cbObj)}}},onFailure:function(result){log("getDPMWakeup: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"PGDW","Power.getDPMWakeup returns failure.");errorCallback(result)}}});log("Power.getDPMWakeup Done")};Power.prototype.setPMMode=function(successCallback,errorCallback,options){var mode=null;switch(options.mode){case Power.PMMode.PowerOff:mode="powerOff";break;case Power.PMMode.SustainAspectRatio:mode="sustainAspectRatio";break;case Power.PMMode.ScreenOff:mode="screenOff";break;case Power.PMMode.ScreenOffAlways:mode="screenOffAlways";break;case Power.PMMode.ScreenOffBacklight:mode="screenOffBacklight";break}
log("setPMMode: "+mode);if(mode===null&&typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"PSPM","Power.setPMMode returns failure. command was not defined.");errorCallback(result);log("Power.setPMMode invalid ");return}
service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"set",parameters:{category:"commercial",settings:{"pmMode":mode}},onSuccess:function(result){log("setPMMode: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){successCallback()}}},onFailure:function(result){log("setPMMode: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"PSPM","Power.setPMMode returns failure.");errorCallback(result)}}});log("Power.setPMMode Done")};Power.prototype.getPMMode=function(successCallback,errorCallback){log("getPMMode: ");service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"get",parameters:{category:"commercial",keys:["pmMode"]},onSuccess:function(result){log("getPMMode: On Success");if(result.returnValue===!0){var cbObj={};cbObj.mode=result.settings.pmMode;if(typeof successCallback==='function'){successCallback(cbObj)}}},onFailure:function(result){log("getPMMode: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"PGPM","Power.getPMMode returns failure.");errorCallback(result)}}});log("Power.getPMMode Done")};Power.prototype.setPowerOnDelay=function(successCallback,errorCallback,options){log("setPowerOnDelay: "+options.delayTime);if(options.delayTime===null&&typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"PSPD","Power.setPowerOnDelay returns failure. command was not defined.");errorCallback(result);log("Power.setPowerOnDelay invalid ");return}
if(typeof options.delayTime!=='number'){var result={};checkErrorCodeNText(result,"PSPD","Power.setPowerOnDelay returns failure. delayTime is not a number.");errorCallback(result);log("Power.setPowerOnDelay invalid type");return}
if((options.delayTime<0)||(options.delayTime>250)){var result={};checkErrorCodeNText(result,"PSPD","Power.setPowerOnDelay returns failure. Out of range.");errorCallback(result);log("Power.setPowerOnDelay invalid range");return}
service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"set",parameters:{category:"commercial",settings:{"powerOnDelay":options.delayTime}},onSuccess:function(result){log("setPowerOnDelay: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){successCallback()}}},onFailure:function(result){log("setPowerOnDelay: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"PSPD","Power.setPowerOnDelay returns failure.");errorCallback(result)}}});log("Power.setPowerOnDelay Done")};Power.prototype.getPowerOnDelay=function(successCallback,errorCallback){log("getPowerOnDelay: ");service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"get",parameters:{category:"commercial",keys:["powerOnDelay"]},onSuccess:function(result){log("getPowerOnDelay: On Success");if(result.returnValue===!0){var cbObj={};cbObj.delayTime=result.settings.powerOnDelay;if(typeof successCallback==='function'){successCallback(cbObj)}}},onFailure:function(result){log("getPowerOnDelay: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"PGPD","Power.getPowerOnDelay returns failure.");errorCallback(result)}}});log("Power.getPowerOnDelay Done")};Power.prototype.getOnOffTimeSchedule=function(successCallback,errorCallback){log("getOnOffTimeSchedule: ");service.Request("luna://com.webos.service.commercial.signage.storageservice/",{method:"getOnOffTimeSchedule",parameters:{},onSuccess:function(result){log("getOnOffTimeSchedule: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){var cbObj={};cbObj.onOffTimeScheduleList=result.settings.onOffTimeSchedule;if(typeof successCallback==='function'){successCallback(cbObj)}}}},onFailure:function(result){log("getOnOffTimeSchedule: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"TGAS","Power.getOnOffTimeSchedule returns failure.");errorCallback(result)}}});log("Power.getOnOffTimeSchedule Done")};Power.prototype.setOnOffTimeSchedule=function(successCallback,errorCallback,params){log("setOnOffTimeSchedule: ");service.Request("luna://com.webos.service.commercial.signage.storageservice/",{method:"setOnOffTimeSchedule",parameters:params,onSuccess:function(result){log("setOnOffTimeSchedule: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){if(typeof successCallback==='function'){successCallback()}}}},onFailure:function(result){log("setOnOffTimeSchedule: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"TGAS","Power.setOnOffTimeSchedule returns failure.");errorCallback(result)}}});log("Power.setOnOffTimeSchedule Done")};Power.prototype.unsetOnOffTimeSchedule=function(successCallback,errorCallback){log("unsetOnOffTimeSchedule: ");service.Request("luna://com.webos.service.commercial.signage.storageservice/",{method:"unsetOnOffTimeSchedule",parameters:{},onSuccess:function(result){log("unsetOnOffTimeSchedule: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){if(typeof successCallback==='function'){successCallback()}}}},onFailure:function(result){log("unsetOnOffTimeSchedule: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"TGAS","Power.unsetOnOffTimeSchedule returns failure.");errorCallback(result)}}});log("Power.unsetHolidaySchedule Done")};return Power}())

/***/ }),
/* 5 */
/***/ (function(module, exports) {

Security=(function(){var Security,service;function log(msg){}
if(typeof window==='object'){cordova.define('cordova/plugin/security',function(require,exports,module){function log(msg){}
var service;if(window.PalmSystem){log("Window.PalmSystem Available");service=require('cordova/plugin/webos/service')}else{service={Request:function(uri,params){log(uri+" invoked. But I am a dummy because PalmSystem is not available");if(typeof params.onFailure==='function'){params.onFailure({returnValue:!1,errorText:"PalmSystem Not Available. Cordova is not installed?"})}}}}
module.exports=Security});Security=cordova.require('cordova/plugin/security')}
else{Security=function(serviceInstance){service=serviceInstance;service.Request=function(serviceUri,reqParams){var commandURI=serviceUri+"/"+reqParams.method;var parameters={};if(reqParams.hasOwnProperty("parameters")===!0)
parameters=reqParams.parameters;var convertedRes={};var callback=function(res){console.log("res : "+JSON.stringify(res));if(res.payload.returnValue===!0){convertedRes=res.payload;reqParams.onSuccess(convertedRes)}else{convertedRes.returnValue=!1;convertedRes.errorCode=res.payload.errorCode;convertedRes.errorText=res.payload.errorText;reqParams.onFailure(convertedRes)}}
if(service){service.call(commandURI,parameters,callback)}}};module.exports=Security}
function checkErrorCodeNText(result,errorCode,errorText){if(result.errorCode===undefined||result.errorCode===null){result.errorCode=errorCode}
if(result.errorText===undefined||result.errorText===null){result.errorText=errorText}}
Security.prototype.registerServerCertificate=function(successCallback,errorCallback,options){log("registerServerCertificate: "+JSON.stringify(options));if(options.userName===undefined||typeof options.userName!=='string'||options.userName.length<4||options.userName.length>10||options.password===undefined||typeof options.password!=='string'||options.password.length<4||options.password.length>10||options.certificate===undefined||typeof options.certificate!=='string'){if(typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"SRSC","Security.registerServerCertificate returns failure. invalid parameters or out of range.");errorCallback(result)}
return}
service.Request("luna://com.webos.service.commercial.signage.storageservice/security/",{method:"registerServerCertificate",parameters:{userName:options.userName,password:options.password,certificate:options.certificate},onSuccess:function(result){log("registerServerCertificate: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){successCallback()}}},onFailure:function(result){log("registerServerCertificate: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SRSC","Security.registerServerCertificate returns failure.");errorCallback(result)}}});log("Security.registerServerCertificate Done")};Security.prototype.unregisterServerCertificate=function(successCallback,errorCallback,options){log("unregisterServerCertificate: "+JSON.stringify(options));if(options.userName===undefined||typeof options.userName!=='string'||options.userName.length<4||options.userName.length>10||options.password===undefined||typeof options.password!=='string'||options.password.length<4||options.password.length>10){if(typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"SUSC","Security.unregisterServerCertificate returns failure. invalid parameters or out of range.");errorCallback(result)}
return}
service.Request("luna://com.webos.service.commercial.signage.storageservice/security",{method:"unregisterServerCertificate",parameters:{userName:options.userName,password:options.password},onSuccess:function(result){log("unregisterServerCertificate: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){successCallback()}}},onFailure:function(result){log("unregisterServerCertificate: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SUSC","Security.unregisterServerCertificate returns failure.");errorCallback(result)}}});log("Security.unregisterServerCertificate Done")};Security.prototype.existServerCertificate=function(successCallback,errorCallback,options){log("existServerCertificate: "+JSON.stringify(options));if(options.userName===undefined||typeof options.userName!=='string'||options.userName.length<4||options.userName.length>10||options.password===undefined||typeof options.password!=='string'||options.password.length<4||options.password.length>10){if(typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"SESC","Security.existServerCertificate returns failure. invalid parameters or out of range.");errorCallback(result)}
return}
service.Request("luna://com.webos.service.commercial.signage.storageservice/security/",{method:"existServerCertificate",parameters:{userName:options.userName,password:options.password},onSuccess:function(result){log("existServerCertificate: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){var cbObj={};cbObj.exist=result.exist;successCallback(cbObj)}}},onFailure:function(result){log("existServerCertificate: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SESC","Security.existServerCertificate returns failure.");errorCallback(result)}}});log("Security.existServerCertificate Done")};return Security}())

/***/ }),
/* 6 */
/***/ (function(module, exports) {

Signage=(function(){var Signage,service;function log(msg){}
if(typeof window==='object'){cordova.define('cordova/plugin/signage',function(require,exports,module){var service;Signage=function(){};if(window.PalmSystem){log("Window.PalmSystem Available");service=require('cordova/plugin/webos/service')}
else{log("Window.PalmSystem is NOT Available");service={Request:function(uri,params){log(uri+" invoked. But I am a dummy because PalmSystem is not available");if(typeof params.onFailure==='function'){params.onFailure({returnValue:!1,errorCode:"CORDOVA_ERR",errorText:"PalmSystem Not Available. Cordova is not installed?"})}}}}
module.exports=Signage});Signage=cordova.require('cordova/plugin/signage')}
else{Signage=function(serviceInstance){service=serviceInstance;service.Request=function(serviceUri,reqParams){var commandURI=serviceUri+"/"+reqParams.method;var parameters={};if(reqParams.hasOwnProperty("parameters")===!0)
parameters=reqParams.parameters;var convertedRes={};var callback=function(res){console.log("res : "+JSON.stringify(res));if(res.payload.returnValue===!0){convertedRes=res.payload;reqParams.onSuccess(convertedRes)}else{convertedRes.returnValue=!1;convertedRes.errorCode=res.payload.errorCode;convertedRes.errorText=res.payload.errorText;reqParams.onFailure(convertedRes)}}
if(service){service.call(commandURI,parameters,callback)}}};module.exports=Signage}
var version=null;var platformInfoObj={};function checkPlatformVersion(cb){if(version===null){service.Request('luna://com.webos.service.tv.systemproperty',{method:'getSystemInfo',parameters:{keys:["sdkVersion","boardType"]},onSuccess:function(result){log("getPlatformInfo: onSuccess");log("version : "+result.sdkVersion);var temp=result.sdkVersion.split('.');if(temp.length>=1&&temp[0]==='1'){platformInfoObj={webOSVer:1,chipset:result.boardType.split("_")[0]}}else if(temp.length>=1&&temp[0]==='2'){platformInfoObj={webOSVer:2,chipset:result.boardType.split("_")[0]}}else if(temp.length>=1&&temp[0]==='3'){platformInfoObj={webOSVer:3,chipset:result.boardType.split("_")[0]}}else{platformInfoObj={webOSVer:0,chipset:""}}
version=platformInfoObj.webOSVer;cb(platformInfoObj)},onFailure:function(error){log("getPlatformInfo: onFailure");platformInfoObj={webOSVer:0,chipset:""}
cb(platformInfoObj)}})}else{cb(platformInfoObj)}}
var removeSignageEventListener=function(event){var monitorObj=_gSystemMonitoringSetup[event];log(JSON.stringify(monitorObj,null,3));if(monitorObj&&monitorObj.getEvent===!0){if(_gSystemMonitoringSetup[event].listenerObj){_gSystemMonitoringSetup[event].getEvent=!1;_gSystemMonitoringSetup[event].listenerObj=null;_gSystemMonitoringSetup[event].listenerObj.cancel()}}};var addSignageEventListener=function(key,callbackfunction){var monitorSetup=_gSystemMonitoringSetup[key];if(monitorSetup&&typeof monitorSetup.createListener==='function'){monitorSetup.listenerObj=monitorSetup.createListener(callbackfunction);monitorSetup.getEvent=!0}};function getInputValue(inputUri){if(inputUri.substring(0,"ext://".length)!=="ext://"){log("Bad prefix: "+inputUri);return!1}
var body=inputUri.substring("ext://".length);log("body is: "+body);var splited=body.split(":");if(splited.length===2){return splited[0]+splited[1]}
else if(splited.length===1){return splited[0]}
else{log("Bad Syntax: "+inputUri);return!1}}
function isValidEnum(arr,value){for(var key in arr){if(arr[key]===value){return!0}}
return!1}
var SETTINGS_KEY={FAILOVER_MODE:"failover",FAILOVER_BACKUPVIASTORAGE_MODE:"backupViaStorage",FAILOVER_PRIORITY:"failoverPriority",IR_OPERATION_MODE:"enableIrRemote",LOCALKEY_OPERATION_MODE:"enableLocalKey",OSD_PORTRAIT_MODE:"osdPortraitMode",TILE_MODE:"tileMode",TILE_ID:"tileId",TILE_ROW:"tileRow",TILE_COLUME:"tileCol",TILE_NATURALMODE:"naturalMode",DPM_MODE:"dpmMode",AUTOMATIC_STANDBY_MODE:"autoSB",ISM_METHOD:"ismmethod",SES_MODE:"smartEnergy",DO_15OFF_MODE:"15off",MONITOR_FAN:"monitorFan",MONITOR_SIGNAL:"monitorSignal",MONITOR_LAMP:"monitorLamp",MONITOR_SCREEN:"monitorScreen",MONITOR_AUDIO:"monitorAudio",AUDIO_SOURCE_HDMI1:"audioSourceHdmi1",AUDIO_SOURCE_HDMI2:"audioSourceHdmi2",AUDIO_SOURCE_DP:"audioSourceDp"};var monitorTemperature=function(callbackfunction){log("Create Listener for monitorTemperature");var subscribed=service.Request("luna://com.webos.service.commercial.signage.storageservice",{method:"systemMonitor/getTemperature",parameters:{subscribe:!0},onSuccess:function(result){log("temperature : "+JSON.stringify(result,null,3));if(result.returnValue===!0){var returnData={source:Signage.MonitoringSource.THERMOMETER,type:Signage.EventType.CURRENT_TEMPERATURE,data:{temperature:result.temperature}};if(typeof callbackfunction==='function'){callbackfunction(returnData)}}},onFailure:function(result){log("monitor_temperature : FAIL "+JSON.stringify(result,null,3))}});return subscribed};var monitorFan=function(callbackfunction){log("Create Listener for monitorFan");var subscribed=service.Request("luna://com.webos.service.commercial.signage.storageservice",{method:"systemMonitor/getFanEvent",parameters:{subscribe:!0},onSuccess:function(result){log("monitor_fan : "+JSON.stringify(result,null,3));if(result.returnValue===!0){var returnData={source:Signage.MonitoringSource.FAN,type:Signage.EventType.FAN_STATUS,data:{status:result.fanFault}};if(typeof callbackfunction==='function'){callbackfunction(returnData)}}},onFailure:function(result){log("monitor_fan : FAIL "+JSON.stringify(result,null,3))}});return subscribed};var monitorLamp=function(callbackfunction){log("Create Listener for monitorLamp");var subscribed=service.Request("luna://com.webos.service.commercial.signage.storageservice",{method:"systemMonitor/getLampEvent",parameters:{subscribe:!0},onSuccess:function(result){log("monitor_lamp : "+JSON.stringify(result,null,3));if(result.returnValue===!0){var returnData={source:Signage.MonitoringSource.LAMP,type:Signage.EventType.LAMP_STATUS,data:{status:result.lampFault}};if(typeof callbackfunction==='function'){callbackfunction(returnData)}}},onFailure:function(result){log("monitor_lamp : FAIL "+JSON.stringify(result,null,3))}});return subscribed};var monitorSignal=function(callbackfunction){log("Create Listener for monitorSignal");var subscribed=service.Request("luna://com.webos.service.commercial.signage.storageservice",{method:"systemMonitor/getSignalEvent",parameters:{subscribe:!0},onSuccess:function(result){log("monitor_signal : "+JSON.stringify(result,null,3));if(result.returnValue===!0){var returnData={type:Signage.EventType.SIGNAL_STATUS,source:Signage.MonitoringSource.SIGNAL,data:{}};if(result.noSignal===!0){returnData.data.status="no_signal"}
else{returnData.data.status="signal_available"}
if(typeof callbackfunction==='function'){callbackfunction(returnData)}}},onFailure:function(result){log("monitor_signal : FAIL "+JSON.stringify(result,null,3))}});return subscribed};var monitorScreen=function(callbackfunction){log("Create Listener for monitorScreen");var subscribed=service.Request("luna://com.webos.service.commercial.signage.storageservice",{method:"systemMonitor/getScreenEvent",parameters:{subscribe:!0},onSuccess:function(result){log("monitor_screen : "+JSON.stringify(result,null,3));if(result.returnValue===!0){var returnData={source:Signage.MonitoringSource.SCREEN,type:Signage.EventType.SCREEN_STATUS,data:{status:result.screen}};if(typeof callbackfunction==='function'){callbackfunction(returnData)}}},onFailure:function(result){log("monitor_screen FAIL : "+JSON.stringify(result,null,3))}});return subscribed};function addSubscriptionEventInfo(eventName,instanceOfSubscription,eventlistener){if(_gSubscriptionEventInfo.hasOwnProperty(eventName)===!1){_gSubscriptionEventInfo[eventName]={};_gSubscriptionEventInfo[eventName].instanceOfSubscription=instanceOfSubscription;_gSubscriptionEventInfo[eventName].eventListener=eventlistener}else{_gSubscriptionEventInfo[eventName].instanceOfSubscription=instanceOfSubscription;_gSubscriptionEventInfo[eventName].eventListener=eventlistener}
return!0}
function removeSubscriptionEventInfo(eventName){if(_gSubscriptionEventInfo.hasOwnProperty(eventName)===!1){return!1}else if(_gSubscriptionEventInfo[eventName].instanceOfSubscription===null){return!1}else{_gSubscriptionEventInfo[eventName].instanceOfSubscription=null;_gSubscriptionEventInfo[eventName].eventListener=null;_gSubscriptionEventInfo[eventName].instanceOfSubscription.cancel();return!0}}
function getSubscriptionEventInfo(eventName){if(_gSubscriptionEventInfo.hasOwnProperty(eventName)===!1){return!1}else{return _gSubscriptionEventInfo[eventName]}}
var monitorRS232C=function(successCallback,errorCallback,eventListener){log("Create Listener for monitorRS232C");var req=service.Request("luna://com.webos.service.commercial.signage.storageservice",{method:"systemMonitor/startMonitorRS232C",parameters:{subscribe:!0},onSuccess:function(result){log("monitorRS232C success : "+JSON.stringify(result,null,3));if(result.returnValue===!0){if(Object.keys(result).length===1){addSubscriptionEventInfo('RS232C',req,eventListener);successCallback()}else if(result.hasOwnProperty('data')===!0){var subEventInfo=getSubscriptionEventInfo('RS232C');if(subEventInfo===!1){errorCallback({errorCode:"INTERNAL_ERROR",errorText:"There is not subscriptionEventInfo"})}else{if(typeof subEventInfo.eventListener==='function'){subEventInfo.eventListener({data:result.data})}}}else{errorCallback({errorCode:"INTERNAL_ERROR",errorText:"Unknown return value"})}
return}},onFailure:function(result){log("monitorRS232C fail : "+JSON.stringify(result,null,3));errorCallback({errorCode:"LUNA_ERROR",errorText:"Failed to request getRS232CEvent to system"})}})};var _gSystemMonitoringSetup={fan:{getEvent:!1,listenerObj:null,createListener:monitorFan},screen:{getEvent:!1,listenerObj:null,createListener:monitorScreen},temperature:{getEvent:!1,listenerObj:null,createListener:monitorTemperature},signal:{getEvent:!1,listenerObj:null,createListener:monitorSignal},lamp:{getEvent:!1,listenerObj:null,createListener:monitorLamp}};var _gSubscriptionEventInfo={RS232C:{instanceOfSubscription:null,eventListener:null}};var _gTileInfo={row:0,col:0};Signage.UNDEFINED='___undefined___';Signage.OsdPortraitMode={ON:"90",OFF:"off"};Signage.ImgResolution={HD:"HD",FHD:"FHD",};Signage.AutomaticStandbyMode={OFF:"off",STANDBY_4HOURS:"4hours"};Signage.IsmMethod={NORMAL:"NORMAL",ORBITER:"ORBITER",INVERSION:"INVERSION",COLORWASH:"COLORWASH",WHITEWASH:"WHITEWASH",WASHING_BAR:"WASHINGBAR",USER_IMAGE:"USERIMAGE",USER_VIDEO:"USERVIDEO"};Signage.FailoverMode={OFF:"off",AUTO:"auto",MANUAL:"manual"};Signage.DigitalAudioInput={HDMI_DP:"hdmi",AUDIO_IN:"audioIn"};Signage.DpmMode={OFF:"off",POWER_OFF_5SECOND:"5sec",POWER_OFF_10SECOND:"10sec",POWER_OFF_15SECOND:"15sec",POWER_OFF_1MINUTE:"1min",POWER_OFF_3MINUTE:"3min",POWER_OFF_5MINUTE:"5min",POWER_OFF_10MINUTE:"10min"};Signage.KeyOperationMode={ALLOW_ALL:"normal",POWER_ONLY:"usePwrOnly",BLOCK_ALL:"blockAll"};Signage.EventType={CURRENT_TEMPERATURE:"CURRENT_TEMPERATURE",FAN_STATUS:"FAN_STATUS",LAMP_STATUS:"LAMP_STATUS",SCREEN_STATUS:"SCREEN_STATUS",SIGNAL_STATUS:"SIGNAL_STATUS"};Signage.MonitoringSource={FAN:"FAN",LAMP:"LAMP",SIGNAL:"SIGNAL",SCREEN:"SCREEN",THERMOMETER:"THERMOMETER"};function checkErrorCodeNText(result,errorCode,errorText){if(result.errorCode===undefined||result.errorCode===null){result.errorCode=errorCode}
if(result.errorText===undefined||result.errorText===null){result.errorText=errorText}}
function getSystemSettings(category,keys,cbObjectGetter,successCallback,errorCallback){var params={category:category,keys:keys};service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"get",parameters:params,onSuccess:function(result){log("On Success");if(result.returnValue===!0){var cbObj=cbObjectGetter(result.settings);if(cbObj===!1){if(typeof errorCallback==='function'){errorCallback({errorText:"Invalid DB value",errorCode:"DB_ERROR"})}}
else{if(typeof successCallback==='function'){log("successCallback");successCallback(cbObj)}
else{log("successCallback not registered or is not a function: "+successCallback)}}}
else{log("Settings Failed:  "+JSON.stringify(result,null,3));if(typeof errorCallback==='function'){errorCallback({errorText:"Invalid DB value : "+result.errorText,errorCode:"DB_ERROR"})}}},onFailure:function(result){log("On Failure");delete result.returnValue;if(result.settings){log("settings = "+JSON.stringify(result.settings,null,3));var cbObject=cbObjectGetter(result.settings);log("errorKey = "+JSON.stringify(result.errorKey,null,3));for(var i=0;i<result.errorKey.length;++i){cbObject[result.errorKey[i]]=Signage.UNDEFINED}
log("cbObj = "+JSON.stringify(cbObject,null,3));if(typeof successCallback==='function'){log("successCallback");successCallback(cbObject)}}
else{if(typeof errorCallback==='function'){errorCallback({errorText:((typeof result.errorText==='undefined')?"DB Failure":result.errorText),errorCode:"DB_ERROR"})}}}});log("Requested Service: "+"luna://com.webos.service.commercial.signage.storageservice/settings/");log("params : "+JSON.stringify(params))}
function setSystemSettings(category,settings,successCallback,errorCallback){var params={category:category,settings:settings};log("settings : "+JSON.stringify(settings,null,3));var hasKey=!1;for(var key in settings){if(key){log("has key : "+key);hasKey=!0;break}}
if(hasKey===!1){log("Nothing to set");successCallback();return}
service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"set",parameters:params,onSuccess:function(){log("On Success");if(typeof successCallback==='function'){log("SUCCEES CALLBACK");successCallback()}},onFailure:function(result){log("On Failure");delete result.returnValue;if(typeof errorCallback==='function'){log("ERROR CALLBACK");errorCallback(result)}}});log("Requested Service: "+"luna://com.webos.service.commercial.signage.storageservice/settings/");log("params : "+JSON.stringify(params))}
Signage.prototype.setPortraitMode=function(successCallback,errorCallback,options){var settings={};var errorMessage;function checkOptions(options){if(options.portraitMode){for(var key in Signage.OsdPortraitMode){if(options.portraitMode===Signage.OsdPortraitMode[key]){return!0}}
errorMessage="Signage.setPortraitMode: Unrecognized OsdPortraintMode : "+options.portraitMode;return!1}
else{errorMessage="Signage.setPortraitMode: portraitMode does not exist.";return!1}}
if(checkOptions(options)){var portraintModeStr=options.portraitMode;settings[SETTINGS_KEY.OSD_PORTRAIT_MODE]=portraintModeStr;service.Request("luna://com.webos.service.commercial.signage.storageservice",{method:"setOsdPortraitMode",parameters:{osdPortraitMode:options.portraitMode},onSuccess:function(result){successCallback()},onFailure:function(error){if(error.errorText.indexOf('Unknown method')!==-1){setSystemSettings("commercial",settings,successCallback,errorCallback)}
else{errorCallback({errorCode:error.errorCode,errorText:error.errorText})}}});log("setPortraitMode Done")}
else{errorCallback({errorCode:"BAD_PARAMETER",errorText:errorMessage})}};Signage.prototype.setFailoverMode=function(successCallback,errorCallback,options){var settings={};var errorMessage;function checkOptions(options){log("options:"+JSON.stringify(options,null,3));var failoverMode=options.failoverMode;if(failoverMode){if(failoverMode.mode){if(failoverMode.mode===Signage.FailoverMode.MANUAL){if(failoverMode.priority){if(failoverMode.priority.length===0||typeof failoverMode.priority.length==='undefined'){return!1}
else{return!0}}
else{errorMessage="priority should be present when mode is MANUAL.";return!1}}
else{if(failoverMode.priority){errorMessage="This priority is available only if mode is : Signage.FailoverMode.MANUAL";return!1}
else{var found=!1;log("Mode is: "+failoverMode.mode);for(var key in Signage.FailoverMode){if(failoverMode.mode===Signage.FailoverMode[key]){log("Matched with: "+Signage.FailoverMode[key]);found=!0}}
if(!found){log("Unrecognized failoverMode : "+failoverMode.mode);errorMessage="Unrecognized failoverMode : "+failoverMode.mode;return!1}
else{return!0}}}}
else{if(!failoverMode.priority){return!0}
else{log("Unrecognized failoverMode : "+failoverMode.mode);errorMessage="Unrecognized failoverMode : "+failoverMode.mode;return!1}}}
else{errorMessage="Fail over mode not set : ";return!1}}
if(checkOptions(options)){var failoverMode=options.failoverMode;if(!failoverMode.mode&&!failoverMode.priority){successCallback()}
else if(failoverMode.mode===Signage.FailoverMode.MANUAL){service.Request("luna://com.webos.service.commercial.signage.storageservice",{method:"setManualFailoverPrioirty",parameters:{priority:failoverMode.priority},onSuccess:function(result){log("onSuccess");if(result.returnValue){successCallback()}
else{log("FAILED: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){log("onFailure");log("FAILED: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})}
else if(failoverMode.mode){var modeStr=failoverMode.mode;log("mode: "+failoverMode.mode);settings[SETTINGS_KEY.FAILOVER_MODE]=modeStr;settings[SETTINGS_KEY.FAILOVER_BACKUPVIASTORAGE_MODE]=modeStr;log("Set: "+JSON.stringify(settings,null,3));setSystemSettings("commercial",settings,successCallback,errorCallback);log("setFailoverMode Done")}
else{var errorObj={errorCode:"BAD_PARAMETER",errorText:"Mode should be set."};errorCallback(errorObj)}}
else{var errorObj2={errorCode:"BAD_PARAMETER",errorText:errorMessage};errorCallback(errorObj2)}};Signage.prototype.getFailoverMode=function(successCallback,errorCallback){try{service.Request("luna://com.webos.service.commercial.signage.storageservice",{method:"getFailoverPrioirty",parameters:{},onSuccess:function(result){log("onSuccess");if(result.returnValue){var returnPriority=[];for(var i=0;i<result.priority.length;i++)
{var splitedPriority=result.priority[i].split("/");var port="";if(typeof splitedPriority[3]==='undefined')
returnPriority.push("ext://"+splitedPriority[2].toLowerCase());else returnPriority.push("ext://"+splitedPriority[2].toLowerCase()+":1")}
successCallback({priority:returnPriority,mode:result.mode})}
else{log("FAILED: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){log("onFailure");log("FAILED: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})}catch(err){log("EXCEPTION"+err);errorCallback({errorCode:"SGFO",errorText:"Signage.getFailoverMode occur error during operaation."})}};function getByType(val,type){var mytype=typeof val;log("mytype: "+mytype);log("type: "+type);if(mytype==='undefined'){return!0}
else if(mytype===type){return val}
else{return!1}}
Signage.prototype.setTileInfo=function(successCallback,errorCallback,options){var errorMessage;var checkOptions=function(options,tileRowMax,tileColMax){var enabledType=typeof options.tileInfo.enabled;log("enabledType:"+enabledType);if(enabledType!=='undefined'&&enabledType!=='boolean'){errorMessage="enabled should be a boolean";return!1}
var isNotANaturalNumber=function(isNum){var ret=new RegExp(/^[0-9]+$/g).exec(isNum);if(ret){return!1}
else{return!0}};if(options.tileInfo){var row=options.tileInfo.row;if(typeof row!=='undefined'){if(isNotANaturalNumber(row)){errorMessage="row should be a natural number :"+row;return!1}
else if(row>tileRowMax||row<1){errorMessage="row should be 0<n<"+(tileRowMax+1)+" but :"+row;return!1}}
else{return!0}
var column=options.tileInfo.column;if(typeof column!=='undefined'){if(isNotANaturalNumber(column)){errorMessage="column should be a natural number :"+column;return!1}
else if(column>tileColMax||column<1){errorMessage="column should be 0<n<"+(tileColMax+1)+" but :"+column;return!1}}
else{return!0}
var id=options.tileInfo.tileId;if(typeof id!=='undefined'){if(isNotANaturalNumber(id)){errorMessage="id should be a natural number :"+id;return!1}
else if(id<1){errorMessage="id should be bigger than 0 but :"+id;return!1}
else{var curRow=_gTileInfo.row;if(row){curRow=row}
var curCol=_gTileInfo.column;if(column){curCol=column}
log("curRow : "+curRow);log("curCol : "+curCol);log("id : "+id);if(id>curCol*curRow){errorMessage="ID should be less than curRow*curCol";return!1}}}
else{return!0}}else{errorMessage="Tile info is mandatory";return!1}
return!0};var rowMax=15;var colMax=15;service.Request("luna://com.webos.service.config",{method:"getConfigs",parameters:{configNames:["commercial.video.tileRowMax","commercial.video.tileColMax"]},onSuccess:function(result){log("onSuccess");if(result.returnValue){rowMax=result.configs["commercial.video.tileRowMax"];colMax=result.configs["commercial.video.tileColMax"];if(checkOptions(options,rowMax,colMax)===!0){var tileInfo=options.tileInfo;var settings={};if(typeof tileInfo.enabled==='boolean'){if(tileInfo.enabled){settings[SETTINGS_KEY.TILE_MODE]='on'}else{settings[SETTINGS_KEY.TILE_MODE]='off'}}
if(tileInfo.row){settings[SETTINGS_KEY.TILE_ROW]=tileInfo.row.toString()}
if(tileInfo.column){settings[SETTINGS_KEY.TILE_COLUME]=tileInfo.column.toString()}
if(tileInfo.tileId){settings[SETTINGS_KEY.TILE_ID]=tileInfo.tileId.toString()}
if(typeof tileInfo.naturalMode==='boolean'){if(tileInfo.naturalMode){settings[SETTINGS_KEY.TILE_NATURALMODE]='on'}else{settings[SETTINGS_KEY.TILE_NATURALMODE]='off'}}
log("Set: "+JSON.stringify(settings,null,3));var newCallBack=function(){log("Do callback");if(tileInfo.row){_gTileInfo.row=tileInfo.row}
if(tileInfo.column){_gTileInfo.column=tileInfo.column}
if(typeof successCallback==='function'){log("Invoke successCallback");successCallback();log("Invoked successCallback")}};setSystemSettings("commercial",settings,newCallBack,errorCallback);log("setTileInfo Done")}else{var cbObj={errorCode:"BAD_PARAM",errorText:errorMessage};errorCallback(cbObj)}}else{log("FAILED: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){log("onFailure");log("FAILED: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})};function getBooleanValue(value){if(value==='on'){return!0}
else{return!1}}
Signage.prototype.getTileInfo=function(successCallback,errorCallback){var cbgetter=function(settings){var cbObj={};log("settings Value: "+JSON.stringify(settings,null,3));cbObj.enabled=getBooleanValue(settings[SETTINGS_KEY.TILE_MODE]);cbObj.row=parseInt(settings[SETTINGS_KEY.TILE_ROW],10);cbObj.column=parseInt(settings[SETTINGS_KEY.TILE_COLUME],10);cbObj.tileId=parseInt(settings[SETTINGS_KEY.TILE_ID],10);cbObj.naturalMode=getBooleanValue(settings[SETTINGS_KEY.TILE_NATURALMODE]);log("Return Value: "+JSON.stringify(cbObj,null,3));return cbObj};var keys=[SETTINGS_KEY.TILE_MODE,SETTINGS_KEY.TILE_ROW,SETTINGS_KEY.TILE_COLUME,SETTINGS_KEY.TILE_ID,SETTINGS_KEY.TILE_NATURALMODE];getSystemSettings("commercial",keys,cbgetter,successCallback,errorCallback)};Signage.prototype.getSignageInfo=function(successCallback,errorCallback){service.Request("luna://com.webos.service.commercial.signage.storageservice/",{method:"getSignageInformation",parameters:{},onSuccess:function(res){if(typeof successCallback==='function'){log(res.signageInfo);if(typeof res.signageInfo.digitalAudioInputMode!=='undefined')
{var digitalAudioInputMode=Signage.DigitalAudioInput.HDMI_DP;if(res.signageInfo.digitalAudioInputMode.hasOwnProperty('ext://HDMI:1'))
digitalAudioInputMode=res.signageInfo.digitalAudioInputMode['ext://HDMI:1'];else if(res.signageInfo.digitalAudioInputMode.hasOwnProperty('ext://hdmi:1'))
digitalAudioInputMode=res.signageInfo.digitalAudioInputMode['ext://hdmi:1'];res.signageInfo.digitalAudioInputMode=digitalAudioInputMode}
successCallback(res.signageInfo)}},onFailure:function(result){delete result.returnValue;if(typeof errorCallback==='function'){errorCallback(result)}}})};Signage.prototype.enableCheckScreen=function(successCallback,errorCallback,options){var errorMessage;var checkOptions=function(options){if(typeof options.checkScreen!=="undefined"||options.checkScreen!==null){return!0}else{errorMessage="need options.checkScreen.";return!1}};if(checkOptions(options)){var settings={checkScreen:(options.checkScreen===!0?"on":"off")};log("Set: "+JSON.stringify(settings,null,3));setSystemSettings("commercial",settings,successCallback,errorCallback);log("enableCheckScreen Done")}else{var cbObj={errorCode:"BAD_PARAMETER",errorText:errorMessage};errorCallback(cbObj)}};Signage.prototype.setIsmMethod=function(successCallback,errorCallback,options){var settings={};var errorMessage;function checkOptions(options,hasUserImage,hasUserVideo){if(options.ismMethod){if((hasUserImage===!1&&options.ismMethod===Signage.IsmMethod.USER_IMAGE)||(hasUserVideo===!1&&(options.ismMethod===Signage.IsmMethod.USER_IMAGE||options.ismMethod===Signage.IsmMethod.USER_VIDEO)))
{errorMessage="no supported ismMethod  : "+options.ismMethod;return!1}
for(var key in Signage.IsmMethod){if(options.ismMethod===Signage.IsmMethod[key]){return!0}}
errorMessage="Unrecognized ismMethod  : "+options.ismMethod;return!1}
else{errorMessage="ismMethod  does not exist.";return!1}}
service.Request("luna://com.webos.service.config/",{method:"getConfigs",parameters:{configNames:["commercial.applist.disablePhoto","commercial.unsupportedFeatures"]},onSuccess:function(result){if(typeof successCallback==='function'&&result.returnValue===!0){var hasUserImage=!0;var hasUserVideo=!0;var disablePhoto=result.configs["commercial.applist.disablePhoto"];for(var i=0;i<disablePhoto.length;i++){if(disablePhoto[i].toLowerCase()==="com.webos.app.ism"){hasUserImage=!1;break}}
var unsupportedFeatures=result.configs["commercial.unsupportedFeatures"];for(var j=0;j<unsupportedFeatures.length;j++){if(unsupportedFeatures[j].toLowerCase()==="usb"){hasUserImage=!1;hasUserVideo=!1;break}}
if(checkOptions(options,hasUserImage,hasUserVideo)){if(options.ismMethod){var ismMethod=options.ismMethod;log("ismMethod : "+ismMethod);settings[SETTINGS_KEY.ISM_METHOD]=ismMethod}
log("Set: "+JSON.stringify(settings,null,3));setSystemSettings("commercial",settings,successCallback,errorCallback);log("setIsmMethod Done")}else{var cbObj={errorCode:"BAD_PARAMETER",errorText:errorMessage};errorCallback(cbObj)}}},onFailure:function(result){delete result.returnValue;if(typeof errorCallback==='function'){errorCallback(result)}}})};Signage.prototype.setDigitalAudioInputMode=function(successCallback,errorCallback,options){var errorMessage;function checkOptions(options){if(options.hasOwnProperty('digitalAudioInputList')){return!1}else if(options.hasOwnProperty('digitalAudioInput')){return!0}else{errorMessage="digitalAudioInputList  does not exist.";return!1}}
if(checkOptions(options)){service.Request("luna://com.webos.service.commercial.signage.storageservice/",{method:"setDigitalAudioInputList",parameters:{digitalAudioInputList:{'ext://hdmi:1':options.digitalAudioInput}},onSuccess:function(){if(typeof successCallback==='function'){successCallback()}},onFailure:function(result){delete result.returnValue;if(typeof errorCallback==='function'){errorCallback(result)}}})}else{var cbObj={errorCode:"BAD_PARAMETER",errorText:errorMessage};errorCallback(cbObj)}};var _gDoBlock=!1;Signage.prototype.registerSystemMonitor=function(successCallback,errorCallback,options){var keys=['fan','signal','lamp','screen','temperature'];var errorMessage;var errorCode="BAD_PARAMETER";log("Listeners are: "+JSON.stringify(_gSystemMonitoringSetup,null,3));function checkOptions(options){if(_gDoBlock===!0){errorMessage="Not ready to register monitor now.";errorCode="SYSTEM_ERROR";return!1}
log("options are: "+JSON.stringify(options,null,3));if(typeof options.eventHandler!=='function'){errorMessage="No event handler was given or event hadnler is not a function";return!1}
if(options.monitorConfiguration){for(var key in options.monitorConfiguration){if(key){var found=!1;for(var i=0;i<keys.length;++i){if(key===keys[i]){log("Found key: "+keys[i]);found=!0}}
if(!found){errorMessage="Invalid Monitoring source  : "+key;return!1}
var value=options.monitorConfiguration[key];log("value: "+value);if(typeof value!=='boolean'){errorMessage="Invalid value  : "+value;return!1}}}
return!0}
else{errorMessage="monitorConfiguration  does not exist.";return!1}}
if(checkOptions(options)){var cancelSuccess=function(){log("Canceled all previous message subscriptions");var handler=options.eventHandler;for(var key in options.monitorConfiguration){if(key){var value=options.monitorConfiguration[key];if(value===!0){log("Add listener for : "+key);addSignageEventListener(key,handler)}}}
log("Monitoring Setup : "+JSON.stringify(_gSystemMonitoringSetup,null,3));log("Start Polling : ");service.Request("luna://com.webos.service.commercial.signage.storageservice",{method:"systemMonitor/startMonitor",parameters:{},onSuccess:function(result){log("On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){successCallback()}}
else{if(typeof errorCallback==='function'){errorCallback(result)}}
_gDoBlock=!1},onFailure:function(result){log("On Failure");delete result.returnValue;if(typeof errorCallback==='function'){errorCallback(result)}
_gDoBlock=!1}})};var cancelError=function(result){errorCallback(result)};log("Cancel all previous message subscriptions");_gDoBlock=!0;cancelAllSubscription(cancelSuccess,cancelError)}
else{var cbObj={errorCode:errorCode,errorText:errorMessage};errorCallback(cbObj)}};Signage.prototype.unregisterSystemMonitor=function(successCallback,errorCallback){cancelAllSubscription(successCallback,errorCallback);log("After unregister, _gSystemMonitoringSetup are: "+JSON.stringify(_gSystemMonitoringSetup,null,3))};function cancelAllSubscription(successCallback,errorCallback){log("cancelAllSubscription> setup are: "+JSON.stringify(_gSystemMonitoringSetup,null,3));for(var key in _gSystemMonitoringSetup){if(key){removeSignageEventListener(key)}}
log("Stop Polling");service.Request("luna://com.webos.service.commercial.signage.storageservice",{method:"systemMonitor/stopMonitor",parameters:{},onSuccess:function(result){log("On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){successCallback()}}
else{if(typeof errorCallback==='function'){errorCallback(result)}}},onFailure:function(result){log("On Failure");delete result.returnValue;if(typeof errorCallback==='function'){errorCallback(result)}}})}
Signage.prototype.getSystemMonitoringInfo=function(successCallback,errorCallback){if(_gSystemMonitoringSetup){successCallback({fan:_gSystemMonitoringSetup.fan.getEvent,signal:_gSystemMonitoringSetup.signal.getEvent,lamp:_gSystemMonitoringSetup.lamp.getEvent,screen:_gSystemMonitoringSetup.screen.getEvent,temperature:_gSystemMonitoringSetup.temperature.getEvent})}
else{var cbObj={errorCode:"ERROR",errorText:"Failed to get system monitoring setup"};errorCallback(cbObj)}};Signage.prototype.setPowerSaveMode=function(successCallback,errorCallback,options){var errorMessage;function checkOptions(options){if(options.powerSaveMode){for(var key in options.powerSaveMode){if(key){var value=options.powerSaveMode[key];if(key==='ses'||key==='do15MinOff'){if(typeof value!=='boolean'){errorMessage="Invalid value  : "+value;return!1}}
else if(key==='automaticStandby'){if(!isValidEnum(Signage.AutomaticStandbyMode,value)){errorMessage="Invalid automaticStandby value  : "+value;return!1}}
else if(key==='dpmMode'){if(!isValidEnum(Signage.DpmMode,value)){errorMessage="Invalid dpmMode value  : "+value;return!1}}
else{errorMessage="Unknown value  : "+key;return!1}}}
return!0}
else{errorMessage="powerSaveMode  does not exist.";return!1}}
if(checkOptions(options)){log(options.powerSaveMode);service.Request("luna://com.webos.service.commercial.signage.storageservice",{method:"setPowerSaveMode",parameters:{mode:options.powerSaveMode},onSuccess:function(result){log("onSuccess");if(result.returnValue){successCallback(result.mode)}
else{log("FAILED: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){log("onFailure");log("FAILED: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})}
else{var cbObj={errorCode:"BAD_PARAMETER",errorText:errorMessage};errorCallback(cbObj)}};Signage.prototype.getPowerSaveMode=function(successCallback,errorCallback){service.Request("luna://com.webos.service.commercial.signage.storageservice",{method:"getPowerSaveMode",parameters:{},onSuccess:function(result){log("onSuccess");if(result.returnValue){successCallback(result.mode)}
else{log("FAILED: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){log("onFailure");log("FAILED: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})};Signage.prototype.setUsagePermission=function(successCallback,errorCallback,options){var settings={};var errorMessage;function checkOptions(options){if(options.policy){for(var key in options.policy){if(key){var value=options.policy[key];if(key==='remoteKeyOperationMode'||key==='localKeyOperationMode'){if(!isValidEnum(Signage.KeyOperationMode,value)){errorMessage="Invalid  KeyOperationMode value  : "+value;return!1}}
else{errorMessage="Unknown value  : "+key;return!1}}}
return!0}
else{errorMessage="policy  does not exist.";return!1}}
if(checkOptions(options)){if(options.policy.localKeyOperationMode){var localKeyOperationMode=options.policy.localKeyOperationMode;log("portraitMode: "+localKeyOperationMode);settings[SETTINGS_KEY.LOCALKEY_OPERATION_MODE]=localKeyOperationMode}
if(options.policy.remoteKeyOperationMode){var remoteKeyOperationMode=options.policy.remoteKeyOperationMode;log("portraitMode: "+remoteKeyOperationMode);settings[SETTINGS_KEY.IR_OPERATION_MODE]=remoteKeyOperationMode}
log("Set: "+JSON.stringify(settings,null,3));setSystemSettings("hotelMode",settings,successCallback,errorCallback);log("setPolicy Done")}
else{var cbObj={errorCode:"BAD_PARAMETER",errorText:errorMessage};errorCallback(cbObj)}};Signage.prototype.getUsagePermission=function(successCallback,errorCallback){var cbgetter=function(settings){log('settings: '+JSON.stringify(settings,null,3));var cbObj={};cbObj.remoteKeyOperationMode=settings[SETTINGS_KEY.IR_OPERATION_MODE];cbObj.localKeyOperationMode=settings[SETTINGS_KEY.LOCALKEY_OPERATION_MODE];log('cbObj: '+JSON.stringify(cbObj,null,3));return cbObj};var keys=[SETTINGS_KEY.IR_OPERATION_MODE,SETTINGS_KEY.LOCALKEY_OPERATION_MODE];getSystemSettings("hotelMode",keys,cbgetter,successCallback,errorCallback)};Signage.prototype.getUsageData=function(successCallback,errorCallback){var gotTT=!1;var gotUT=!1;var cbObject={uptime:!1,totalUsed:!1};function accessResult(){log("accessResult");if(gotTT===!0&&gotUT===!0){log("CB Object: "+JSON.stringify(cbObject,null,3));if(cbObject.uptime===!1||cbObject.totalUsed===!1){errorCallback({errorCode:"CORDOVA_FAIL",errorText:"Failed to get usage data"});return}
else{log("SUCCESS");successCallback(cbObject);return}}
else{log("Not Yet")}}
service.Request("luna://com.webos.service.tv.signage",{method:"getUTT",parameters:{},onSuccess:function(result){log("On getUTT Success");gotTT=!0;if(result.returnValue===!0){log("UTT is :"+result.UTT);cbObject.totalUsed=result.UTT}
accessResult()},onFailure:function(result){log("On getUTT Failure :"+JSON.stringify(result,null,3));gotTT=!0;accessResult()}});service.Request("luna://com.webos.service.tv.signage",{method:"dsmp/getElapsedTime",parameters:{},onSuccess:function(result){log("On getElapsedTime Success");gotUT=!0;log("result: "+JSON.stringify(result,null,3));if(result.returnValue===!0){var elapsedTime=result.elapsedTime;cbObject.uptime=elapsedTime;log("Elapsed!!: "+elapsedTime)}
accessResult()},onFailure:function(result){log("On getSystemSettings Failure "+JSON.stringify(result,null,3));gotUT=!0;accessResult()}})};Signage.prototype.captureScreen=function(successCallback,errorCallback,options){var param={save:(options===undefined||options===null||options.save===undefined?!1:options.save)};if(options!==undefined&&options!==null&&options.thumbnail!==undefined&&options.thumbnail===!0){param.width=128;param.height=72}
else if(options.imgResolution===Signage.ImgResolution.FHD){param.width=1920;param.height=1080}
else{param.width=1280;param.height=720}
service.Request("luna://com.webos.service.commercial.signage.storageservice",{method:"captureScreen",parameters:param,onSuccess:function(result){log("On Success");if(result.returnValue===!0){successCallback({data:result.data,size:result.size,encoding:result.encoding})}
else{errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){log("On Failure");errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})};Signage.prototype.setIntelligentAuto=function(successCallback,errorCallback,options){log("setIntelligentAuto: "+options.enabled);if(options.enabled===null&&typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"SSIA","Signage.setIntelligentAuto returns failure. command was not defined.");errorCallback(result);log("Signage.setIntelligentAuto invalid ");return}
service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"set",parameters:{category:"commercial",settings:{"intelligentAuto":(options.enabled===!0)?"on":"off"}},onSuccess:function(result){log("setIntelligentAuto: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){successCallback()}}},onFailure:function(result){log("setIntelligentAuto: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SSIA","Signage.setIntelligentAuto returns failure.");errorCallback(result)}}});log("Signage.setIntelligentAuto Done")};Signage.prototype.getIntelligentAuto=function(successCallback,errorCallback){log("getIntelligentAuto: ");service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"get",parameters:{category:"commercial",keys:["intelligentAuto"]},onSuccess:function(result){log("getIntelligentAuto: On Success");if(result.returnValue===!0){var cbObj={};cbObj.enabled=result.settings.intelligentAuto;if(typeof successCallback==='function'){successCallback(cbObj)}}},onFailure:function(result){log("getIntelligentAuto: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SGIA","Signage.getIntelligentAuto returns failure.");errorCallback(result)}}});log("Signage.getIntelligentAuto Done")};Signage.prototype.setStudioMode=function(successCallback,errorCallback,options){log("setStudioMode: "+options.enabled);if(options.enabled===null&&typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"SSSM","Signage.setStudioMode returns failure. command was not defined.");errorCallback(result);log("Signage.setStudioMode invalid ");return}
service.Request("luna://com.webos.service.commercial.signage.storageservice/",{method:"version",onSuccess:function(result){if(result.returnValue===!0){var scapVersion=result.version;if(scapVersion[0]==="1"&&scapVersion[2]==="5"){var ret={};checkErrorCodeNText(ret,"ERROR","This function is not supported");errorCallback(ret);return}else{service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"set",parameters:{category:"commercial",settings:{"studioMode":(options.enabled===!0)?"on":"off"}},onSuccess:function(result){log("setStudioMode: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){successCallback()}}},onFailure:function(result){log("setStudioMode: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SSSM","Signage.setStudioMode returns failure.");errorCallback(result)}}})}}},onFailure:function(result){delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SSSM","Signage.setStudioMode returns failure.");errorCallback(result)}}});log("Signage.setStudioMode Done")};Signage.prototype.getStudioMode=function(successCallback,errorCallback){log("getStudioMode: ");service.Request("luna://com.webos.service.commercial.signage.storageservice/",{method:"version",onSuccess:function(result){if(result.returnValue===!0){var scapVersion=result.version;if(scapVersion[0]==="1"&&scapVersion[2]==="5"){var ret={};checkErrorCodeNText(ret,"ERROR","This function is not supported");errorCallback(ret);return}else{service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"get",parameters:{category:"commercial",keys:["studioMode"]},onSuccess:function(result){log("getStudioMode: On Success");if(result.returnValue===!0){var cbObj={};cbObj.enabled=(result.settings.studioMode==="on")?!0:!1;if(typeof successCallback==='function'){successCallback(cbObj)}}},onFailure:function(result){log("getStudioMode: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SGSM","Signage.getStudioMode returns failure.");errorCallback(result)}}})}}},onFailure:function(result){delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SGSM","Signage.getStudioMode returns failure.");errorCallback(result)}}});log("Signage.getStudioMode Done")};Signage.prototype.setLanDaisyChain=function(successCallback,errorCallback,options){service.Request("luna://com.webos.service.config/",{method:"getConfigs",parameters:{configNames:["commercial.hw.lanDaisyChain"]},onSuccess:function(result){if(result.returnValue===!0){if(result.configs["commercial.hw.lanDaisyChain"]===!1){checkErrorCodeNText(result,"SSLD","Signage.setLanDaisyChain returns failure. unsupported feature. ");errorCallback(result);log("Signage.setLanDaisyChain invalid ");return}
else{if(options.enabled===null&&typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"SSLD","Signage.setLanDaisyChain returns failure. command was not defined.");errorCallback(result);log("Signage.setLanDaisyChain invalid ");return}
log("setLanDaisyChain: "+options.enabled);service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"set",parameters:{category:"commercial",settings:{"lanDaisyChain":(options.enabled===!0)?"on":"off"}},onSuccess:function(result){log("setLanDaisyChain: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){successCallback()}}},onFailure:function(result){log("setLanDaisyChain: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SSIA","Signage.setLanDaisyChain returns failure.");errorCallback(result)}}});log("Signage.setLanDaisyChain Done")}}},onFailure:function(result){delete result.returnValue;if(typeof errorCallback==='function'){errorCallback(result)}}})};Signage.prototype.getLanDaisyChain=function(successCallback,errorCallback){service.Request("luna://com.webos.service.config/",{method:"getConfigs",parameters:{configNames:["commercial.hw.lanDaisyChain"]},onSuccess:function(result){if(result.returnValue===!0){if(result.configs["commercial.hw.lanDaisyChain"]===!1){checkErrorCodeNText(result,"SSLD","Signage.getLanDaisyChain returns failure. unsupported feature. ");errorCallback(result);log("Signage.getLanDaisyChain invalid ");return}
else{log("getLanDaisyChain: ");service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"get",parameters:{category:"commercial",keys:["lanDaisyChain"]},onSuccess:function(result){log("getLanDaisyChain: On Success");if(result.returnValue===!0){var cbObj={};cbObj.enabled=(result.settings.lanDaisyChain==="on")?!0:!1;if(typeof successCallback==='function'){successCallback(cbObj)}}},onFailure:function(result){log("getLanDaisyChain: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SSLD","Signage.getLanDaisyChain returns failure.");errorCallback(result)}}});log("Signage.getLanDaisyChain Done")}}},onFailure:function(result){delete result.returnValue;if(typeof errorCallback==='function'){errorCallback(result)}}})};Signage.prototype.registerRS232CEventListener=function(successCallback,errorCallback,options){if(typeof options.eventListener!=='function'){var cbObj={errorCode:"BAD_PARAMETER",errorText:"No event listener was given or event listener is not a function"};errorCallback(cbObj);return!1}
monitorRS232C(successCallback,errorCallback,options.eventListener)};Signage.prototype.unregisterRS232CEventListener=function(successCallback,errorCallback){if(removeSubscriptionEventInfo('RS232C')===!1){if(typeof errorCallback==='function'){errorCallback({errorCode:"BAD_PARAMETER",errorText:"Failed to remove event listener"})}
return}else{service.Request("luna://com.webos.service.commercial.signage.storageservice",{method:"systemMonitor/stopMonitorRS232C",parameters:{},onSuccess:function(result){log("On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){successCallback()}}else{if(typeof errorCallback==='function'){errorCallback(result)}}},onFailure:function(result){log("On Failure");delete result.returnValue;if(typeof errorCallback==='function'){errorCallback(result)}}})}};Signage.prototype.addEventListener=addSignageEventListener;Signage.prototype.removeEventListener=removeSignageEventListener;return Signage}())

/***/ }),
/* 7 */
/***/ (function(module, exports) {

Sound=(function(){var Sound,service;function log(msg){}
if(typeof window==='object'){cordova.define('cordova/plugin/sound',function(require,exports,module){Sound=function(){};var service;if(window.PalmSystem){log("Window.PalmSystem Available");service=require('cordova/plugin/webos/service')}else{service={Request:function(uri,params){log(uri+" invoked. But I am a dummy because PalmSystem is not available");if(typeof params.onFailure==='function'){params.onFailure({returnValue:!1,errorText:"PalmSystem Not Available. Cordova is not installed?"})}}}}
module.exports=Sound});Sound=cordova.require('cordova/plugin/sound')}
else{Sound=function(serviceInstance){service=serviceInstance;service.Request=function(serviceUri,reqParams){var commandURI=serviceUri+"/"+reqParams.method;var parameters={};if(reqParams.hasOwnProperty("parameters")===!0)
parameters=reqParams.parameters;var convertedRes={};var callback=function(res){console.log("res : "+JSON.stringify(res));if(res.payload.returnValue===!0){convertedRes=res.payload;reqParams.onSuccess(convertedRes)}else{convertedRes.returnValue=!1;convertedRes.errorCode=res.payload.errorCode;convertedRes.errorText=res.payload.errorText;reqParams.onFailure(convertedRes)}}
if(service){service.call(commandURI,parameters,callback)}}};module.exports=Sound}
function checkErrorCodeNText(result,errorCode,errorText){if(result.errorCode===undefined||result.errorCode===null){result.errorCode=errorCode}
if(result.errorText===undefined||result.errorText===null){result.errorText=errorText}}
var version=null;var platformInfoObj={};function checkPlatformVersion(cb){if(version===null){service.Request('luna://com.webos.service.tv.systemproperty',{method:'getSystemInfo',parameters:{keys:["sdkVersion","boardType"]},onSuccess:function(result){log("getPlatformInfo: onSuccess");log("version : "+result.sdkVersion);var temp=result.sdkVersion.split('.');if(temp.length>=1&&temp[0]==='1'){platformInfoObj={webOSVer:1,chipset:result.boardType.split("_")[0]}}else if(temp.length>=1&&temp[0]==='2'){platformInfoObj={webOSVer:2,chipset:result.boardType.split("_")[0]}}else if(temp.length>=1&&temp[0]==='3'){platformInfoObj={webOSVer:3,chipset:result.boardType.split("_")[0]}}else{platformInfoObj={webOSVer:0,chipset:""}}
version=platformInfoObj.webOSVer;cb(platformInfoObj)},onFailure:function(error){log("getPlatformInfo: onFailure");platformInfoObj={webOSVer:0,chipset:""}
cb(platformInfoObj)}})}else{cb(platformInfoObj)}}
Sound.SoundMode={Standard:"standard",Cinema:"movie",ClearVoice:"news",Sports:"sports",Music:"music",Game:"game"};Sound.SpeakerType={SignageSpeaker:"tv_speaker",LGSoundSync:"bt_soundbar"};Sound.prototype.getSoundStatus=function(successCallback,errorCallback){log("getSoundStatus: ");service.Request("luna://com.webos.service.commercial.signage.storageservice/",{method:"version",onSuccess:function(result){if(result.returnValue===!0){var scapVersion=result.version;var key="";if(scapVersion[0]==="1"&&scapVersion[2]==="5"){key="com.webos.surfacemanager.supportCommerSoundSetting"}else{key="tv.model.supportCommerSoundSetting"}
service.Request("luna://com.webos.service.config/",{method:"getConfigs",parameters:{configNames:[key]},onSuccess:function(result){log("getConfigs: On Success");if(result.returnValue===!0){var supportCommerSoundSetting=result.configs[key];if(supportCommerSoundSetting===!0){service.Request("luna://com.webos.audio/",{method:"getVolume",onSuccess:function(result){log("getSoundStatus: On Success");if(result.returnValue===!0){var cbObj={};cbObj.level=result.volume;cbObj.muted=result.muted;service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"get",parameters:{category:"commercial",keys:["enableSpeaker"]},onSuccess:function(result){log("getSoundStatus: On Success 2");if(result.returnValue===!0){cbObj.externalSpeaker=(result.settings.enableSpeaker==="on"?!0:!1);if(typeof successCallback==='function'){successCallback(cbObj)}}},onFailure:function(result){log("getSoundStatus: On Failure 2");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SGSS","Sound.getSoundStatus returns failure.");errorCallback(result)}}})}},onFailure:function(result){log("getSoundStatus: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SGSS","Sound.getSoundStatus returns failure.");errorCallback(result)}}})}else{delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SGSS","unsupported feature");errorCallback(result)}
return}
log("Sound.getSoundStatus Done")}},onFailure:function(result){log("getConfigs: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SGSS","Sound.getSoundStatus returns failure.");errorCallback(result)}}})}},onFailure:function(result){delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SGSS","Sound.getSoundStatus returns failure.");errorCallback(result)}}});log("Sound.getSoundStatus Done")};Sound.prototype.setVolumeLevel=function(successCallback,errorCallback,options){log("setVolumeLevel: "+JSON.stringify(options));if(typeof options.level!=='number'||isNaN(options.level)||options.level<0||options.level>100){if(typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"SSVL","Sound.setVolumeLevel returns failure. out of range or invalid parameter type.");errorCallback(result)}
return}
service.Request("luna://com.webos.service.commercial.signage.storageservice",{method:"version",onSuccess:function(result){if(result.returnValue===!0){var scapVersion=result.version;var key="";if(scapVersion[0]==="1"&&scapVersion[2]==="5"){key="com.webos.surfacemanager.supportCommerSoundSetting"}else{key="tv.model.supportCommerSoundSetting"}
service.Request("luna://com.webos.service.config",{method:"getConfigs",parameters:{configNames:[key]},onSuccess:function(result){log("getConfigs: On Success");if(result.returnValue===!0){var supportCommerSoundSetting=result.configs[key];if(supportCommerSoundSetting===!0){if(options.volOsdEnabled===!1){service.Request("luna://com.webos.service.config",{method:"setConfigs",parameters:{configs:{"com.webos.surfacemanager.volumeOSD":!1}},onSuccess:function(result){if(result.returnValue===!0){service.Request("luna://com.webos.audio",{method:"setVolume",parameters:{volume:options.level},onSuccess:function(result){log("setVolumeLevel: On Success");if(result.returnValue===!0){setTimeout(function(){service.Request("luna://com.webos.service.config",{method:"setConfigs",parameters:{configs:{"com.webos.surfacemanager.volumeOSD":!0}},onSuccess:function(result){if(result.returnValue===!0){if(typeof successCallback==='function'){successCallback()}}},onFailure:function(result){delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SSVL","Sound.setVolumeLevel returns failure.");errorCallback(result);return}}})},2000)}},onFailure:function(result){log("setVolumeLevel: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SSVL","Sound.setVolumeLevel returns failure.");errorCallback(result)}}})}},onFailure:function(result){delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SSVL","Sound.setVolumeLevel returns failure.");errorCallback(result);return}}})}else{service.Request("luna://com.webos.audio",{method:"setVolume",parameters:{volume:options.level},onSuccess:function(result){log("setVolumeLevel: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){successCallback()}}},onFailure:function(result){log("setVolumeLevel: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SSVL","Sound.setVolumeLevel returns failure.");errorCallback(result)}}})}}else{delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SSVL","unsupported feature");errorCallback(result)}
return}}},onFailure:function(result){log("getConfigs: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SSVL","Sound.setVolumeLevel returns failure");errorCallback(result)}}})}},onFailure:function(result){delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SSVL","Sound.setVolumeLevel returns failure.");errorCallback(result)}}});log("Sound.setVolumeLevel Done")};Sound.prototype.setExternalSpeaker=function(successCallback,errorCallback,options){log("setExternalSpeaker: "+JSON.stringify(options));if(typeof options.externalSpeaker!=='boolean'){if(typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"SSVL","Sound.setExternalSpeaker returns failure. out of range or invalid parameter type.");errorCallback(result)}
return}
var enable=null;switch(options.externalSpeaker){case!0:enable="on";break;case!1:enable="off";break}
service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"set",parameters:{category:"commercial",settings:{"enableSpeaker":enable}},onSuccess:function(){log("setExternalSpeaker: On Success");if(typeof successCallback==='function'){successCallback()}},onFailure:function(result){log("setExternalSpeaker: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SSES","Sound.setExternalSpeaker returns failure.");errorCallback(result)}}});log("Sound.setExternalSpeaker Done")};Sound.prototype.setMuted=function(successCallback,errorCallback,options){log("setMuted: "+JSON.stringify(options));if(typeof options.muted!=='boolean'){if(typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"SSM","Sound.setMuted returns failure. out of range or invalid parameter type.");errorCallback(result)}
return}
service.Request("luna://com.webos.service.commercial.signage.storageservice/",{method:"version",onSuccess:function(result){var scapVersion=result.version;var key="";if(scapVersion[0]==="1"&&scapVersion[2]==="5"){key="com.webos.surfacemanager.supportCommerSoundSetting"}else{key="tv.model.supportCommerSoundSetting"}
service.Request("luna://com.webos.service.config/",{method:"getConfigs",parameters:{configNames:[key]},onSuccess:function(result){log("getConfigs: On Success");if(result.returnValue===!0){var supportCommerSoundSetting=result.configs[key];if(supportCommerSoundSetting===!0){service.Request("luna://com.webos.audio/",{method:"setMuted",parameters:{muted:options.muted},onSuccess:function(result){log("setMuted: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){successCallback()}}},onFailure:function(result){log("setMuted: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SSM","Sound.setMuted returns failure.");errorCallback(result)}}})}else{delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SSM","unsupported feature");errorCallback(result)}
return}}},onFailure:function(result){log("getConfigs: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SSM","Sound.setMuted returns failure");errorCallback(result)}}})},onFailure:function(result){delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SSM","Sound.setMuted returns failure.");errorCallback(result)}}});log("Sound.setMuted Done")};Sound.prototype.setSoundMode=function(successCallback,errorCallback,options){var mode=null;switch(options.mode){case Sound.SoundMode.Standard:mode="standard";break;case Sound.SoundMode.Cinema:mode="movie";break;case Sound.SoundMode.ClearVoice:mode="news";break;case Sound.SoundMode.Sports:mode="sports";break;case Sound.SoundMode.Music:mode="music";break;case Sound.SoundMode.Game:mode="game";break}
if(((options.balance<-50)||(options.balance>50))&&isNumber(options.balance)){var result={};checkErrorCodeNText(result,"SSSM","Sound.setSoundMode returns failure. Out of range.");errorCallback(result);log("Sound.setSoundMode invalid range")}
log("setSoundMode: "+mode);if(mode===null&&typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"SSSM","Sound.setSoundMode returns failure. command was not defined.");errorCallback(result);log("Sound.setSoundMode invalid ");return}
service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"set",parameters:{category:"sound",settings:{"soundMode":mode,"audioBalance":options.balance}},onSuccess:function(result){log("setSoundMode: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){successCallback()}}},onFailure:function(result){log("setSoundMode: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SSSM","Sound.setSoundMode returns failure.");errorCallback(result)}}});log("Sound.setSoundMode Done")};Sound.prototype.getSoundMode=function(successCallback,errorCallback){log("getSoundMode: ");service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"get",parameters:{category:"sound",keys:["soundMode","audioBalance"]},onSuccess:function(result){log("getSoundMode: On Success");if(result.returnValue===!0){var cbObj={};cbObj.mode=result.settings.soundMode;cbObj.balance=result.settings.audioBalance;if(typeof successCallback==='function'){successCallback(cbObj)}}},onFailure:function(result){log("getSoundMode: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SGSM","Sound.getSoundMode returns failure.");errorCallback(result)}}});log("Sound.getSoundMode Done")};Sound.prototype.setSoundOut=function(successCallback,errorCallback,options){checkPlatformVersion(function(platformInfo){if(platformInfo.webOSVer!==3){var result={};checkErrorCodeNText(result,"SSSO","Sound.setSoundOut returns failure. Only webOS 3.0 support setSoundOut API.");errorCallback(result);log("not support setSoundOut");return}
service.Request("luna://com.webos.service.config/",{method:"getConfigs",parameters:{configNames:["system.supportBluetoothFeatures"]},onSuccess:function(result){log("getConfigs: On Success");if(result.returnValue===!0){var bluetoothFeatures=result.configs["system.supportBluetoothFeatures"];if(bluetoothFeatures.indexOf('btsound')===-1)
{if(options.speakerType===Sound.SpeakerType.LGSoundSync){var result={};checkErrorCodeNText(result,"SSSO","Sound.setSoundOut returns failure. bluetooth soundsync is not supported.");errorCallback(result);return}}
var speakerType=null;switch(options.speakerType){case Sound.SpeakerType.SignageSpeaker:speakerType="tv_speaker";break;case Sound.SpeakerType.LGSoundSync:speakerType="bt_soundbar";break}
log("setSoundOut: "+speakerType);if(speakerType===null&&typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"SSSO","Sound.setSoundOut returns failure. command was not defined.");errorCallback(result);log("Sound.setSoundOut invalid ");return}
service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"set",parameters:{category:"sound",settings:{"soundOutput":speakerType}},onSuccess:function(result){log("setSoundOut: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){successCallback()}}},onFailure:function(result){log("setSoundOut: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SSSO","Sound.setSoundOut returns failure.");errorCallback(result)}}});log("Sound.setSoundOut Done")}},onFailure:function(result){log("getConfigs: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SSSO","unsupported feature");errorCallback(result)}}})})};Sound.prototype.getSoundOut=function(successCallback,errorCallback){checkPlatformVersion(function(platformInfo){if(platformInfo.webOSVer!==3){var result={};checkErrorCodeNText(result,"SGSO","Sound.getSoundOut returns failure. Only webOS 3.0 support getSoundOut API.");errorCallback(result);log("not support getSoundOut");return}
log("getSoundOut: ");service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"get",parameters:{category:"sound",keys:["soundOutput"]},onSuccess:function(result){log("getSoundOut: On Success");if(result.returnValue===!0){var cbObj={};cbObj.speakerType=result.settings.soundOutput;if(typeof successCallback==='function'){successCallback(cbObj)}}},onFailure:function(result){log("getSoundOut: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SGSO","Sound.getSoundOut returns failure.");errorCallback(result)}}});log("Sound.getSoundOut Done")})};return Sound}())

/***/ }),
/* 8 */
/***/ (function(module, exports) {

Storage=(function(){var Storage,service;function log(msg){}
if(typeof window==='object'){cordova.define('cordova/plugin/storage',function(require,exports,module){Storage=function(){};if(window.PalmSystem){log("Window.PalmSystem Available");service=require('cordova/plugin/webos/service')}else{service={Request:function(uri,params){log(uri+" invoked. But I am a dummy because PalmSystem is not available");if(typeof params.onFailure==='function'){params.onFailure({returnValue:!1,errorText:"PalmSystem Not Available. Cordova is not installed?"})}}}}
module.exports=Storage});Storage=cordova.require('cordova/plugin/storage')}
else{Storage=function(serviceInstance){service=serviceInstance;service.Request=function(serviceUri,reqParams){var commandURI=serviceUri+"/"+reqParams.method;var parameters={};if(reqParams.hasOwnProperty("parameters")===!0)
parameters=reqParams.parameters;var convertedRes={};var callback=function(res){console.log("res : "+JSON.stringify(res));if(res.payload.returnValue===!0){convertedRes=res.payload;reqParams.onSuccess(convertedRes)}else{convertedRes.returnValue=!1;convertedRes.errorCode=res.payload.errorCode;convertedRes.errorText=res.payload.errorText;reqParams.onFailure(convertedRes)}}
if(service){service.call(commandURI,parameters,callback)}}};module.exports=Storage}
function checkErrorCodeNText(result,errorCode,errorText){if(result.errorCode===undefined||result.errorCode===null){result.errorCode=errorCode}
if(result.errorText===undefined||result.errorText===null){result.errorText=errorText}}
function isValidFileURI(uri){if(uri){if(uri.indexOf("://")===-1){log("INVALID URI"+uri);return!1}else{log("GOOD URI");return!0}}else{log("NO URI"+uri);return!1}}
Error.ERROR_CODE={IO_ERROR:"IO_ERROR",DEVICE_ERROR:"DEVICE_ERROR",BAD_PARAMETER:"BAD_PARAMETER",SERVER_ERROR:"SERVER_ERROR",NETWORK_ERROR:"NETWORK_ERROR",SYSTEM_ERROR:"SYSTEM_ERROR",};Storage.SCAP_URI="";Storage.MAX_BUFFER_LENGTH=1024*10;Storage.AppMode={USB:"usb",LOCAL:"local"};Storage.AppType={IPK:"ipk",ZIP:"zip"};Storage.prototype.downloadFirmware=function(successCallback,errorCallback,options){service.Request("luna://com.webos.service.commercial.signage.storageservice",{method:"downloadFirmware",parameters:{uri:options.uri},onSuccess:function(result){if(result.returnValue===!0){successCallback()}else{errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})};Storage.prototype.upgradeFirmware=function(successCallback,errorCallback){service.Request("luna://com.webos.service.commercial.signage.storageservice",{method:"upgradeFirmware",parameters:{},onSuccess:function(result){if(result.returnValue===!0){successCallback()}else{errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})};Storage.prototype.getFirmwareUpgradeStatus=function(successCallback,errorCallback){service.Request("luna://com.webos.service.commercial.signage.storageservice",{method:"getFirmwareUpgradeStatus",parameters:{},onSuccess:function(result){if(result.returnValue===!0){successCallback({status:result.status,upgradeProgress:result.upgradeProgress,downloadProgress:result.downloadProgress})}else{errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})};Storage.prototype.changeLogoImage=function(successCallback,errorCallback,options){service.Request("luna://com.webos.service.commercial.signage.storageservice",{method:"changeLogoImage",parameters:{uri:options.uri},onSuccess:function(result){if(result.returnValue===!0){successCallback()}else{errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})};Storage.prototype.upgradeApplication=function(successCallback,errorCallback,options){var param={from:'remote',to:(options===undefined||options===null?Storage.AppMode.LOCAL:options.to),recovery:(options===undefined||options===null?!1:options.recovery),};if(options.hasOwnProperty('type')===!0&&options.type!==undefined)
param.type=options.type;service.Request("luna://com.webos.service.commercial.signage.storageservice",{method:"upgradeApplication",parameters:param,onSuccess:function(result){if(result.returnValue===!0){successCallback()}else{errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})};Storage.prototype.removeApplication=function(successCallback,errorCallback,options){service.Request("luna://com.webos.service.commercial.signage.storageservice",{method:"removeApplication",parameters:{to:options.to},onSuccess:function(result){if(result.returnValue===!0){successCallback()}else{errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})};Storage.prototype.copyFile=function(successCallback,errorCallback,options){log("Options: "+JSON.stringify(options,null,3));if(options.maxRedirection&&options.maxRedirection>5){log("Bad options TOO MANY REDIRECTION");errorCallback({errorCode:"BAD_PARAMETER",errorText:"Redirect cannot be more that 5"});return}
if(options.headers&&JSON.stringify(options.headers).length>1024){log("header too long header too long");errorCallback({errorCode:"BAD_PARAMETER",errorText:"Header data cannot be bigger than 1K"});return}
if(typeof options.httpOption==='undefined'){options.httpOption={}}
if(options.httpOption.headers&&JSON.stringify(options.httpOption.headers).length>1024){log("header too long header too long");errorCallback({errorCode:"BAD_PARAMETER",errorText:"Header data cannot be bigger than 1K"});return}
if(options.maxRedirection||options.headers){if(options.maxRedirection&&typeof options.httpOption.maxRedirection==='undefined'){options.httpOption.maxRedirection=options.maxRedirection}
if(options.headers&&typeof options.httpOption.headers==='undefined'){options.httpOption.headers=options.headers}}
if(typeof options.httpOption.maxRedirection!=='undefined'){if(typeof options.maxRedirection!=='undefined'){if(options.httpOption.maxRedirection!==options.maxRedirection){errorCallback({errorCode:"BAD_PARAMETER",errorText:"Both options.httpOption.maxRedirection and options.maxRedirection are exists,"+"but different value. What value you want to use?"});return}}else options.maxRedirection=options.httpOption.maxRedirection}
log(options);service.Request("luna://com.webos.service.commercial.signage.storageservice",{method:"fs/copyFile",parameters:{dest:options.destination,src:options.source,ftpOption:options.ftpOption,httpOption:options.httpOption},onSuccess:function(result){if(result.returnValue===!0){log("SUCCESS");successCallback()}else{log("Err: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){log("Err: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})};Storage.prototype.removeFile=function(successCallback,errorCallback,options){if(!(options&&isValidFileURI(options.file))){errorCallback({errorCode:"BAD_PARAMETER",errorText:"options.file is a mandatory parameter"});return}
var param={file:options.file};if(options.recursive===!0){param.recursive=!0}
service.Request("luna://com.webos.service.commercial.signage.storageservice",{method:"fs/removeFile",parameters:param,onSuccess:function(result){log("onSuccess");if(result.returnValue===!0){successCallback()}else{errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){log("onFailure");errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})};Storage.prototype.listFiles=function(successCallback,errorCallback,options){var param={};if(options&&options.path){if(isValidFileURI(options.path)){param.pathURI=options.path}else{errorCallback({errorCode:"BAD_PARAMETER",errorText:"File URI is not valid."});return}}else{param.pathURI="file://internal/"}
service.Request("luna://com.webos.service.commercial.signage.storageservice",{method:"fs/listFiles",parameters:param,onSuccess:function(result){if(result.returnValue===!0){var files=[];for(var i=0;i<result.files.length;++i){log(result.files[i]);var fileinfo={name:result.files[i].name,type:(result.files[i].type==='folder')?'folder':'file',size:result.files[i].size};files.push(fileinfo)}
var cbObj={files:files,totalCount:result.totalCount};successCallback(cbObj)}else{errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})};Storage.prototype.getStorageInfo=function(successCallback,errorCallback){service.Request("luna://com.webos.service.commercial.signage.storageservice",{method:"fs/storageInfo",parameters:{},onSuccess:function(result){log("returned : "+JSON.stringify(result,null,3));if(result.returnValue===!0){log("returned : "+JSON.stringify(result,null,3));var cbObj={free:result.spaceInfo.freeSize,total:result.spaceInfo.totalSize,used:result.spaceInfo.usedSize,externalMemory:result.externalStorage};successCallback(cbObj)}else{errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})};Storage.prototype.mkdir=function(successCallback,errorCallback,options){if(!(options&&isValidFileURI(options.path))){errorCallback({errorCode:"BAD_PARAMETER",errorText:"options.path is a mandatory parameter"});return}
var param={pathURI:options.path};service.Request("luna://com.webos.service.commercial.signage.storageservice",{method:"fs/mkdir",parameters:param,onSuccess:function(result){log("onSuccess");if(result.returnValue===!0){successCallback()}else{errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){log("onFailure");errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})};Storage.prototype.exists=function(successCallback,errorCallback,options){if(!(options&&isValidFileURI(options.path))){log("BAD_PARAMETER");errorCallback({errorCode:"BAD_PARAMETER",errorText:"options.path is a mandatory parameter"});return}
var param={pathURI:options.path};service.Request("luna://com.webos.service.commercial.signage.storageservice",{method:"fs/exists",parameters:param,onSuccess:function(result){log("onSuccess");if(result.returnValue===!0){log("returned : "+JSON.stringify(result,null,3));var cbObj={exists:result.exists};successCallback(cbObj)}else{errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){log("onFailure");errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})};Storage.prototype.readFile=function(successCallback,errorCallback,options){if(!options){errorCallback({errorCode:"BAD_PARAMETER",errorText:"options.path is a mandatory parameter"})}else if(!isValidFileURI(options.path)){errorCallback({errorCode:"BAD_PARAMETER",errorText:"options.path is a mandatory parameter"})}else if(options.length&&(options.length>Storage.MAX_BUFFER_LENGTH||options.length<1)){errorCallback({errorCode:"BAD_PARAMETER",errorText:"length should be > 0 and < "+Storage.MAX_BUFFER_LENGTH})}else if(options.position&&(options.position<0)){errorCallback({errorCode:"BAD_PARAMETER",errorText:"position should be > 0"})}else{var params={};params.path=options.path;params.length=options.length?options.length:Storage.MAX_BUFFER_LENGTH;params.position=options.position?options.position:0;params.encoding=options.encoding?options.encoding:'utf-8';service.Request("luna://com.webos.service.commercial.signage.storageservice",{method:"fs/readFile",parameters:params,onSuccess:function(result){if(result.returnValue){if(params.encoding==='binary'){var byteArray=result.data;var arrayView=new Uint8Array(byteArray.length);for(var i=0;i<byteArray.length;++i){arrayView[i]=byteArray[i]}
successCallback({data:arrayView.buffer})}else{successCallback({data:result.data})}}else{errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})}};Storage.prototype.writeFile=function(successCallback,errorCallback,options){if(!options){errorCallback({errorCode:"BAD_PARAMETER",errorText:"options.path is a mandatory parameter"})}else if(!isValidFileURI(options.path)){errorCallback({errorCode:"BAD_PARAMETER",errorText:"options.path is a is not valid"})}else if(!options.data){errorCallback({errorCode:"BAD_PARAMETER",errorText:"options.data is a mandatory parameter"})}else if(options.mode&&(options.mode!=='truncate'&&options.mode!=='append'&&options.mode!=='position')){errorCallback({errorCode:"BAD_PARAMETER",errorText:"mode should be 'truncate'|'append'|'position'"})}else if(options.position&&(options.position<0)){errorCallback({errorCode:"BAD_PARAMETER",errorText:"position should be > 0"})}else if(options.offset&&(options.offset<0)){errorCallback({errorCode:"BAD_PARAMETER",errorText:"offset should be > 0"})}else if(options.length&&(options.length>Storage.MAX_BUFFER_LENGTH||options.length<1)){errorCallback({errorCode:"BAD_PARAMETER",errorText:"length should be > 0 and < "+Storage.MAX_BUFFER_LENGTH})}else if(options.encoding&&(options.encoding!=='utf8'&&options.encoding!=='binary'&&options.encoding!=='base64')){errorCallback({errorCode:"BAD_PARAMETER",errorText:"Invalid encoding: "+options.encoding})}else{log("REQUEST");var params={};params.path=options.path;params.mode=options.mode?options.mode:'truncate';params.position=options.position?options.position:0;params.encoding=options.encoding?options.encoding:'utf8';var offset=options.offset?options.offset:0;if(params.encoding==='binary'){log("binary, size is: "+options.data.byteLength);var uint8View=new Uint8Array(options.data);log("uint8View: "+uint8View);var maxLength=options.length?options.length:Storage.MAX_BUFFER_LENGTH;var array=[];var count=0;for(var i=offset;i<uint8View.length&&count<maxLength;++i,count++){array[count]=uint8View[i]}
log("array length: "+count);params.data=array;params.length=count;params.offset=0}
else if(params.encoding==='base64'){var maxLength2=options.length?options.length:Storage.MAX_BUFFER_LENGTH;log("base64, size is: "+options.data.length);var base64Str=options.data;var decodedRaw=window.atob(base64Str);var decoded=decodedRaw.substring(offset,offset+maxLength2);var arrayView=new Uint8Array(decoded.length);var j;for(j=0;j<decoded.length;j++){arrayView[j]=decoded.charCodeAt(j)}
var array2=[];for(j=0;j<arrayView.length;++j){array2[j]=arrayView[j]}
params.data=array2;params.length=array2.length;params.offset=0}
else{var maxLength3=options.length?options.length:Storage.MAX_BUFFER_LENGTH;params.data=options.data.substring(offset,offset+maxLength3);params.length=params.data.length;params.offset=0}
try{service.Request("luna://com.webos.service.commercial.signage.storageservice",{method:"fs/writeFile",parameters:params,onSuccess:function(result){log("onSuccess");if(result.returnValue){successCallback({written:result.written})}else{log("FAILED: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){log("onFailure");log("FAILED: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})}catch(err){log("EXCEPTION"+err);errorCallback({errorCode:'STWF',errorText:'Storage.writeFile() error is occured during operation.'})}}};Storage.prototype.statFile=function(successCallback,errorCallback,options){if(!(options&&isValidFileURI(options.path))){errorCallback({errorCode:"BAD_PARAMETER",errorText:"options.path is a mandatory parameter"})}else if(!options.path){errorCallback({errorCode:"BAD_PARAMETER",errorText:"options.path is a mandatory parameter"})}else{try{service.Request("luna://com.webos.service.commercial.signage.storageservice",{method:"fs/statFile",parameters:{path:options.path},onSuccess:function(result){log("onSuccess");if(result.returnValue){successCallback(result.stat)}else{log("FAILED: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){log("onFailure");log("FAILED: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})}catch(err){log("EXCEPTION"+err);errorCallback({errorCode:'STSF',errorText:'Storage.statFile() error is occured during operation.'})}}};Storage.prototype.removeAll=function(successCallback,errorCallback,options){if(!options){errorCallback({errorCode:"BAD_PARAMETER",errorText:"options.device is a mandatory parameter"})}else if(!options.device){errorCallback({errorCode:"BAD_PARAMETER",errorText:"options.device is a mandatory parameter"})}else{try{service.Request("luna://com.webos.service.commercial.signage.storageservice",{method:"fs/removeAll",parameters:{device:options.device},onSuccess:function(result){log("onSuccess");if(result.returnValue){successCallback()}else{log("FAILED: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){log("onFailure");log("FAILED: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})}catch(err){log("EXCEPTION"+err);errorCallback({errorCode:'STRA',errorText:'Storage.removeAll() error is occured during operation.'})}}};Storage.prototype.fsync=function(successCallback,errorCallback,options){try{var params={};if(options&&options.path){if(isValidFileURI(options.path)){params.path=options.path}else{errorCallback({errorCode:"BAD_PARAMETER",errorText:"Invalid File URI"});return}}
service.Request("luna://com.webos.service.commercial.signage.storageservice",{method:"fs/fsyncFile",parameters:params,onSuccess:function(result){log("onSuccess");if(result.returnValue){successCallback()}else{log("FAILED: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){log("onFailure");log("FAILED: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})}catch(err){log("EXCEPTION"+err);errorCallback({errorCode:'STFS',errorText:'Storage.fsync() error is occured during operation.'})}};Storage.prototype.moveFile=function(successCallback,errorCallback,options){if(!options){errorCallback({errorCode:"BAD_PARAMETER",errorText:"options.path is a mandatory parameter"})}else if(!isValidFileURI(options.oldPath)){errorCallback({errorCode:"BAD_PARAMETER",errorText:"options.oldpath is a mandatory parameter"})}else if(!isValidFileURI(options.newPath)){errorCallback({errorCode:"BAD_PARAMETER",errorText:"options.newPath is a mandatory parameter"})}else{try{service.Request("luna://com.webos.service.commercial.signage.storageservice",{method:"fs/moveFile",parameters:{oldPath:options.oldPath,newPath:options.newPath},onSuccess:function(result){log("onSuccess");if(result.returnValue){successCallback()}else{log("FAILED: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){log("onFailur");log("FAILED: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})}catch(err){log("EXCEPTION"+err);errorCallback({errorCode:'STMF',errorText:'Storage.moveFile() error is occured during operation.'})}}};Storage.prototype.unzipFile=function(successCallback,errorCallback,options){if(!options){errorCallback({errorCode:"BAD_PARAMETER",errorText:"options.path is a mandatory parameter"})}else if(!isValidFileURI(options.zipPath)){errorCallback({errorCode:"BAD_PARAMETER",errorText:"options.zipPath is a mandatory parameter"})}else if(!isValidFileURI(options.targetPath)){errorCallback({errorCode:"BAD_PARAMETER",errorText:"options.targetPath is a mandatory parameter"})}else{try{service.Request("luna://com.webos.service.commercial.signage.storageservice",{method:"fs/unzip",parameters:{zipPath:options.zipPath,targetPath:options.targetPath},onSuccess:function(result){log("onSuccess");if(result.returnValue){successCallback()}else{log("FAILED: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){log("onFailure");log("FAILED: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})}catch(err){log("EXCEPTION"+err);errorCallback({errorCode:'STUF',errorText:'Storage.unzipFile() error is occured during operation.'})}}};Storage.prototype.getMD5Hash=function(successCallback,errorCallback,options){log("getMD5Hash: ");if(!(options&&isValidFileURI(options.filePath))){errorCallback({errorCode:"BAD_PARAMETER",errorText:"options.filePath is a mandatory parameter"});return}
service.Request('luna://com.webos.service.commercial.signage.storageservice',{method:'fs/getMD5Hash',parameters:{filePath:options.filePath},onSuccess:function(result){if(typeof successCallback==='function'){delete result.returnValue;successCallback(result)}},onFailure:function(error){log("getMD5Hash: onFailure");delete error.returnValue;if(typeof errorCallback==='function'){errorCallback(error)}}});log("Storage.getMD5Hash Done")};Storage.prototype.decryptFile=function(successCallback,errorCallback,options){log("decryptFile: ");service.Request('luna://com.webos.service.commercial.signage.storageservice',{method:'fs/decryptFile',parameters:{cipher_mode:options.cipher_mode,password:options.password,inputPath:options.inputPath,outputFileName:options.outputFileName},onSuccess:function(result){if(typeof successCallback==='function'){delete result.returnValue;successCallback(result)}},onFailure:function(error){log("decryptFile: onFailure");delete error.returnValue;if(typeof errorCallback==='function'){errorCallback(error)}}});log("Storage.decryptFile Done")};return Storage}())

/***/ }),
/* 9 */
/***/ (function(module, exports) {

Time=(function(){var Time,service;function log(msg){}
if(typeof window==='object'){cordova.define('cordova/plugin/time',function(require,exports,module){Time=function(){};var service;if(window.PalmSystem){log("Window.PalmSystem Available");service=require('cordova/plugin/webos/service')}else{service={Request:function(uri,params){log(uri+" invoked. But I am a dummy because PalmSystem is not available");if(typeof params.onFailure==='function'){params.onFailure({returnValue:!1,errorText:"PalmSystem Not Available. Cordova is not installed?"})}}}}
module.exports=Time});Time=cordova.require('cordova/plugin/time')}
else{Time=function(serviceInstance){service=serviceInstance;service.Request=function(serviceUri,reqParams){var commandURI=serviceUri+"/"+reqParams.method;var parameters={};if(reqParams.hasOwnProperty("parameters")===!0)
parameters=reqParams.parameters;var convertedRes={};var callback=function(res){console.log("res : "+JSON.stringify(res));if(res.payload.returnValue===!0){convertedRes=res.payload;reqParams.onSuccess(convertedRes)}else{convertedRes.returnValue=!1;convertedRes.errorCode=res.payload.errorCode;convertedRes.errorText=res.payload.errorText;reqParams.onFailure(convertedRes)}}
if(service){service.call(commandURI,parameters,callback)}}};module.exports=Time}
function checkErrorCodeNText(result,errorCode,errorText){if(result.errorCode===undefined||result.errorCode===null){result.errorCode=errorCode}
if(result.errorText===undefined||result.errorText===null){result.errorText=errorText}}
var version=null;var platformInfoObj={};function checkPlatformVersion(cb){if(version===null){service.Request('luna://com.webos.service.tv.systemproperty',{method:'getSystemInfo',parameters:{keys:["sdkVersion","boardType"]},onSuccess:function(result){log("getPlatformInfo: onSuccess");log("version : "+result.sdkVersion);var temp=result.sdkVersion.split('.');if(temp.length>=1&&temp[0]==='1'){platformInfoObj={webOSVer:1,chipset:result.boardType.split("_")[0]}}else if(temp.length>=1&&temp[0]==='2'){platformInfoObj={webOSVer:2,chipset:result.boardType.split("_")[0]}}else if(temp.length>=1&&temp[0]==='3'){platformInfoObj={webOSVer:3,chipset:result.boardType.split("_")[0]}}else{platformInfoObj={webOSVer:0,chipset:""}}
version=platformInfoObj.webOSVer;cb(platformInfoObj)},onFailure:function(error){log("getPlatformInfo: onFailure");platformInfoObj={webOSVer:0,chipset:""}
cb(platformInfoObj)}})}else{cb(platformInfoObj)}}
Time.prototype.setHolidayScheduleMode=function(successCallback,errorCallback,options){log("setHolidayScheduleMode: "+options.enabled);var ret={};checkErrorCodeNText(ret,"ERROR","This function is not supported");errorCallback(ret);return;if(options.enabled===null&&typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"TSHM","Time.setHolidayScheduleMode returns failure. command was not defined.");errorCallback(result);log("Time.setHolidayScheduleMode invalid ");return}
service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"set",parameters:{category:"commercial",settings:{"holidayScheduleMode":(options.enabled===!0)?"on":"off"}},onSuccess:function(result){log("setHolidayScheduleMode: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){successCallback()}}},onFailure:function(result){log("setHolidayScheduleMode: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"TSHM","Time.setHolidayScheduleMode returns failure.");errorCallback(result)}}});log("Time.setHolidayScheduleMode Done")};Time.prototype.getHolidayScheduleMode=function(successCallback,errorCallback){log("getHolidayScheduleMode: ");var ret={};checkErrorCodeNText(ret,"ERROR","This function is not supported");errorCallback(ret);return;service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"get",parameters:{category:"commercial",keys:["holidayScheduleMode"]},onSuccess:function(result){log("getHolidayScheduleMode: On Success");if(result.returnValue===!0){var cbObj={};cbObj.enabled=(result.settings.holidayScheduleMode==="on")?!0:!1;if(typeof successCallback==='function'){successCallback(cbObj)}}},onFailure:function(result){log("getHolidayScheduleMode: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"TGHM","Time.getHolidayScheduleMode returns failure.");errorCallback(result)}}});log("Time.getHolidayScheduleMode Done")};Time.prototype.addHolidaySchedule=function(successCallback,errorCallback,options){log("addHolidaySchedule: "+"startMonth : "+options.startMonth+", startDay : "+options.startDay+", endMonth : "+options.endMonth+", endDay : "+options.endDay);var ret={};checkErrorCodeNText(ret,"ERROR","This function is not supported");errorCallback(ret);return;var startSch=new Date((new Date()).getFullYear(),options.startMonth-1,options.startDay,0,0);var endSch=new Date((new Date()).getFullYear(),options.endMonth-1,options.endDay,0,0);if(typeof errorCallback==='function'){if(typeof options.startMonth!=='number'||typeof options.startDay!=='number'||isNaN(options.startMonth)||isNaN(options.startDay)||typeof options.endMonth!=='number'||typeof options.endDay!=='number'||isNaN(options.endMonth)||isNaN(options.endDay)){var result={};checkErrorCodeNText(result,"TAHS","Time.addHolidaySchedule returns failure. parmas are not valid.");errorCallback(result);return}
if(startSch.getMonth()!==options.startMonth-1||startSch.getDate()!==options.startDay||endSch.getMonth()!==options.endMonth-1||endSch.getDate()!==options.endDay){var result={};checkErrorCodeNText(result,"TAHS","Time.addHolidaySchedule returns failure for out of range.");errorCallback(result);return}
if(startSch.getTime()>endSch.getTime())
{var result={};checkErrorCodeNText(result,"TAHS","Time.addHolidaySchedule returns failure. schedule is not valid.");errorCallback(result);return}}
service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"get",parameters:{category:"commercial",keys:["holidaySchedule"]},onSuccess:function(result){log("getHolidaySchedule: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){var schedule={};var savedStartSch=null
var savedEndSch=null
var scheduleList=result.settings.holidaySchedule;if(scheduleList.length>=7)
{var result={};checkErrorCodeNText(result,"TAHS","Time.addHolidaySchedule returns failure. schedule list is full");errorCallback(result);return}
for(var i=0;i<scheduleList.length;i++){savedStartSch=new Date((new Date()).getFullYear(),scheduleList[i].startMonth-1,scheduleList[i].startDay,0,0);savedEndSch=new Date((new Date()).getFullYear(),scheduleList[i].endMonth-1,scheduleList[i].endDay,0,0);if(((savedStartSch.getTime()<=startSch.getTime())&&(savedEndSch.getTime()>startSch.getTime()))||((savedStartSch.getTime()<endSch.getTime())&&(savedEndSch.getTime()>=endSch.getTime()))||((savedStartSch.getTime()===startSch.getTime())&&(savedEndSch.getTime()===endSch.getTime()))||((startSch.getTime()===endSch.getTime())&&(savedEndSch.getTime()===startSch.getTime()))){var result={};checkErrorCodeNText(result,"TAHS","Time.addHolidaySchedule returns failure. schedule is not valid");errorCallback(result);return}}
schedule.startMonth=options.startMonth;schedule.startDay=options.startDay;schedule.endMonth=options.endMonth;schedule.endDay=options.endDay;scheduleList.push(schedule);log("scheduleList : "+JSON.stringify(scheduleList));service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"set",parameters:{category:"commercial",settings:{"holidaySchedule":scheduleList}},onSuccess:function(result){log("addHolidaySchedule: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){successCallback()}}},onFailure:function(result){log("addHolidaySchedule: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"TAHS","Time.addHolidaySchedule returns failure.");errorCallback(result)}}})}}},onFailure:function(result){log("addHolidaySchedule: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"TAHS","Time.addHolidaySchedule returns failure.");errorCallback(result)}}});log("Time.addHolidaySchedule Done")};Time.prototype.delHolidaySchedule=function(successCallback,errorCallback,options){log("delHolidaySchedule: "+"id : "+options.scheduleId);var ret={};checkErrorCodeNText(ret,"ERROR","This function is not supported");errorCallback(ret);return;if((typeof options.scheduleId!=='string'||options.scheduleId===undefined||options.scheduleId===null)&&typeof errorCallback==='function')
{var result={};checkErrorCodeNText(result,"TDHS","Time.delHolidaySchedule returns failure. scheduleId is not valid.");errorCallback(result);log("Time.delHolidaySchedule invalid ");return}
service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"get",parameters:{category:"commercial",keys:["holidaySchedule"]},onSuccess:function(result){log("getHolidaySchedule: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){var scheduleList=null;var tempList=[];var flag=!1;scheduleList=result.settings.holidaySchedule;log("before scheduleList : "+JSON.stringify(scheduleList));for(var i=0;i<scheduleList.length;i++){if(scheduleList[i]._id===options.scheduleId){flag=!0}else{tempList.push(scheduleList[i])}}
if(flag===!1&&typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"TDHS","Time.delHolidaySchedule returns failure. can not find schedule id.");errorCallback(result);log("Time.delHolidaySchedule invalid ");return}
log("after scheduleList : "+JSON.stringify(tempList));service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"set",parameters:{category:"commercial",settings:{"holidaySchedule":tempList}},onSuccess:function(result){log("delHolidaySchedule: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){successCallback()}}},onFailure:function(result){log("delHolidaySchedule: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"TDHS","Time.delHolidaySchedule returns failure.");errorCallback(result)}}})}}},onFailure:function(result){log("delHolidaySchedule: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"TDHS","Time.delHolidaySchedule returns failure.");errorCallback(result)}}});log("Time.delHolidaySchedule Done")};Time.prototype.delAllHolidaySchedules=function(successCallback,errorCallback){log("delAllHolidaySchedules: ");var ret={};checkErrorCodeNText(ret,"ERROR","This function is not supported");errorCallback(ret);return;service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"set",parameters:{category:"commercial",settings:{"holidaySchedule":[]}},onSuccess:function(result){log("delAllHolidaySchedules: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){successCallback()}}},onFailure:function(result){log("delAllHolidaySchedules: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"TDAS","Time.delAllHolidaySchedules returns failure.");errorCallback(result)}}});log("Time.delAllHolidaySchedules Done")};Time.prototype.getAllHolidaySchedules=function(successCallback,errorCallback){log("getAllHolidaySchedules: ");var ret={};checkErrorCodeNText(ret,"ERROR","This function is not supported");errorCallback(ret);return;service.Request("luna://com.webos.service.commercial.signage.storageservice/settings/",{method:"get",parameters:{category:"commercial",keys:["holidaySchedule"]},onSuccess:function(result){log("getHolidaySchedule: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){var cbObj={};cbObj.holidayScheduleList=result.settings.holidaySchedule;if(typeof successCallback==='function'){successCallback(cbObj)}}}},onFailure:function(result){log("getAllHolidaySchedules: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"TGAS","Time.getAllHolidaySchedules returns failure.");errorCallback(result)}}});log("Time.getAllHolidaySchedules Done")};Time.prototype.getHolidaySchedule=function(successCallback,errorCallback){log("getHolidaySchedule: ");service.Request("luna://com.webos.service.commercial.signage.storageservice/",{method:"getHolidaySchedule",parameters:{},onSuccess:function(result){log("getHolidaySchedule: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){var cbObj={};cbObj.holidayScheduleList=result.settings.holidaySchedule;if(typeof successCallback==='function'){successCallback(cbObj)}}}},onFailure:function(result){log("getHolidaySchedule: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"TGAS","Time.getHolidaySchedule returns failure.");errorCallback(result)}}});log("Time.getHolidaySchedule Done")};Time.prototype.setHolidaySchedule=function(successCallback,errorCallback,params){log("setHolidaySchedule: ");service.Request("luna://com.webos.service.commercial.signage.storageservice/",{method:"setHolidaySchedule",parameters:params,onSuccess:function(result){log("setHolidaySchedule: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){if(typeof successCallback==='function'){successCallback()}}}},onFailure:function(result){log("setHolidaySchedule: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"TGAS","Time.setHolidaySchedule returns failure.");errorCallback(result)}}});log("Time.setHolidaySchedule Done")};Time.prototype.unsetHolidaySchedule=function(successCallback,errorCallback){log("unsetHolidaySchedule: ");service.Request("luna://com.webos.service.commercial.signage.storageservice/",{method:"unsetHolidaySchedule",parameters:{},onSuccess:function(result){log("unsetHolidaySchedule: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){if(typeof successCallback==='function'){successCallback()}}}},onFailure:function(result){log("unsetHolidaySchedule: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"TGAS","Time.unsetHolidaySchedule returns failure.");errorCallback(result)}}});log("Time.unsetHolidaySchedule Done")};return Time}())

/***/ }),
/* 10 */
/***/ (function(module, exports) {

Utility=(function(){var Utility,service;function log(msg){}
if(typeof window==='object'){cordova.define('cordova/plugin/utility',function(require,exports,module){Utility=function(){};if(window.PalmSystem){log("Window.PalmSystem Available");service=require('cordova/plugin/webos/service')}else{service={Request:function(uri,params){log(uri+" invoked. But I am a dummy because PalmSystem is not available");if(typeof params.onFailure==='function'){params.onFailure({returnValue:!1,errorText:"PalmSystem Not Available. Cordova is not installed?"})}}}}
module.exports=Utility});Utility=cordova.require('cordova/plugin/utility')}
else{Utility=function(serviceInstance){service=serviceInstance;service.Request=function(serviceUri,reqParams){var commandURI=serviceUri+"/"+reqParams.method;var parameters={};if(reqParams.hasOwnProperty("parameters")===!0)
parameters=reqParams.parameters;var convertedRes={};var callback=function(res){console.log("res : "+JSON.stringify(res));if(res.payload.returnValue===!0){convertedRes=res.payload;reqParams.onSuccess(convertedRes)}else{convertedRes.returnValue=!1;convertedRes.errorCode=res.payload.errorCode;convertedRes.errorText=res.payload.errorText;reqParams.onFailure(convertedRes)}}
if(service){service.call(commandURI,parameters,callback)}}};module.exports=Utility}
function checkErrorCodeNText(result,errorCode,errorText){if(result.errorCode===undefined||result.errorCode===null){result.errorCode=errorCode}
if(result.errorText===undefined||result.errorText===null){result.errorText=errorText}}
Utility.prototype.createToast=function(successCallback,errorCallback,options){log("createToast: "+options.msg);if(options.msg===null&&typeof errorCallback==='function'){var result={};checkErrorCodeNText(result,"UTCT","Utility.createToast returns failure. command was not defined.");errorCallback(result);log("Utility.createToast invalid ");return}
service.Request("luna://com.webos.service.commercial.signage.storageservice/",{method:"createToast",parameters:{text:options.msg},onSuccess:function(result){log("createToast: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){log("call successCallback");successCallback()}}},onFailure:function(result){log("createToast: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"UTCT","Utility.createToast returns failure.");1
errorCallback(result)}}});log("Utility.createToast Done")};return Utility}())

/***/ }),
/* 11 */
/***/ (function(module, exports) {

Configuration=(function(){var e,a;function d(f){}if(typeof window==="object"){cordova.define("cordova/plugin/configuration",function(g,f,h){e=function(){};if(window.PalmSystem){d("Window.PalmSystem Available");a=g("cordova/plugin/webos/service")}else{a={Request:function(i,j){d(i+" invoked. But I am a dummy because PalmSystem is not available");if(typeof j.onFailure==="function"){j.onFailure({returnValue:false,errorText:"PalmSystem Not Available. Cordova is not installed?"})}}}}h.exports=e});e=cordova.require("cordova/plugin/configuration")}else{e=function(f){a=f;a.Request=function(g,i){var h=g+"/"+i.method;var j={};if(i.hasOwnProperty("parameters")===true){j=i.parameters}var k={};var l=function(m){console.log("res : "+JSON.stringify(m));if(m.payload.returnValue===true){k=m.payload;i.onSuccess(k)}else{k.returnValue=false;k.errorCode=m.payload.errorCode;k.errorText=m.payload.errorText;i.onFailure(k)}};if(a){a.call(h,j,l)}}};module.exports=e}function b(g,h,f){if(g.errorCode===undefined||g.errorCode===null){g.errorCode=h}if(g.errorText===undefined||g.errorText===null){g.errorText=f}}e.PictureMode={VIVID:"vivid",STANDARD:"normal",APS:"eco",CINEMA:"cinema",GAME:"game",SPORTS:"sports",EXPERT1:"expert1",EXPERT2:"expert2"};e.AppMode={LOCAL:"local",USB:"usb",REMOTE:"remote"};e.AppType={IPK:"ipk",ZIP:"zip"};e.prototype.setPictureMode=function(f,g,h){a.Request("luna://com.webos.service.commercial.scapadapter/configuration/",{method:"setPictureMode",parameters:h,onSuccess:function(i){d("setPictureMode: On Success");if(typeof f==="function"){f()}},onFailure:function(i){d("setPictureMode: On Failure");delete i.returnValue;if(typeof g==="function"){b(i,"CSPP","Configuration.setPictureMode returns failure.");g(i)}}})};e.prototype.getPictureMode=function(f,g){a.Request("luna://com.webos.service.commercial.scapadapter/configuration/",{method:"getPictureMode",parameters:{},onSuccess:function(h){d("getPictureMode: On Success");delete h.returnValue;if(typeof f==="function"){f(h)}},onFailure:function(h){d("getPictureMode: On Failure");delete h.returnValue;if(typeof g==="function"){b(h,"CGPM","Configuration.getPictureMode returns failure.");g(h)}}})};e.prototype.setPictureProperty=function(f,g,h){a.Request("luna://com.webos.service.commercial.scapadapter/configuration/",{method:"setPictureProperty",parameters:h,onSuccess:function(i){d("setPictureProperty: On Success");if(typeof f==="function"){f()}},onFailure:function(i){d("setPictureProperty: On Failure");delete i.returnValue;if(typeof g==="function"){b(i,"CSPP","Configuration.setPictureProperty returns failure.");g(i)}}})};e.prototype.getPictureProperty=function(f,g){a.Request("luna://com.webos.service.commercial.scapadapter/configuration/",{method:"getPictureProperty",parameters:{},onSuccess:function(h){d("getPictureProperty: On Success");delete h.returnValue;if(typeof f==="function"){f(h)}},onFailure:function(h){d("getPictureProperty: On Failure");delete h.returnValue;if(typeof g==="function"){b(h,"CGPP","Configuration.getPictureProperty returns failure.");g(h)}}})};var c={alias:"signageName"};e.prototype.setProperty=function(f,g,i){d("setProperty: "+JSON.stringify(i));var h=JSON.parse(i);var k={};var l={};c.alias="deviceName";l.category="network";for(var j in h){if(c[j]!==undefined){k[(c[j])]=h[j]}}l.settings=k;a.Request("luna://com.webos.service.commercial.scapadapter/settings/",{method:"set",parameters:l,onSuccess:function(m){d("setProperty: On Success");if(m.returnValue===true){if(typeof f==="function"){f()}}},onFailure:function(m){d("setProperty: On Failure");delete m.returnValue;if(typeof g==="function"){b(m,"CSP","Configuration.setProperty returns failure.");g(m)}}});d("Configuration.setProperty Done")};e.prototype.getProperty=function(g,h,j){d("getProperty: ");var i=JSON.parse(j);var l=i.keys;var m={};var f=[];c.alias="deviceName";m.category="network";for(var k in l){if(k!==null&&k!==undefined){d("key"+l[k]);f.push(c[l[k]])}}m.keys=f;d(f);a.Request("luna://com.webos.service.commercial.scapadapter/settings/",{method:"get",parameters:m,onSuccess:function(n){d("getProperty: On Success");if(n.returnValue===true){if(typeof g==="function"){var p={};for(var o in l){if(o!==null||o!==undefined){d("key"+l[o]);if(n.settings[c[l[o]]]!==undefined||n.settings[c[l[o]]]!==null){p[l[o]]=n.settings[c[l[o]]]}}}g(JSON.stringify(p))}}},onFailure:function(n){d("getProperty: On Failure");delete n.returnValue;if(typeof h==="function"){b(n,"CGP","Configuration.getProperty returns failure.");h(n)}}});d("Configuration.getProperty Done")};e.prototype.setCurrentTime=function(f,g,h){d("setCurrentTime: "+JSON.stringify(h));var i={};i.year=h.year;i.month=h.month;i.day=h.day;i.hour=h.hour;i.minute=h.minute;i.sec=h.sec;a.Request("luna://com.webos.service.commercial.scapadapter/settings/",{method:"setSystemTime",parameters:{time:i,ntp:h.ntp,ntpServerAddress:h.ntpServerAddress},onSuccess:function(){d("setCurrentTime: On Success");if(typeof f==="function"){f()}},onFailure:function(j){d("setCurrentTime: On Failure");delete j.returnValue;if(typeof g==="function"){b(j,"CSCT","Configuration.setCurrentTime returns failure.");g(j)}}});d("Configuration.setCurrentTime Done")};e.prototype.getCurrentTime=function(f,g){d("getCurrentTime: ");a.Request("luna://com.webos.service.commercial.scapadapter/settings/",{method:"getSystemTime",parameters:{},onSuccess:function(h){d("getSystemTime: On Success");delete h.returnValue;if(typeof f==="function"){f(h)}},onFailure:function(h){d("getSystemTime: On Failure");delete h.returnValue;if(typeof g==="function"){g(h)}}});d("Configuration.getCurrentTime Done")};e.prototype.restartApplication=function(f,g){d("restartApp: ");a.Request("luna://com.webos.service.commercial.scapadapter/",{method:"restart_application",onSuccess:function(h){d("restartApp: On Success");if(typeof f==="function"){f(h)}},onFailure:function(h){d("restartApp: On Failure");delete h.returnValue;if(typeof g==="function"){b(h,"CRA","Configuration.restartApp returns failure.");g(h)}}});d("Configuration.restartApp Done")};e.prototype.getServerProperty=function(f,g){a.Request("luna://com.webos.service.commercial.scapadapter/configuration/",{method:"getServerProperty",parameters:{},onSuccess:function(h){delete h.returnValue;if(typeof f==="function"){f(h)}},onFailure:function(h){delete h.returnValue;if(typeof g==="function"){b(h,"CGSP","Configuration.getServerProperty returns failure.");g(h)}}})};e.prototype.setServerProperty=function(f,g,h){a.Request("luna://com.webos.service.commercial.scapadapter/configuration/",{method:"setServerProperty",parameters:h,onSuccess:function(i){if(i.returnValue===true){if(typeof f==="function"){f()}}},onFailure:function(i){delete i.returnValue;if(typeof g==="function"){b(i,"CSSP","Configuration.setServerProperty returns failure.");g(i)}}})};e.prototype.clearCache=function(f,g){d("clearCache: ");a.Request("luna://com.webos.service.commercial.scapadapter/",{method:"clearCache",onSuccess:function(h){d("clearCache: On Success");if(typeof f==="function"){f()}},onFailure:function(h){d("clearCache: On Failure");delete h.returnValue;if(typeof g==="function"){b(h,"CCC","Configuration.clearCache returns failure.");g(h)}}});d("Configuration.clearCache Done")};e.prototype.getTimeZoneList=function(f,g){d("getTimeZoneList: ");a.Request("luna://com.webos.service.commercial.scapadapter/settings/",{method:"getTimeZoneList",onSuccess:function(h){d("getTimeZoneList: On Success");if(h.returnValue===true){if(typeof f==="function"){delete h.returnValue;f(h)}}},onFailure:function(h){d("getTimeZoneList: On Failure");delete h.returnValue;if(typeof g==="function"){b(h,"CGTL","Configuration.getTimeZoneList returns failure.");g(h)}}});d("Configuration.getTimeZoneList Done")};e.prototype.getTimeZone=function(f,g){d("getTimeZone: ");a.Request("luna://com.webos.service.commercial.scapadapter/settings/",{method:"getTimeZone",onSuccess:function(h){d("getTimeZone: On Success");if(h.returnValue===true){if(typeof f==="function"){delete h.returnValue;f(h)}}},onFailure:function(h){d("getTimeZone: On Failure");delete h.returnValue;if(typeof g==="function"){b(h,"CGTZ","Configuration.getTimeZone returns failure.");g(h)}}});d("Configuration.getTimeZone Done")};e.prototype.setTimeZone=function(f,g,h){a.Request("luna://com.webos.service.commercial.scapadapter/settings/",{method:"setTimeZone",parameters:h,onSuccess:function(i){if(i.returnValue===true){if(typeof f==="function"){delete i.returnValue;f(i)}}},onFailure:function(i){delete i.returnValue;if(typeof g==="function"){b(i,"CSTZ","Configuration.setTimeZone returns failure.");g(i)}}})};e.prototype.debug=function(f,g,h){d("debug: "+h.enabled);a.Request("luna://com.webos.service.commercial.scapadapter/",{method:"debug",parameters:{enabled:h.enabled},onSuccess:function(i){d("debug: On Success");if(typeof f==="function"){f(i)}},onFailure:function(i){d("debug: On Failure");delete i.returnValue;if(typeof g==="function"){b(i,"CD","Configuration.debug returns failure.");g(i)}}});d("Configuration.debug Done")};e.prototype.setUSBLock=function(f,g,h){a.Request("luna://com.webos.service.commercial.scapadapter/configuration/",{method:"setUSBLock",parameters:h,onSuccess:function(i){if(i.returnValue===true){if(typeof f==="function"){f()}}},onFailure:function(i){delete i.returnValue;if(typeof g==="function"){b(i,"CSUL","Configuration.setUSBLock returns failure.");g(i)}}})};e.prototype.getUSBLock=function(f,g){a.Request("luna://com.webos.service.commercial.scapadapter/configuration/",{method:"getUSBLock",parameters:{},onSuccess:function(h){delete h.returnValue;if(typeof f==="function"){f(h)}},onFailure:function(h){delete h.returnValue;if(typeof g==="function"){b(h,"CGUL","Configuration.getUSBLock returns failure.");g(h)}}})};e.prototype.setOSDLock=function(f,g,h){a.Request("luna://com.webos.service.commercial.scapadapter/configuration/",{method:"setOSDLock",parameters:h,onSuccess:function(i){if(i.returnValue===true){if(typeof f==="function"){f()}}},onFailure:function(i){delete i.returnValue;if(typeof g==="function"){b(i,"CSOL","Configuration.setOSDLock returns failure.");g(i)}}})};e.prototype.getOSDLock=function(f,g){a.Request("luna://com.webos.service.commercial.scapadapter/configuration/",{method:"getOSDLock",parameters:{},onSuccess:function(h){delete h.returnValue;if(typeof f==="function"){f(h)}},onFailure:function(h){delete h.returnValue;if(typeof g==="function"){b(h,"CGOL","Configuration.getOSDLock returns failure.");g(h)}}})};e.prototype.getLocaleList=function(f,g){a.Request("luna://com.webos.service.commercial.scapadapter/configuration/",{method:"getLocaleList",parameters:{},onSuccess:function(h){d("getLocaleList: On Success");delete h.returnValue;if(typeof f==="function"){f(h)}},onFailure:function(h){d("getLocaleList: On Failure");delete h.returnValue;if(typeof g==="function"){b(h,"CGLL","Configuration.getLocaleList returns failure.");g(h)}}})};e.prototype.setOSDLanguage=function(f,g,h){a.Request("luna://com.webos.service.commercial.scapadapter/configuration/",{method:"setOSDLanguage",parameters:h,onSuccess:function(i){if(i.returnValue===true){if(typeof f==="function"){f()}}},onFailure:function(i){delete i.returnValue;if(typeof g==="function"){b(i,"CSON","Configuration.setOSDLanguage returns failure.");g(i)}}})};e.prototype.getOSDLanguage=function(f,g){a.Request("luna://com.webos.service.commercial.scapadapter/configuration/",{method:"getOSDLanguage",parameters:{},onSuccess:function(h){delete h.returnValue;if(typeof f==="function"){f(h)}},onFailure:function(h){delete h.returnValue;if(typeof g==="function"){b(h,"CGON","Configuration.getOSDLanguage returns failure.");g(h)}}})};e.prototype.setVirtualKeyboardLanguage=function(f,g,h){d("setVirtualKeyboardLanguage: "+h.languageCodeList);a.Request("luna://com.webos.service.commercial.scapadapter/configuration/",{method:"setVirtualKeyboardLanguage",parameters:{languageCodeList:h.languageCodeList},onSuccess:function(i){d("setVirtualKeyboardLanguage: On Success");if(i.returnValue===true){if(typeof f==="function"){f()}}},onFailure:function(i){d("setVirtualKeyboardLanguage: On Failure");delete i.returnValue;if(typeof g==="function"){b(i,"CSKL","Configuration.setVirtualKeyboardLanguage returns failure.");g(i)}}});d("Configuration.setVirtualKeyboardLanguage Done")};e.prototype.getVirtualKeyboardLanguage=function(f,g){d("getVirtualKeyboardLanguage: ");a.Request("luna://com.webos.service.commercial.scapadapter/configuration/",{method:"getVirtualKeyboardLanguage",parameters:{},onSuccess:function(h){d("getVirtualKeyboardLanguage: On Success");if(h.returnValue===true){var i={};d("keyboards : "+JSON.stringify(h.languageCodeList));i.languageCodeList=h.languageCodeList;if(typeof f==="function"){f(i)}}},onFailure:function(h){d("getVirtualKeyboardLanguage: On Failure");delete h.returnValue;if(typeof g==="function"){b(h,"CGKL","Configuration.getVirtualKeyboardLanguage returns failure.");g(h)}}});d("Configuration.getVirtualKeyboardLanguage Done")};e.prototype.setProxyBypassList=function(g,h,i){if(typeof i.urlList==="undefined"&&typeof h==="function"){var f={};b(f,"CSPB","Configuration.setProxyBypassList returns failure. options.urlList is undefined.");h(f);return}a.Request("luna://com.webos.service.commercial.scapadapter/configuration/",{method:"setProxyBypassList",parameters:{urlList:i.urlList},onSuccess:function(j){d("setProxyBypassList: On Success");if(j.returnValue===true){if(typeof g==="function"){g()}}},onFailure:function(j){d("setProxyBypassList: On Failure");delete j.returnValue;if(typeof h==="function"){b(j,"CSPB","Configuration.setProxyBypassList returns failure.");h(j)}}})};e.prototype.getProxyBypassList=function(f,g){a.Request("luna://com.webos.service.commercial.scapadapter/configuration/",{method:"getProxyBypassList",parameters:{},onSuccess:function(h){if(h.returnValue===true){var i={};i.urlList=h.urlList;if(typeof f==="function"){f(i)}}},onFailure:function(h){delete h.returnValue;if(typeof g==="function"){b(h,"CGPB","Configuration.getProxyBypassList returns failure.");g(h)}}})};return e}());

/***/ }),
/* 12 */
/***/ (function(module, exports) {

DeviceInfo=(function(){var d,a;function c(e){}if(typeof window==="object"){cordova.define("cordova/plugin/deviceInfo",function(f,e,g){d=function(){};if(window.PalmSystem){c("Window.PalmSystem Available");a=f("cordova/plugin/webos/service")}else{a={Request:function(h,i){c(h+" invoked. But I am a dummy because PalmSystem is not available");if(typeof i.onFailure==="function"){i.onFailure({returnValue:false,errorText:"PalmSystem Not Available. Cordova is not installed?"})}}}}g.exports=d});d=cordova.require("cordova/plugin/deviceInfo")}else{d=function(e){a=e;a.Request=function(f,h){var g=f+"/"+h.method;var i={};if(h.hasOwnProperty("parameters")===true){i=h.parameters}var j={};var k=function(l){console.log("res : "+JSON.stringify(l));if(l.payload.returnValue===true){j=l.payload;h.onSuccess(j)}else{j.returnValue=false;j.errorCode=l.payload.errorCode;j.errorText=l.payload.errorText;h.onFailure(j)}};if(a){a.call(g,i,k)}}};module.exports=d}function b(f,g,e){if(f.errorCode===undefined||f.errorCode===null){f.errorCode=g}if(f.errorText===undefined||f.errorText===null){f.errorText=e}}d.EddystoneFrame={UUID:"uid",URL:"url"};d.prototype.getNetworkInfo=function(e,f){c("getNetworkInfo: ");a.Request("luna://com.webos.service.commercial.scapadapter/network/",{method:"getNetworkInfo",parameters:{},onSuccess:function(g){if(typeof e==="function"){delete g.returnValue;e(g)}},onFailure:function(g){delete g.returnValue;if(typeof f==="function"){f(g)}}});c("DeviceInfo.getNetworkInfo Done")};d.prototype.setNetworkInfo=function(e,f,g){c("setNetworkInfo: ");a.Request("luna://com.webos.service.commercial.scapadapter/network/",{method:"setNetworkInfo",parameters:g,onSuccess:function(h){c("setNetworkInfo: onSuccess");if(typeof e==="function"){e()}},onFailure:function(h){c("setNetworkInfo: onFailure");delete h.returnValue;if(typeof f==="function"){f(h)}}});c("DeviceInfo.setNetworkInfo Done")};d.prototype.getBeaconInfo=function(e,f){a.Request("luna://com.webos.service.commercial.scapadapter/network/",{method:"getBeaconInfo",parameters:{},onSuccess:function(g){c("getBeaconInfo: onSuccess");delete g.returnValue;if(typeof e==="function"){e(g)}},onFailure:function(g){c("getBeaconInfo: onFailure");delete g.returnValue;if(typeof f==="function"){f(g)}}})};d.prototype.setBeaconInfo=function(e,f,g){a.Request("luna://com.webos.service.commercial.scapadapter/network/",{method:"setBeaconInfo",parameters:g,onSuccess:function(h){c("setBeaconInfo: onSuccess");if(typeof e==="function"){e()}},onFailure:function(h){c("setBeaconInfo: onFailure");delete h.returnValue;if(typeof f==="function"){f(h)}}})};d.prototype.getSoftApInfo=function(e,f){c("getSoftApInfo: ");a.Request("luna://com.webos.service.commercial.scapadapter/network/",{method:"getSoftApInfo",parameters:{},onSuccess:function(g){c("getSoftApInfo: onSuccess");delete g.returnValue;if(typeof e==="function"){e(g)}},onFailure:function(g){c("getSoftApInfo: onFailure");delete g.returnValue;if(typeof f==="function"){f(g)}}});c("DeviceInfo.getSoftApInfo Done")};d.prototype.setSoftApInfo=function(f,g,h){c("setSoftApInfo: ");if(h.enabled===true&&((h.ssid!==null&&h.ssid.length>32)||(h.securityKey!==null&&h.securityKey.length!==6))){c("setSoftApInfo: options are invalid.");if(typeof g==="function"){var e={};b(e,"DSSI","DeviceInfo.setSoftApInfo. Invalid options.");g(e)}return}a.Request("luna://com.webos.service.commercial.scapadapter/network/",{method:"setSoftApInfo",parameters:h,onSuccess:function(i){c("setSoftApInfo: onSuccess");if(typeof f==="function"){f()}},onFailure:function(i){c("setSoftApInfo: onFailure");delete i.returnValue;if(typeof g==="function"){g(i)}}});c("DeviceInfo.setSoftApInfo Done")};d.prototype.getSoftApClientInfo=function(e,f){c("getSoftApClientInfo: ");a.Request("luna://com.webos.service.commercial.scapadapter/deviceinfo/",{method:"getSoftApClientInfo",parameters:{},onSuccess:function(g){c("getSoftApClientInfo: onSuccess");delete g.returnValue;if(typeof e==="function"){e(g)}},onFailure:function(g){c("getSoftApClientInfo: onFailure");delete g.returnValue;if(typeof f==="function"){f(g)}}});c("DeviceInfo.getSoftApClientInfo Done")};d.prototype.getWifiList=function(e,f){c("getWifiList: ");a.Request("luna://com.webos.service.commercial.scapadapter/network/",{method:"getWifiList",parameters:{},onSuccess:function(g){c("getWifiList: onSuccess");delete g.returnValue;if(typeof e==="function"){e(g)}},onFailure:function(g){c("getWifiList: onFailure");delete g.returnValue;if(typeof f==="function"){f(g)}}});c("DeviceInfo.getWifiList Done")};d.prototype.connectWifi=function(e,f,g){c("connectWifi: ");a.Request("luna://com.webos.service.commercial.scapadapter/network/",{method:"connectWifi",parameters:g,onSuccess:function(h){c("connectWifi: onSuccess");if(typeof e==="function"){e()}},onFailure:function(h){c("connectWifi: onFailure");delete h.returnValue;if(typeof f==="function"){f(h)}}});c("DeviceInfo.connectWifi Done")};d.prototype.startWps=function(e,f,g){c("startWps: ");a.Request("luna://com.webos.service.commercial.scapadapter/network/",{method:"startWps",parameters:g,onSuccess:function(h){c("startWps: onSuccess");delete h.returnValue;if(typeof e==="function"){e(h)}},onFailure:function(h){c("startWps: onFailure");delete h.returnValue;if(typeof f==="function"){f(h)}}});c("DeviceInfo.startWps Done")};d.prototype.stopWps=function(e,f){c("stopWps: ");a.Request("luna://com.webos.service.commercial.scapadapter/network/",{method:"stopWps",parameters:{},onSuccess:function(g){c("stopWps: onSuccess");if(typeof e==="function"){e()}},onFailure:function(g){c("stopWPS: onFailure");delete g.returnValue;if(typeof f==="function"){f(g)}}});c("DeviceInfo.stopWps Done")};d.prototype.getNetworkMacInfo=function(e,f){c("getNetworkMacInfo");a.Request("luna://com.webos.service.commercial.scapadapter/deviceinfo",{method:"getNetworkMacInfo",parameters:{},onSuccess:function(g){c("getNetworkMacInfo: onSuccess");delete g.returnValue;if(typeof e==="function"){e(g)}},onFailure:function(g){c("getNetworkMacInfo: onFailure");delete g.returnValue;if(typeof f==="function"){f(g)}}});c("DeviceInfo.getNetworkMacInfo Done")};d.prototype.getPlatformInfo=function(e,f){a.Request("luna://com.webos.service.commercial.scapadapter/deviceInfo/",{method:"getPlatformInfo",parameters:{},onSuccess:function(g){delete g.returnValue;if(typeof e==="function"){e(g)}},onFailure:function(g){delete g.returnValue;if(typeof f==="function"){b(g,"DGFI","DeviceInfo.getPlatformInfo returns failure.");f(g)}}})};d.prototype.getSystemUsageInfo=function(e,f,g){c("getSystemUsageInfo: ");a.Request("luna://com.webos.service.commercial.scapadapter",{method:"getSystemUsageInfo",parameters:{cpus:g.cpus,memory:g.memory},onSuccess:function(h){if(h.returnValue===true){var i={};if(typeof h.memory!=="undefined"){i.memory=h.memory}if(typeof h.cpus!=="undefined"){i.cpus=h.cpus}if(typeof e==="function"){e(i)}}else{if(typeof f==="function"){f({errorCode:h.errorCode,errorText:h.errorText})}}},onFailure:function(h){if(typeof f==="function"){f({errorCode:h.errorCode,errorText:h.errorText})}}});c("DeviceInfo.getSystemUsageInfo Done")};d.prototype.setProxyInfo=function(e,f,g){a.Request("luna://com.webos.service.commercial.scapadapter/deviceInfo/",{method:"setProxyInfo",parameters:g,onSuccess:function(h){delete h.returnValue;if(typeof e==="function"){e()}},onFailure:function(h){delete h.returnValue;if(typeof f==="function"){b(h,"DSPI","DeviceInfo.setProxyInfo returns failure.");f(h)}}})};d.prototype.getProxyInfo=function(e,f){a.Request("luna://com.webos.service.commercial.scapadapter/deviceInfo/",{method:"getProxyInfo",parameters:{},onSuccess:function(g){delete g.returnValue;if(typeof e==="function"){e(g)}},onFailure:function(g){delete g.returnValue;if(typeof f==="function"){b(g,"DGPI","DeviceInfo.getProxyInfo returns failure.");f(g)}}})};d.prototype.setiBeaconInfo=function(e,f,g){a.Request("luna://com.webos.service.commercial.scapadapter/deviceInfo/",{method:"setiBeaconInfo",parameters:g,onSuccess:function(h){delete h.returnValue;if(typeof e==="function"){e()}},onFailure:function(h){delete h.returnValue;if(typeof f==="function"){b(h,"DSIB","DeviceInfo.setiBeaconInfo returns failure.");f(h)}}})};d.prototype.getiBeaconInfo=function(e,f){a.Request("luna://com.webos.service.commercial.scapadapter/deviceInfo/",{method:"getiBeaconInfo",parameters:{},onSuccess:function(g){delete g.returnValue;if(typeof e==="function"){e(g)}},onFailure:function(g){delete g.returnValue;if(typeof f==="function"){b(g,"DGIB","DeviceInfo.getiBeaconInfo returns failure.");f(g)}}})};d.prototype.setEddystoneInfo=function(e,f,g){a.Request("luna://com.webos.service.commercial.scapadapter/deviceInfo/",{method:"setEddystoneInfo",parameters:g,onSuccess:function(h){delete h.returnValue;if(typeof e==="function"){e()}},onFailure:function(h){delete h.returnValue;if(typeof f==="function"){b(h,"DSEI","DeviceInfo.setEddystoneInfo returns failure.");f(h)}}})};d.prototype.getEddystoneInfo=function(e,f){a.Request("luna://com.webos.service.commercial.scapadapter/deviceInfo/",{method:"getEddystoneInfo",parameters:{},onSuccess:function(g){delete g.returnValue;if(typeof e==="function"){e(g)}},onFailure:function(g){delete g.returnValue;if(typeof f==="function"){b(g,"DGEI","DeviceInfo.getEddystoneInfo returns failure.");f(g)}}})};return d}());

/***/ }),
/* 13 */
/***/ (function(module, exports) {

Power=(function(){var c,b;function f(g){}if(typeof window==="object"){cordova.define("cordova/plugin/power",function(h,g,i){c=function(){};if(window.PalmSystem){f("Window.PalmSystem Available");b=h("cordova/plugin/webos/service")}else{b={Request:function(j,k){f(j+" invoked. But I am a dummy because PalmSystem is not available");if(typeof k.onFailure==="function"){k.onFailure({returnValue:false,errorText:"PalmSystem Not Available. Cordova is not installed?"})}}}}i.exports=c});c=cordova.require("cordova/plugin/power")}else{c=function(g){b=g;b.Request=function(h,j){var i=h+"/"+j.method;var k={};if(j.hasOwnProperty("parameters")===true){k=j.parameters}var l={};var m=function(n){console.log("res : "+JSON.stringify(n));if(n.payload.returnValue===true){l=n.payload;j.onSuccess(l)}else{l.returnValue=false;l.errorCode=n.payload.errorCode;l.errorText=n.payload.errorText;j.onFailure(l)}};if(b){b.call(i,k,m)}}};module.exports=c}function e(h,i,g){if(h.errorCode===undefined||h.errorCode===null){h.errorCode=i}if(h.errorText===undefined||h.errorText===null){h.errorText=g}}function a(h,g){if(h===g){return true}if(h==null||g==null){return false}if(h.length!=g.length){return false}h.sort();g.sort();for(var j=0;j<h.length;j++){if(h[j]!==g[j]){return false}}return true}function d(g){switch(g){case"ext://hdmi:1":return"HDMI1";case"ext://hdmi:2":return"HDMI2";case"ext://hdmi:3":return"HDMI3";case"ext://dvi:1":return"DVI";case"ext://dp:1":return"DISPLAYPORT";case"ext://rgb:1":return"RGB";case"ext://ops:1":return"OPS";case"HDMI1":return"ext://hdmi:1";case"HDMI":return"ext://hdmi:1";case"HDMI2":return"ext://hdmi:2";case"HDMI3":return"ext://hdmi:3";case"DVI":return"ext://dvi:1";case"DISPLAYPORT":return"ext://dp:1";case"RGB":return"ext://rgb:1";case"OPS":return"ext://ops:1";case"OPS/HDMI3/DVI":return"ext://hdmi:3"}return null}c.PowerCommand={SHUTDOWN:"powerOff",REBOOT:"reboot"};c.DisplayMode={DISPLAY_OFF:"Screen Off",DISPLAY_ON:"Active"};c.TimerWeek={MONDAY:1,TUESDAY:2,WEDNESDAY:4,THURSDAY:8,FRIDAY:16,SATURDAY:32,SUNDAY:64,EVERYDAY:127};c.DPMSignalType={CLOCK:"clock",CLOCK_WITH_DATA:"clockAndData"};c.PMMode={PowerOff:"powerOff",SustainAspectRatio:"sustainAspectRatio",ScreenOff:"screenOff",ScreenOffAlways:"screenOffAlways",ScreenOffBacklight:"screenOffBacklight"};c.prototype.getPowerStatus=function(g,h){f("getPowerStatus");b.Request("luna://com.webos.service.commercial.scapadapter/power/",{method:"getPowerStatus",parameters:{},onSuccess:function(i){f("getPowerStatus: On onSuccess");delete i.returnValue;if(typeof g==="function"){g(i)}},onFailure:function(i){f("getPowerStatus: On Failure");delete i.returnValue;if(typeof h==="function"){e(i,"PGPS","Power.getPowerStatus returns failure.");h(i)}}});f("Power.getPowerStatus Done")};c.prototype.enableAllOnTimer=function(h,i,j){f("enableAllOnTimer: "+JSON.stringify(j));var k=null;switch(j.allOnTimer){case true:k="on";break;case false:k="off";break;default:if(typeof i==="function"){var g={};e(g,"PEAOT","Power.enableAllOnTimer returns failure. Invalid option value.");i(g)}return}b.Request("luna://com.webos.service.commercial.scapadapter/settings/",{method:"set",parameters:{category:"time",settings:{onTimerEnable:k}},onSuccess:function(){if(j.clearOnTimer===true){b.Request("luna://com.webos.service.commercial.scapadapter/settings/",{method:"get",parameters:{category:"commercial",keys:["onOffTimeSchedule"]},onSuccess:function(l){if(l.returnValue===true){var o;var m={};m.onTime=[];m.offTime=[];var n={};var p=(l.settings.onOffTimeSchedule.offTime===null||l.settings.onOffTimeSchedule.offTime===undefined?0:l.settings.onOffTimeSchedule.offTime.length);for(o=0;o<p;o++){if(l.settings.onOffTimeSchedule.offTime[o].day!==undefined&&l.settings.onOffTimeSchedule.offTime[o].day!==null){n.day=l.settings.onOffTimeSchedule.offTime[o].day}if(l.settings.onOffTimeSchedule.offTime[o].hour!==undefined&&l.settings.onOffTimeSchedule.offTime[o].hour!==null){n.hour=l.settings.onOffTimeSchedule.offTime[o].hour}if(l.settings.onOffTimeSchedule.offTime[o].minute!==undefined&&l.settings.onOffTimeSchedule.offTime[o].minute!==null){n.minute=l.settings.onOffTimeSchedule.offTime[o].minute}m.offTime.push(n);n={}}b.Request("luna://com.webos.service.commercial.scapadapter/settings/",{method:"set",parameters:{category:"commercial",settings:{onOffTimeSchedule:m}},onSuccess:function(){f("enableAllOnTimer: On Success 2");if(typeof h==="function"){h()}},onFailure:function(q){f("enableAllOnTimer: On Failure 2");delete q.returnValue;if(typeof i==="function"){e(q,"PAOT","Power.enableAllOnTimer returns failure.");i(q)}return}})}else{if(typeof h==="function"){f("enableAllOnTimer: On Success");h()}}},onFailure:function(l){delete l.returnValue;if(typeof i==="function"){f("enableAllOnTimer: On Failure");e(l,"PEAOT","Power.enableAllOnTimer returns failure.");i(l)}}})}else{if(typeof h==="function"){f("enableAllOnTimer: On Success");h()}}},onFailure:function(l){delete l.returnValue;if(typeof i==="function"){f("enableAllOnTimer: On Failure");e(l,"PEAOT","Power.enableAllOnTimer returns failure.");i(l)}}});f("Power.enableAllOnTimer Done")};c.prototype.enableAllOffTimer=function(h,i,j){f("enableAllOffTimer: "+JSON.stringify(j));var k=null;switch(j.allOffTimer){case true:k="on";break;case false:k="off";break;default:if(typeof i==="function"){var g={};e(g,"PEAOT","Power.enableAllOffTimer returns failure. Invalid option value.");i(g)}return}b.Request("luna://com.webos.service.commercial.scapadapter/settings/",{method:"set",parameters:{category:"time",settings:{offTimerEnable:k}},onSuccess:function(){if(j.clearOffTimer===true){b.Request("luna://com.webos.service.commercial.scapadapter/settings/",{method:"get",parameters:{category:"commercial",keys:["onOffTimeSchedule"]},onSuccess:function(l){if(l.returnValue===true){var o;var m={};m.onTime=[];m.offTime=[];var n={};var p=(l.settings.onOffTimeSchedule.onTime===null||l.settings.onOffTimeSchedule.onTime===undefined?0:l.settings.onOffTimeSchedule.onTime.length);for(o=0;o<p;o++){if(l.settings.onOffTimeSchedule.onTime[o].day!==undefined&&l.settings.onOffTimeSchedule.onTime[o].day!==null){n.day=l.settings.onOffTimeSchedule.onTime[o].day}if(l.settings.onOffTimeSchedule.onTime[o].hour!==undefined&&l.settings.onOffTimeSchedule.onTime[o].hour!==null){n.hour=l.settings.onOffTimeSchedule.onTime[o].hour}if(l.settings.onOffTimeSchedule.onTime[o].minute!==undefined&&l.settings.onOffTimeSchedule.onTime[o].minute!==null){n.minute=l.settings.onOffTimeSchedule.onTime[o].minute}m.onTime.push(n);n={}}b.Request("luna://com.webos.service.commercial.scapadapter/settings/",{method:"set",parameters:{category:"commercial",settings:{onOffTimeSchedule:m}},onSuccess:function(){f("enableAllOffTimer: On Success 2");if(typeof h==="function"){h()}},onFailure:function(q){f("enableAllOffTimer: On Failure 2");delete q.returnValue;if(typeof i==="function"){e(q,"PAOT","Power.enableAllOffTimer returns failure.");i(q)}return}})}else{if(typeof h==="function"){f("enableAllOffTimer: On Success");h()}}},onFailure:function(l){delete l.returnValue;if(typeof i==="function"){f("enableAllOffTimer: On Failure");e(l,"PEAOT","Power.enableAllOffTimer returns failure.");i(l)}}})}else{if(typeof h==="function"){f("enableAllOffTimer: On Success");h()}}},onFailure:function(l){delete l.returnValue;if(typeof i==="function"){f("enableAllOffTimer: On Failure");e(l,"PEAOT","Power.enableAllOffTimer returns failure.");i(l)}}});f("Power.enableAllOffTimer Done")};c.prototype.enableWakeOnLan=function(g,h,i){b.Request("luna://com.webos.service.commercial.scapadapter/power/",{method:"enableWakeOnLan",parameters:i,onSuccess:function(j){delete j.returnValue;if(typeof g==="function"){g()}},onFailure:function(j){delete j.returnValue;if(typeof h==="function"){e(j,"PEWO","Power.enableWakeOnLan returns failure.");h(j)}}})};c.prototype.addOnTimer=function(h,i,j){f("addOnTimer: "+JSON.stringify(j));if(j.hour===undefined||isNaN(j.hour)||typeof j.hour!=="number"||j.hour<0||j.hour>23||j.minute===undefined||isNaN(j.minute)||typeof j.minute!=="number"||j.minute<0||j.minute>59||j.week===undefined||isNaN(j.week)||typeof j.week!=="number"||j.week<=0||j.week>127){if(typeof i==="function"){var g={};e(g,"PAOT","Power.addOnTimer returns failure. invalid parameters or out of range.");i(g)}return}b.Request("luna://com.webos.service.commercial.scapadapter/settings/",{method:"get",parameters:{category:"commercial",keys:["onOffTimeSchedule"]},onSuccess:function(k){if(k.returnValue===true){var p;var m={};m.onTime=[];m.offTime=[];var r=[];var o={};var l=1;while(j.week!==0){if(j.week&1){console.log("AddonTimer - options.week - "+j.week);switch(l){case 1:r.push("mon");break;case 2:r.push("tue");break;case 4:r.push("wed");break;case 8:r.push("thu");break;case 16:r.push("fri");break;case 32:r.push("sat");break;case 64:r.push("sun");break}}j.week=j.week>>>1;l=l<<1;if(j.week===0){break}}o.day=r;o.hour=j.hour;o.minute=j.minute;m.onTime.push(o);o={};var n=(k.settings.onOffTimeSchedule.onTime===null||k.settings.onOffTimeSchedule.onTime===undefined?0:k.settings.onOffTimeSchedule.onTime.length);for(p=0;p<n;p++){if(k.settings.onOffTimeSchedule.onTime[p].day!==undefined&&k.settings.onOffTimeSchedule.onTime[p].day!==null){o.day=k.settings.onOffTimeSchedule.onTime[p].day}if(k.settings.onOffTimeSchedule.onTime[p].hour!==undefined&&k.settings.onOffTimeSchedule.onTime[p].hour!==null){o.hour=k.settings.onOffTimeSchedule.onTime[p].hour}if(k.settings.onOffTimeSchedule.onTime[p].minute!==undefined&&k.settings.onOffTimeSchedule.onTime[p].minute!==null){o.minute=k.settings.onOffTimeSchedule.onTime[p].minute}m.onTime.push(o);o={}}var q=(k.settings.onOffTimeSchedule.offTime===null||k.settings.onOffTimeSchedule.offTime===undefined?0:k.settings.onOffTimeSchedule.offTime.length);for(p=0;p<q;p++){if(k.settings.onOffTimeSchedule.offTime[p].day!==undefined&&k.settings.onOffTimeSchedule.offTime[p].day!==null){o.day=k.settings.onOffTimeSchedule.offTime[p].day}if(k.settings.onOffTimeSchedule.offTime[p].hour!==undefined&&k.settings.onOffTimeSchedule.offTime[p].hour!==null){o.hour=k.settings.onOffTimeSchedule.offTime[p].hour}if(k.settings.onOffTimeSchedule.offTime[p].minute!==undefined&&k.settings.onOffTimeSchedule.offTime[p].minute!==null){o.minute=k.settings.onOffTimeSchedule.offTime[p].minute}m.offTime.push(o);o={}}b.Request("luna://com.webos.service.commercial.scapadapter/settings/",{method:"set",parameters:{category:"commercial",settings:{onOffTimeSchedule:m}},onSuccess:function(){f("addOnTimer: On Success 2");if(typeof h==="function"){h()}},onFailure:function(s){f("addOnTimer: On Failure 2");delete s.returnValue;if(typeof i==="function"){e(s,"PAOT","Power.addOnTimer returns failure.");i(s)}return}})}},onFailure:function(k){f("addOnTimer: On Failure");delete k.returnValue;if(typeof i==="function"){e(k,"PAOT","Power.addOnTimer returns failure.");i(k)}return}});f("Power.addOnTimer Done")};c.prototype.deleteOnTimer=function(h,i,j){f("deleteOnTimer: "+JSON.stringify(j));if(j.hour===undefined||isNaN(j.hour)||typeof j.hour!=="number"||j.hour<0||j.hour>23||j.minute===undefined||isNaN(j.minute)||typeof j.minute!=="number"||j.minute<0||j.minute>59||j.week===undefined||isNaN(j.week)||typeof j.week!=="number"||j.week<0||j.week>127){if(typeof i==="function"){var g={};e(g,"PAOT","Power.deleteOnTimer returns failure. invalid parameters or out of range.");i(g)}return}b.Request("luna://com.webos.service.commercial.scapadapter/settings/",{method:"get",parameters:{category:"commercial",keys:["onOffTimeSchedule"]},onSuccess:function(t){if(t.returnValue===true){var n;var o={};o.onTime=[];o.offTime=[];var s=[];var m={};var r={};var k=1;while(j.week!==0){if(j.week&1){switch(k){case 1:s.push("mon");break;case 2:s.push("tue");break;case 4:s.push("wed");break;case 8:s.push("thu");break;case 16:s.push("fri");break;case 32:s.push("sat");break;case 64:s.push("sun");break}}j.week=j.week>>>1;k=k<<1;if(j.week===0){break}}k=0;m.day=s;m.hour=j.hour;m.minute=j.minute;var p=(t.settings.onOffTimeSchedule.onTime===null||t.settings.onOffTimeSchedule.onTime===undefined?0:t.settings.onOffTimeSchedule.onTime.length);var l=false;for(n=0;n<p;n++){if(t.settings.onOffTimeSchedule.onTime[n].day!==undefined&&t.settings.onOffTimeSchedule.onTime[n].day!==null&&t.settings.onOffTimeSchedule.onTime[n].hour!==undefined&&t.settings.onOffTimeSchedule.onTime[n].hour!==null&&t.settings.onOffTimeSchedule.onTime[n].minute!==undefined&&t.settings.onOffTimeSchedule.onTime[n].minute!==null){if(a(t.settings.onOffTimeSchedule.onTime[n].day,m.day)&&t.settings.onOffTimeSchedule.onTime[n].hour===m.hour&&t.settings.onOffTimeSchedule.onTime[n].minute===m.minute){l=true}else{r.day=t.settings.onOffTimeSchedule.onTime[n].day;r.hour=t.settings.onOffTimeSchedule.onTime[n].hour;r.minute=t.settings.onOffTimeSchedule.onTime[n].minute;o.onTime.push(r)}}r={}}var q=(t.settings.onOffTimeSchedule.offTime===null||t.settings.onOffTimeSchedule.offTime===undefined?0:t.settings.onOffTimeSchedule.offTime.length);for(n=0;n<q;n++){if(t.settings.onOffTimeSchedule.offTime[n].day!==undefined&&t.settings.onOffTimeSchedule.offTime[n].day!==null){r.day=t.settings.onOffTimeSchedule.offTime[n].day}if(t.settings.onOffTimeSchedule.offTime[n].hour!==undefined&&t.settings.onOffTimeSchedule.offTime[n].hour!==null){r.hour=t.settings.onOffTimeSchedule.offTime[n].hour}if(t.settings.onOffTimeSchedule.offTime[n].minute!==undefined&&t.settings.onOffTimeSchedule.offTime[n].minute!==null){r.minute=t.settings.onOffTimeSchedule.offTime[n].minute}o.offTime.push(r);r={}}if(l){b.Request("luna://com.webos.service.commercial.scapadapter/settings/",{method:"set",parameters:{category:"commercial",settings:{onOffTimeSchedule:o}},onSuccess:function(){f("deleteOnTimer: On Success 2");if(typeof h==="function"){h()}},onFailure:function(u){f("deleteOnTimer: On Failure 2");delete u.returnValue;if(typeof i==="function"){e(u,"PAOT","Power.deleteOnTimer returns failure.");i(u)}return}})}else{var t={};e(t,"PAOT","Power.deleteOnTimer returns failure. / No matched found");i(t)}}},onFailure:function(k){f("deleteOnTimer: On Failure");delete k.returnValue;if(typeof i==="function"){e(k,"PAOT","Power.deleteOnTimer returns failure.");i(k)}return}});f("Power.deleteOnTimer Done")};c.prototype.addOffTimer=function(h,i,j){if(j.hour===undefined||isNaN(j.hour)||typeof j.hour!=="number"||j.hour<0||j.hour>23||j.minute===undefined||isNaN(j.minute)||typeof j.minute!=="number"||j.minute<0||j.minute>59||j.week===undefined||isNaN(j.week)||typeof j.week!=="number"||j.week<=0||j.week>127){if(typeof i==="function"){var g={};e(g,"PAOT","Power.addOffTimer returns failure. Invalid parameter.");i(g)}return}b.Request("luna://com.webos.service.commercial.scapadapter/settings/",{method:"get",parameters:{category:"commercial",keys:["onOffTimeSchedule"]},onSuccess:function(k){if(k.returnValue===true){var p;var m={};m.onTime=[];m.offTime=[];var r=[];var o={};var l=1;while(j.week!==0){if(j.week&1){switch(l){case 1:r.push("mon");break;case 2:r.push("tue");break;case 4:r.push("wed");break;case 8:r.push("thu");break;case 16:r.push("fri");break;case 32:r.push("sat");break;case 64:r.push("sun");break}}j.week=j.week>>>1;l=l<<1;if(j.week===0){break}}o.day=r;o.hour=j.hour;o.minute=j.minute;m.offTime.push(o);o={};var n=(k.settings.onOffTimeSchedule.onTime===null||k.settings.onOffTimeSchedule.onTime===undefined?0:k.settings.onOffTimeSchedule.onTime.length);for(p=0;p<n;p++){if(k.settings.onOffTimeSchedule.onTime[p].day!==undefined&&k.settings.onOffTimeSchedule.onTime[p].day!==null){o.day=k.settings.onOffTimeSchedule.onTime[p].day}if(k.settings.onOffTimeSchedule.onTime[p].hour!==undefined&&k.settings.onOffTimeSchedule.onTime[p].hour!==null){o.hour=k.settings.onOffTimeSchedule.onTime[p].hour}if(k.settings.onOffTimeSchedule.onTime[p].minute!==undefined&&k.settings.onOffTimeSchedule.onTime[p].minute!==null){o.minute=k.settings.onOffTimeSchedule.onTime[p].minute}m.onTime.push(o);o={}}var q=(k.settings.onOffTimeSchedule.offTime===null||k.settings.onOffTimeSchedule.offTime===undefined?0:k.settings.onOffTimeSchedule.offTime.length);for(p=0;p<q;p++){if(k.settings.onOffTimeSchedule.offTime[p].day!==undefined&&k.settings.onOffTimeSchedule.offTime[p].day!==null){o.day=k.settings.onOffTimeSchedule.offTime[p].day}if(k.settings.onOffTimeSchedule.offTime[p].hour!==undefined&&k.settings.onOffTimeSchedule.offTime[p].hour!==null){o.hour=k.settings.onOffTimeSchedule.offTime[p].hour}if(k.settings.onOffTimeSchedule.offTime[p].minute!==undefined&&k.settings.onOffTimeSchedule.offTime[p].minute!==null){o.minute=k.settings.onOffTimeSchedule.offTime[p].minute}m.offTime.push(o);o={}}b.Request("luna://com.webos.service.commercial.scapadapter/settings/",{method:"set",parameters:{category:"commercial",settings:{onOffTimeSchedule:m}},onSuccess:function(){f("addOffTimer: On Success 2");if(typeof h==="function"){h()}},onFailure:function(s){f("addOffTimer: On Failure 2");delete s.returnValue;if(typeof i==="function"){e(s,"PAOT","Power.addOffTimer returns failure.");i(s)}return}})}},onFailure:function(k){f("addOffTimer: On Failure");delete k.returnValue;if(typeof i==="function"){e(k,"PAOT","Power.addOffTimer returns failure.");i(k)}return}});f("Power.addOffTimer Done")};c.prototype.deleteOffTimer=function(h,i,j){f("deleteOffTimer: "+JSON.stringify(j));if(j.hour===undefined||isNaN(j.hour)||typeof j.hour!=="number"||j.hour<0||j.hour>23||j.minute===undefined||isNaN(j.minute)||typeof j.minute!=="number"||j.minute<0||j.minute>59||j.week===undefined||isNaN(j.week)||typeof j.week!=="number"||j.week<0||j.week>127){if(typeof i==="function"){var g={};e(g,"PAOT","Power.deleteOffTimer returns failure. invalid parameters or out of range.");i(g)}return}b.Request("luna://com.webos.service.commercial.scapadapter/settings/",{method:"get",parameters:{category:"commercial",keys:["onOffTimeSchedule"]},onSuccess:function(t){if(t.returnValue===true){var n;var o={};o.onTime=[];o.offTime=[];var s=[];var m={};var r={};var k=1;while(j.week!==0){if(j.week&1){switch(k){case 1:s.push("mon");break;case 2:s.push("tue");break;case 4:s.push("wed");break;case 8:s.push("thu");break;case 16:s.push("fri");break;case 32:s.push("sat");break;case 64:s.push("sun");break}}j.week=j.week>>>1;k=k<<1;if(j.week===0){break}}k=0;m.day=s;m.hour=j.hour;m.minute=j.minute;var p=(t.settings.onOffTimeSchedule.onTime===null||t.settings.onOffTimeSchedule.onTime===undefined?0:t.settings.onOffTimeSchedule.onTime.length);var l=false;for(n=0;n<p;n++){if(t.settings.onOffTimeSchedule.onTime[n].day!==undefined&&t.settings.onOffTimeSchedule.onTime[n].day!==null){r.day=t.settings.onOffTimeSchedule.onTime[n].day}if(t.settings.onOffTimeSchedule.onTime[n].hour!==undefined&&t.settings.onOffTimeSchedule.onTime[n].hour!==null){r.hour=t.settings.onOffTimeSchedule.onTime[n].hour}if(t.settings.onOffTimeSchedule.onTime[n].minute!==undefined&&t.settings.onOffTimeSchedule.onTime[n].minute!==null){r.minute=t.settings.onOffTimeSchedule.onTime[n].minute}o.onTime.push(r);r={}}var q=(t.settings.onOffTimeSchedule.offTime===null||t.settings.onOffTimeSchedule.offTime===undefined?0:t.settings.onOffTimeSchedule.offTime.length);for(n=0;n<q;n++){if(t.settings.onOffTimeSchedule.offTime[n].day!==undefined&&t.settings.onOffTimeSchedule.offTime[n].day!==null&&t.settings.onOffTimeSchedule.offTime[n].hour!==undefined&&t.settings.onOffTimeSchedule.offTime[n].hour!==null&&t.settings.onOffTimeSchedule.offTime[n].minute!==undefined&&t.settings.onOffTimeSchedule.offTime[n].minute!==null){if(a(t.settings.onOffTimeSchedule.offTime[n].day,m.day)&&t.settings.onOffTimeSchedule.offTime[n].hour===m.hour&&t.settings.onOffTimeSchedule.offTime[n].minute===m.minute){l=true}else{r.day=t.settings.onOffTimeSchedule.offTime[n].day;r.hour=t.settings.onOffTimeSchedule.offTime[n].hour;r.minute=t.settings.onOffTimeSchedule.offTime[n].minute;o.offTime.push(r)}}r={}}if(l){b.Request("luna://com.webos.service.commercial.scapadapter/settings/",{method:"set",parameters:{category:"commercial",settings:{onOffTimeSchedule:o}},onSuccess:function(){f("deleteOffTimer: On Success 2");if(typeof h==="function"){h()}},onFailure:function(u){f("deleteOffTimer: On Failure 2");delete u.returnValue;if(typeof i==="function"){e(u,"PAOT","Power.deleteOffTimer returns failure.");i(u)}return}})}else{var t={};e(t,"PAOT","Power.deleteOffTimer returns failure. / No matched found.");i(t)}}},onFailure:function(k){f("deleteOffTimer: On Failure");delete k.returnValue;if(typeof i==="function"){e(k,"PAOT","Power.deleteOffTimer returns failure.");i(k)}return}});f("Power.deleteOffTimer Done")};c.prototype.getOnTimerList=function(g,h){b.Request("luna://com.webos.service.commercial.scapadapter/settings/",{method:"get",parameters:{category:"commercial",keys:["onOffTimeSchedule"]},onSuccess:function(k){if(k.returnValue===true){var q={};var r=new Array(k.settings.onOffTimeSchedule.onTime===null||k.settings.onOffTimeSchedule.onTime===undefined?0:k.settings.onOffTimeSchedule.onTime.length);for(var n=0,o=0;o<r.length;o++,n++){if(k.settings.onOffTimeSchedule.onTime[o]===null||k.settings.onOffTimeSchedule.onTime[o]===undefined){continue}r[n]={hour:0,minute:0,week:0};var p=k.settings.onOffTimeSchedule.onTime[o].day;var l=0;for(var m=0;m<p.length;m++){if(p[m]==="mon"){l+=1}if(p[m]==="tue"){l+=2}if(p[m]==="wed"){l+=4}if(p[m]==="thu"){l+=8}if(p[m]==="fri"){l+=16}if(p[m]==="sat"){l+=32}if(p[m]==="sun"){l+=64}}r[n].hour=k.settings.onOffTimeSchedule.onTime[o].hour;r[n].minute=k.settings.onOffTimeSchedule.onTime[o].minute;r[n].week=l}q.timerList=r;if(typeof g==="function"){g(q)}}},onFailure:function(i){f("getOnTimerList: On Failure");delete i.returnValue;if(typeof h==="function"){e(i,"PGOTL","Power.getOnTimerList returns failure.");h(i)}}});f("Power.getOnTimerList Done")};c.prototype.getOffTimerList=function(g,h){f("getOffTimerList: ");b.Request("luna://com.webos.service.commercial.scapadapter/settings/",{method:"get",parameters:{category:"commercial",keys:["onOffTimeSchedule"]},onSuccess:function(k){if(k.returnValue===true){var q={};var r=new Array(k.settings.onOffTimeSchedule.offTime===null||k.settings.onOffTimeSchedule.offTime===undefined?0:k.settings.onOffTimeSchedule.offTime.length);for(var n=0,o=0;o<r.length;o++,n++){if(k.settings.onOffTimeSchedule.offTime[o]===null||k.settings.onOffTimeSchedule.offTime[o]===undefined){continue}r[n]={hour:0,minute:0,week:0};var p=k.settings.onOffTimeSchedule.offTime[o].day;var l=0;for(var m=0;m<p.length;m++){if(p[m]==="mon"){l+=1}if(p[m]==="tue"){l+=2}if(p[m]==="wed"){l+=4}if(p[m]==="thu"){l+=8}if(p[m]==="fri"){l+=16}if(p[m]==="sat"){l+=32}if(p[m]==="sun"){l+=64}}r[n].hour=k.settings.onOffTimeSchedule.offTime[o].hour;r[n].minute=k.settings.onOffTimeSchedule.offTime[o].minute;r[n].week=l}q.timerList=r;if(typeof g==="function"){g(q)}}},onFailure:function(i){f("getOffTimerList: On Failure");delete i.returnValue;if(typeof h==="function"){e(i,"PGOTL","Power.getOffTimerList returns failure.");h(i)}}});f("Power.getOffTimerList Done")};c.prototype.setDisplayMode=function(g,h,i){f("setDisplayMode: "+JSON.stringify(i));b.Request("luna://com.webos.service.commercial.scapadapter/power",{method:"setDisplayMode",parameters:{displayMode:i.displayMode},onSuccess:function(j){f("setDisplayMode: On Success");if(j.returnValue===true){delete j.returnValue;if(typeof g==="function"){f("setDisplayMode: no need to do any action.");g()}}},onFailure:function(j){f("setDisplayMode: On Failure");delete j.returnValue;if(typeof h==="function"){e(j,"PSDM","Power.setDisplayMode returns failure.");h(j)}}});f("Power.setDisplayMode Done")};c.prototype.executePowerCommand=function(g,h,i){f("executePowerCommand: "+JSON.stringify(i));b.Request("luna://com.webos.service.commercial.scapadapter/power",{method:"executePowerCommand",parameters:{powerCommand:i.powerCommand},onSuccess:function(j){f("executePowerCommand: On Success");delete j.returnValue;if(typeof g==="function"){g()}},onFailure:function(j){f("executePowerCommand: On Failure");delete j.returnValue;if(typeof h==="function"){e(j,"PEPM","Power.executePowerCommand returns failure.");h(j)}}});f("Power.executePowerCommand Done")};c.prototype.setDPMWakeup=function(g,h,i){b.Request("luna://com.webos.service.commercial.scapadapter/power/",{method:"setDPMWakeup",parameters:i,onSuccess:function(j){delete j.returnValue;if(typeof g==="function"){g()}},onFailure:function(j){delete j.returnValue;if(typeof h==="function"){e(j,"PSDW","Power.setDPMWakeup returns failure.");h(j)}}})};c.prototype.getDPMWakeup=function(g,h){b.Request("luna://com.webos.service.commercial.scapadapter/power/",{method:"getDPMWakeup",parameters:{},onSuccess:function(i){delete i.returnValue;if(typeof g==="function"){g(i)}},onFailure:function(i){delete i.returnValue;if(typeof h==="function"){e(i,"PGDW","Power.getDPMWakeup returns failure.");h(i)}}})};c.prototype.setPMMode=function(g,h,i){b.Request("luna://com.webos.service.commercial.scapadapter/power/",{method:"setPMMode",parameters:i,onSuccess:function(j){delete j.returnValue;if(typeof g==="function"){g()}},onFailure:function(j){delete j.returnValue;if(typeof h==="function"){e(j,"PSPM","Power.setPMMode returns failure.");h(j)}}})};c.prototype.getPMMode=function(g,h){b.Request("luna://com.webos.service.commercial.scapadapter/power/",{method:"getPMMode",parameters:{},onSuccess:function(i){delete i.returnValue;if(typeof g==="function"){g(i)}},onFailure:function(i){delete i.returnValue;if(typeof h==="function"){e(i,"PGPM","Power.getPMMode returns failure.");h(i)}}})};c.prototype.setPowerOnDelay=function(g,h,i){b.Request("luna://com.webos.service.commercial.scapadapter/power/",{method:"setPowerOnDelay",parameters:i,onSuccess:function(j){delete j.returnValue;if(typeof g==="function"){g()}},onFailure:function(j){delete j.returnValue;if(typeof h==="function"){e(j,"PSPD","Power.setPowerOnDelay returns failure.");h(j)}}})};c.prototype.getPowerOnDelay=function(g,h){b.Request("luna://com.webos.service.commercial.scapadapter/power/",{method:"getPowerOnDelay",parameters:{},onSuccess:function(i){delete i.returnValue;if(typeof g==="function"){g(i)}},onFailure:function(i){delete i.returnValue;if(typeof h==="function"){e(i,"PGPD","Power.getPowerOnDelay returns failure.");h(i)}}})};c.prototype.getOnOffTimeSchedule=function(g,h){var i={};e(i,"DEPRECATED_API","This function is deprecated.");h(i)};c.prototype.setOnOffTimeSchedule=function(g,h,j){var i={};e(i,"DEPRECATED_API","This function is deprecated.");h(i)};c.prototype.unsetOnOffTimeSchedule=function(g,h){var i={};e(i,"DEPRECATED_API","This function is deprecated.");h(i)};return c}());

/***/ }),
/* 14 */
/***/ (function(module, exports) {

Security=(function(){var Security,service;function log(msg){}
if(typeof window==='object'){cordova.define('cordova/plugin/security',function(require,exports,module){function log(msg){}
var service;if(window.PalmSystem){log("Window.PalmSystem Available");service=require('cordova/plugin/webos/service')}else{service={Request:function(uri,params){log(uri+" invoked. But I am a dummy because PalmSystem is not available");if(typeof params.onFailure==='function'){params.onFailure({returnValue:!1,errorText:"PalmSystem Not Available. Cordova is not installed?"})}}}}
module.exports=Security});Security=cordova.require('cordova/plugin/security')}
else{Security=function(serviceInstance){service=serviceInstance;service.Request=function(serviceUri,reqParams){var commandURI=serviceUri+"/"+reqParams.method;var parameters={};if(reqParams.hasOwnProperty("parameters")===!0)
parameters=reqParams.parameters;var convertedRes={};var callback=function(res){console.log("res : "+JSON.stringify(res));if(res.payload.returnValue===!0){convertedRes=res.payload;reqParams.onSuccess(convertedRes)}else{convertedRes.returnValue=!1;convertedRes.errorCode=res.payload.errorCode;convertedRes.errorText=res.payload.errorText;reqParams.onFailure(convertedRes)}}
if(service){service.call(commandURI,parameters,callback)}}};module.exports=Security}
function checkErrorCodeNText(result,errorCode,errorText){if(result.errorCode===undefined||result.errorCode===null){result.errorCode=errorCode}
if(result.errorText===undefined||result.errorText===null){result.errorText=errorText}}
function isEmpty(val){return val==null}
Security.prototype.registerServerCertificate=function(successCallback,errorCallback,options){log("registerServerCertificate: "+JSON.stringify(options));service.Request("luna://com.webos.service.commercial.signage.storageservice/security/",{method:"registerServerCertificate",parameters:{userName:options.userName,password:options.password,certificate:options.certificate},onSuccess:function(result){log("registerServerCertificate: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){successCallback()}}},onFailure:function(result){log("registerServerCertificate: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SRSC","Security.registerServerCertificate returns failure.");errorCallback(result)}}});log("Security.registerServerCertificate Done")};Security.prototype.unregisterServerCertificate=function(successCallback,errorCallback,options){log("unregisterServerCertificate: "+JSON.stringify(options));service.Request("luna://com.webos.service.commercial.signage.storageservice/security",{method:"unregisterServerCertificate",parameters:{userName:options.userName,password:options.password},onSuccess:function(result){log("unregisterServerCertificate: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){successCallback()}}},onFailure:function(result){log("unregisterServerCertificate: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SUSC","Security.unregisterServerCertificate returns failure.");errorCallback(result)}}});log("Security.unregisterServerCertificate Done")};Security.prototype.existServerCertificate=function(successCallback,errorCallback,options){log("existServerCertificate: "+JSON.stringify(options));service.Request("luna://com.webos.service.commercial.signage.storageservice/security/",{method:"existServerCertificate",parameters:{userName:options.userName,password:options.password},onSuccess:function(result){log("existServerCertificate: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){var cbObj={};cbObj.userName=options.userName;cbObj.exist=result.exist;successCallback(cbObj)}}},onFailure:function(result){log("existServerCertificate: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SESC","Security.existServerCertificate returns failure.");errorCallback(result)}}});log("Security.existServerCertificate Done")};Security.prototype.registerServerCertificateList=function(successCallback,errorCallback,options){log("Security.registerServerCertificateList");var result={};if(isEmpty(errorCallback)||isEmpty(successCallback)){log("Security.registerServerCertificateList returns failure. callback function is undefined.");return}
if(isEmpty(options)||isEmpty(options.serverCertificateList)){checkErrorCodeNText(result,"SRSL","Security.registerServerCertificateList returns failure. there is undefined parameter.");errorCallback(result);return}
service.Request("luna://com.webos.service.commercial.scapadapter/security",{method:"registerServerCertificateList",parameters:{serverCertificateList:options.serverCertificateList},onSuccess:function(result){log("registerServerCertificateList: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){successCallback()}}},onFailure:function(result){log("registerServerCertificateList: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SRSL","Security.registerServerCertificateList returns failure.");errorCallback(result)}}});log("Security.registerServerCertificateList Done")};Security.prototype.unregisterServerCertificateList=function(successCallback,errorCallback,options){log("Security.unregisterServerCertificateList");var result={};if(isEmpty(errorCallback)||isEmpty(successCallback)){log("Security.unregisterServerCertificateList returns failure. callback function is undefined.");return}
if(isEmpty(options)||isEmpty(options.domainNameList)){checkErrorCodeNText(result,"SUSL","Security.unregisterServerCertificateList returns failure. there is undefined parameter.");errorCallback(result);return}
service.Request("luna://com.webos.service.commercial.scapadapter/security",{method:"unregisterServerCertificateList",parameters:{domainNameList:options.domainNameList},onSuccess:function(result){log("unregisterServerCertificateList: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){delete result.returnValue;successCallback(result)}}},onFailure:function(result){log("unregisterServerCertificateList: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SUSL","Security.unregisterServerCertificateList returns failure.");errorCallback(result)}}});log("Security.unregisterServerCertificateList Done")};Security.prototype.unregisterAllServerCertificateList=function(successCallback,errorCallback){log("Security.unregisterAllServerCertificateList");var result={};if(isEmpty(errorCallback)||isEmpty(successCallback)){log("Security.unregisterAllServerCertificateList returns failure. callback function is undefined.");return}
service.Request("luna://com.webos.service.commercial.scapadapter/security",{method:"unregisterAllServerCertificateList",parameters:{},onSuccess:function(result){log("unregisterAllServerCertificateList: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){successCallback()}}},onFailure:function(result){log("unregisterAllServerCertificateList: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SUAL","Security.unregisterAllServerCertificateList returns failure.");errorCallback(result)}}});log("Security.unregisterAllServerCertificateList Done")};Security.prototype.getServerCertificateList=function(successCallback,errorCallback){log("Security.getServerCertificateList");var result={};if(isEmpty(errorCallback)||isEmpty(successCallback)){log("Security.getServerCertificateList returns failure. callback function is undefined.");return}
service.Request("luna://com.webos.service.commercial.scapadapter/security",{method:"getServerCertificateList",parameters:{},onSuccess:function(result){log("getServerCertificateList: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){delete result.returnValue;successCallback(result)}}},onFailure:function(result){log("getServerCertificateList: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SGSL","Security.getServerCertificateList returns failure.");errorCallback(result)}}});log("Security.getServerCertificateList Done")};return Security}())

/***/ }),
/* 15 */
/***/ (function(module, exports) {

Signage=(function(){var Signage,service;function log(msg){}
if(typeof window==='object'){cordova.define('cordova/plugin/signage',function(require,exports,module){var service;Signage=function(){};if(window.PalmSystem){log("Window.PalmSystem Available");service=require('cordova/plugin/webos/service')}
else{log("Window.PalmSystem is NOT Available");service={Request:function(uri,params){log(uri+" invoked. But I am a dummy because PalmSystem is not available");if(typeof params.onFailure==='function'){params.onFailure({returnValue:!1,errorCode:"CORDOVA_ERR",errorText:"PalmSystem Not Available. Cordova is not installed?"})}}}}
module.exports=Signage});Signage=cordova.require('cordova/plugin/signage')}
else{Signage=function(serviceInstance){service=serviceInstance;service.Request=function(serviceUri,reqParams){var commandURI=serviceUri+"/"+reqParams.method;var parameters={};if(reqParams.hasOwnProperty("parameters")===!0)
parameters=reqParams.parameters;var convertedRes={};var callback=function(res){console.log("res : "+JSON.stringify(res));if(res.payload.returnValue===!0){convertedRes=res.payload;reqParams.onSuccess(convertedRes)}else{convertedRes.returnValue=!1;convertedRes.errorCode=res.payload.errorCode;convertedRes.errorText=res.payload.errorText;reqParams.onFailure(convertedRes)}}
if(service){service.call(commandURI,parameters,callback)}}};module.exports=Signage}
var removeSignageEventListener=function(event){var monitorObj=_gSystemMonitoringSetup[event];log(JSON.stringify(monitorObj,null,3));if(monitorObj&&monitorObj.getEvent===!0){if(_gSystemMonitoringSetup[event].listenerObj){_gSystemMonitoringSetup[event].getEvent=!1;_gSystemMonitoringSetup[event].listenerObj=null}}};var addSignageEventListener=function(key,callbackfunction){var monitorSetup=_gSystemMonitoringSetup[key];if(monitorSetup&&typeof monitorSetup.createListener==='function'){monitorSetup.listenerObj=monitorSetup.createListener(callbackfunction);monitorSetup.getEvent=!0}};function getInputValue(inputUri){if(inputUri.substring(0,"ext://".length)!=="ext://"){log("Bad prefix: "+inputUri);return!1}
var body=inputUri.substring("ext://".length);log("body is: "+body);var splited=body.split(":");if(splited.length===2){return splited[0]+splited[1]}
else if(splited.length===1){return splited[0]}
else{log("Bad Syntax: "+inputUri);return!1}}
function isValidEnum(arr,value){for(var key in arr){if(arr[key]===value){return!0}}
return!1}
var SETTINGS_KEY={FAILOVER_MODE:"failover",FAILOVER_BACKUPVIASTORAGE_MODE:"backupViaStorage",FAILOVER_PRIORITY:"failoverPriority",IR_OPERATION_MODE:"enableIrRemote",LOCALKEY_OPERATION_MODE:"enableLocalKey",OSD_PORTRAIT_MODE:"osdPortraitMode",TILE_MODE:"tileMode",TILE_ID:"tileId",TILE_ROW:"tileRow",TILE_COLUME:"tileCol",TILE_NATURALMODE:"naturalMode",DPM_MODE:"dpmMode",AUTOMATIC_STANDBY_MODE:"autoSB",ISM_METHOD:"ismmethod",SES_MODE:"smartEnergy",DO_15OFF_MODE:"15off",MONITOR_FAN:"monitorFan",MONITOR_SIGNAL:"monitorSignal",MONITOR_LAMP:"monitorLamp",MONITOR_SCREEN:"monitorScreen",MONITOR_AUDIO:"monitorAudio",AUDIO_SOURCE_HDMI1:"audioSourceHdmi1",AUDIO_SOURCE_HDMI2:"audioSourceHdmi2",AUDIO_SOURCE_DP:"audioSourceDp"};var monitorTemperature=function(callbackfunction){log("Create Listener for monitorTemperature");var subscribed=service.Request("luna://com.webos.service.commercial.scapadapter",{method:"systemMonitor/getTemperature",parameters:{subscribe:!0},onSuccess:function(result){log("temperature : "+JSON.stringify(result,null,3));if(result.returnValue===!0){var returnData={source:Signage.MonitoringSource.THERMOMETER,type:Signage.EventType.CURRENT_TEMPERATURE,data:{temperature:result.temperature}};if(typeof callbackfunction==='function'){callbackfunction(returnData)}}},onFailure:function(result){log("monitor_temperature : FAIL "+JSON.stringify(result,null,3))}});return subscribed};var monitorFan=function(callbackfunction){log("Create Listener for monitorFan");var subscribed=service.Request("luna://com.webos.service.commercial.scapadapter",{method:"systemMonitor/getFanEvent",parameters:{subscribe:!0},onSuccess:function(result){log("monitor_fan : "+JSON.stringify(result,null,3));if(result.returnValue===!0){var returnData={source:Signage.MonitoringSource.FAN,type:Signage.EventType.FAN_STATUS,data:{status:result.fanFault}};if(typeof callbackfunction==='function'){callbackfunction(returnData)}}},onFailure:function(result){log("monitor_fan : FAIL "+JSON.stringify(result,null,3))}});return subscribed};var monitorLamp=function(callbackfunction){log("Create Listener for monitorLamp");var subscribed=service.Request("luna://com.webos.service.commercial.scapadapter",{method:"systemMonitor/getLampEvent",parameters:{subscribe:!0},onSuccess:function(result){log("monitor_lamp : "+JSON.stringify(result,null,3));if(result.returnValue===!0){var returnData={source:Signage.MonitoringSource.LAMP,type:Signage.EventType.LAMP_STATUS,data:{status:result.lampFault}};if(typeof callbackfunction==='function'){callbackfunction(returnData)}}},onFailure:function(result){log("monitor_lamp : FAIL "+JSON.stringify(result,null,3))}});return subscribed};var monitorSignal=function(callbackfunction){log("Create Listener for monitorSignal");var subscribed=service.Request("luna://com.webos.service.commercial.scapadapter",{method:"systemMonitor/getSignalEvent",parameters:{subscribe:!0},onSuccess:function(result){log("monitor_signal : "+JSON.stringify(result,null,3));if(result.returnValue===!0){var returnData={type:Signage.EventType.SIGNAL_STATUS,source:Signage.MonitoringSource.SIGNAL,data:{}};if(result.noSignal===!0){returnData.data.status="no_signal"}
else{returnData.data.status="signal_available"}
if(typeof callbackfunction==='function'){callbackfunction(returnData)}}},onFailure:function(result){log("monitor_signal : FAIL "+JSON.stringify(result,null,3))}});return subscribed};var monitorScreen=function(callbackfunction){log("Create Listener for monitorScreen");var subscribed=service.Request("luna://com.webos.service.commercial.scapadapter",{method:"systemMonitor/getScreenEvent",parameters:{subscribe:!0},onSuccess:function(result){log("monitor_screen : "+JSON.stringify(result,null,3));if(result.returnValue===!0){var returnData={source:Signage.MonitoringSource.SCREEN,type:Signage.EventType.SCREEN_STATUS,data:{status:result.screen}};if(typeof callbackfunction==='function'){callbackfunction(returnData)}}},onFailure:function(result){log("monitor_screen FAIL : "+JSON.stringify(result,null,3))}});return subscribed};function addSubscriptionEventInfo(eventName,instanceOfSubscription,eventlistener){if(_gSubscriptionEventInfo.hasOwnProperty(eventName)===!1){_gSubscriptionEventInfo[eventName]={};_gSubscriptionEventInfo[eventName].instanceOfSubscription=instanceOfSubscription;_gSubscriptionEventInfo[eventName].eventListener=eventlistener}else{_gSubscriptionEventInfo[eventName].instanceOfSubscription=instanceOfSubscription;_gSubscriptionEventInfo[eventName].eventListener=eventlistener}
return!0}
function removeSubscriptionEventInfo(eventName){if(_gSubscriptionEventInfo.hasOwnProperty(eventName)===!1){return!1}else if(_gSubscriptionEventInfo[eventName].instanceOfSubscription===null){return!1}else{_gSubscriptionEventInfo[eventName].instanceOfSubscription.cancel();_gSubscriptionEventInfo[eventName].instanceOfSubscription=null;_gSubscriptionEventInfo[eventName].eventListener=null;return!0}}
function getSubscriptionEventInfo(eventName){if(_gSubscriptionEventInfo.hasOwnProperty(eventName)===!1){return!1}else{return _gSubscriptionEventInfo[eventName]}}
var monitorRS232C=function(successCallback,errorCallback,eventListener){log("Create Listener for monitorRS232C");var req=service.Request("luna://com.webos.service.commercial.scapadapter",{method:"systemMonitor/startMonitorRS232C",parameters:{subscribe:!0},onSuccess:function(result){log("monitorRS232C success : "+JSON.stringify(result,null,3));if(result.returnValue===!0){if(Object.keys(result).length===1){addSubscriptionEventInfo('RS232C',req,eventListener);successCallback()}else if(result.hasOwnProperty('data')===!0){var subEventInfo=getSubscriptionEventInfo('RS232C');if(subEventInfo===!1){errorCallback({errorCode:"INTERNAL_ERROR",errorText:"There is not subscriptionEventInfo"})}else{if(typeof subEventInfo.eventListener==='function'){subEventInfo.eventListener({data:result.data})}}}else{errorCallback({errorCode:"INTERNAL_ERROR",errorText:"Unknown return value"})}
return}},onFailure:function(result){log("monitorRS232C fail : "+JSON.stringify(result,null,3));errorCallback({errorCode:"LUNA_ERROR",errorText:"Failed to request getRS232CEvent to system"})}})};var _gSystemMonitoringSetup={fan:{getEvent:!1,listenerObj:null,createListener:monitorFan},screen:{getEvent:!1,listenerObj:null,createListener:monitorScreen},temperature:{getEvent:!1,listenerObj:null,createListener:monitorTemperature},signal:{getEvent:!1,listenerObj:null,createListener:monitorSignal},lamp:{getEvent:!1,listenerObj:null,createListener:monitorLamp}};var _gSubscriptionEventInfo={RS232C:{instanceOfSubscription:null,eventListener:null}};var _gTileInfo={row:0,col:0};Signage.UNDEFINED='___undefined___';Signage.OsdPortraitMode={ON:"90",OFF:"off"};Signage.ImgResolution={HD:"HD",FHD:"FHD",};Signage.AutomaticStandbyMode={OFF:"off",STANDBY_4HOURS:"4hours"};Signage.IsmMethod={NORMAL:"NORMAL",ORBITER:"ORBITER",INVERSION:"INVERSION",COLORWASH:"COLORWASH",WHITEWASH:"WHITEWASH",WASHING_BAR:"WASHINGBAR",USER_IMAGE:"USERIMAGE",USER_VIDEO:"USERVIDEO"};Signage.FailoverMode={OFF:"off",AUTO:"auto",MANUAL:"manual"};Signage.DigitalAudioInput={HDMI_DP:"hdmi",AUDIO_IN:"audioIn"};Signage.DpmMode={OFF:"off",POWER_OFF_5SECOND:"5sec",POWER_OFF_10SECOND:"10sec",POWER_OFF_15SECOND:"15sec",POWER_OFF_1MINUTE:"1min",POWER_OFF_3MINUTE:"3min",POWER_OFF_5MINUTE:"5min",POWER_OFF_10MINUTE:"10min"};Signage.KeyOperationMode={ALLOW_ALL:"normal",POWER_ONLY:"usePwrOnly",BLOCK_ALL:"blockAll"};Signage.EventType={CURRENT_TEMPERATURE:"CURRENT_TEMPERATURE",FAN_STATUS:"FAN_STATUS",LAMP_STATUS:"LAMP_STATUS",SCREEN_STATUS:"SCREEN_STATUS",SIGNAL_STATUS:"SIGNAL_STATUS"};Signage.MonitoringSource={FAN:"FAN",LAMP:"LAMP",SIGNAL:"SIGNAL",SCREEN:"SCREEN",THERMOMETER:"THERMOMETER"};Signage.KeyCode={DISC_POWER_OFF:0x02C2,DISC_POWER_ON:0x02C1,ENERGY_SAVING:0x02C5,INPUT:0x02C8,LG_3D:0x02E1,NUM_0:0x0030,NUM_1:0x0031,NUM_2:0x0032,NUM_3:0x0033,NUM_4:0x0034,NUM_5:0x0035,NUM_6:0x0036,NUM_7:0x0037,NUM_8:0x0038,NUM_9:0x0039,OPT_1aA:0x044F,CLEAR:0x0008,POWER:0x0199,VOL_UP:0x01BF,VOL_DOWN:0x01C0,MUTE:0x01C1,RATIO:0x002D2,AUTO:0x0044E,BRIGHTNESS_UP:0x0044C,BRIGHTNESS_DOWN:0x0044D,PSM:0x00454,SMART_HOME:0x02DE,WBAL:0x0451,MENU:0x0273,SMENU:0x0452,LEFT:0x0025,UP:0x0026,RIGHT:0x0027,DOWN:0x0028,ENTER:0x000A,BACK:0x0260,EXIT:0x0259,SIMPLINK:0x02D4,TILE:0x0453,STOP:0x019D,REWIND:0x019C,PLAY:0x019F,PAUSE:0x0013,FAST_FORWARD:0x01A1,RED:0x0193,GREEN:0x0194,YELLOW:0x0195,BLUE:0x0196,INFO:0x0455};function checkErrorCodeNText(result,errorCode,errorText){if(result.errorCode===undefined||result.errorCode===null){result.errorCode=errorCode}
if(result.errorText===undefined||result.errorText===null){result.errorText=errorText}}
function getSystemSettings(category,keys,cbObjectGetter,successCallback,errorCallback){var params={category:category,keys:keys};service.Request("luna://com.webos.service.commercial.scapadapter/settings/",{method:"get",parameters:params,onSuccess:function(result){log("On Success");if(result.returnValue===!0){var cbObj=cbObjectGetter(result.settings);if(cbObj===!1){if(typeof errorCallback==='function'){errorCallback({errorText:"Invalid DB value",errorCode:"DB_ERROR"})}}
else{if(typeof successCallback==='function'){log("successCallback");successCallback(cbObj)}
else{log("successCallback not registered or is not a function: "+successCallback)}}}
else{log("Settings Failed:  "+JSON.stringify(result,null,3));if(typeof errorCallback==='function'){errorCallback({errorText:"Invalid DB value : "+result.errorText,errorCode:"DB_ERROR"})}}},onFailure:function(result){log("On Failure");delete result.returnValue;if(result.settings){log("settings = "+JSON.stringify(result.settings,null,3));var cbObject=cbObjectGetter(result.settings);log("errorKey = "+JSON.stringify(result.errorKey,null,3));for(var i=0;i<result.errorKey.length;++i){cbObject[result.errorKey[i]]=Signage.UNDEFINED}
log("cbObj = "+JSON.stringify(cbObject,null,3));if(typeof successCallback==='function'){log("successCallback");successCallback(cbObject)}}
else{if(typeof errorCallback==='function'){errorCallback({errorText:((typeof result.errorText==='undefined')?"DB Failure":result.errorText),errorCode:"DB_ERROR"})}}}});log("Requested Service: "+"luna://com.webos.service.commercial.scapadapter/settings/");log("params : "+JSON.stringify(params))}
function setSystemSettings(category,settings,successCallback,errorCallback){var params={category:category,settings:settings};log("settings : "+JSON.stringify(settings,null,3));var hasKey=!1;for(var key in settings){if(key){log("has key : "+key);hasKey=!0;break}}
if(hasKey===!1){log("Nothing to set");successCallback();return}
service.Request("luna://com.webos.service.commercial.scapadapter/settings/",{method:"set",parameters:params,onSuccess:function(){log("On Success");if(typeof successCallback==='function'){log("SUCCEES CALLBACK");successCallback()}},onFailure:function(result){log("On Failure");delete result.returnValue;if(typeof errorCallback==='function'){log("ERROR CALLBACK");errorCallback(result)}}});log("Requested Service: "+"luna://com.webos.service.commercial.scapadapter/settings/");log("params : "+JSON.stringify(params))}
Signage.prototype.setPortraitMode=function(successCallback,errorCallback,options){var settings={};var errorMessage;function checkOptions(options){if(options.portraitMode){for(var key in Signage.OsdPortraitMode){if(options.portraitMode===Signage.OsdPortraitMode[key]){return!0}}
errorMessage="Signage.setPortraitMode: Unrecognized OsdPortraintMode : "+options.portraitMode;return!1}
else{errorMessage="Signage.setPortraitMode: portraitMode does not exist.";return!1}}
if(checkOptions(options)){var portraintModeStr=options.portraitMode;settings[SETTINGS_KEY.OSD_PORTRAIT_MODE]=portraintModeStr;service.Request("luna://com.webos.service.commercial.scapadapter",{method:"setOsdPortraitMode",parameters:{osdPortraitMode:options.portraitMode},onSuccess:function(result){successCallback()},onFailure:function(error){if(error.errorText.indexOf('Unknown method')!==-1){setSystemSettings("commercial",settings,successCallback,errorCallback)}
else{errorCallback({errorCode:error.errorCode,errorText:error.errorText})}}});log("setPortraitMode Done")}
else{errorCallback({errorCode:"BAD_PARAMETER",errorText:errorMessage})}};Signage.prototype.setFailoverMode=function(successCallback,errorCallback,options){service.Request("luna://com.webos.service.commercial.scapadapter/signage",{method:"setFailoverMode",parameters:options,onSuccess:function(result){log("onSuccess");delete result.returnValue;successCallback()},onFailure:function(result){log("onFailure");delete result.returnValue;errorCallback(result)}})};Signage.prototype.getFailoverMode=function(successCallback,errorCallback){service.Request("luna://com.webos.service.commercial.scapadapter/signage",{method:"getFailoverMode",parameters:{},onSuccess:function(result){delete result.returnValue;successCallback({priority:result.priority,mode:result.mode})},onFailure:function(result){delete result.returnValue;errorCallback(result)}})};Signage.prototype.setTileInfo=function(successCallback,errorCallback,options){service.Request("luna://com.webos.service.commercial.scapadapter/signage",{method:"setTileInfo",parameters:options,onSuccess:function(result){log("onSuccess");delete result.returnValue;successCallback()},onFailure:function(result){log("onFailure");delete result.returnValue;errorCallback(result)}})};function getBooleanValue(value){if(value==='on'){return!0}
else{return!1}}
Signage.prototype.getTileInfo=function(successCallback,errorCallback){service.Request("luna://com.webos.service.commercial.scapadapter/signage",{method:"getTileInfo",parameters:{},onSuccess:function(result){if(typeof successCallback==='function'){delete result.returnValue;successCallback(result)}},onFailure:function(result){delete result.returnValue;if(typeof errorCallback==='function'){errorCallback(result)}}})};Signage.prototype.getSignageInfo=function(successCallback,errorCallback){service.Request("luna://com.webos.service.commercial.scapadapter/",{method:"getSignageInformation",parameters:{},onSuccess:function(res){if(typeof successCallback==='function'){log(res.signageInfo);if(typeof res.signageInfo.digitalAudioInputMode!=='undefined')
{var digitalAudioInputMode=Signage.DigitalAudioInput.HDMI_DP;if(res.signageInfo.digitalAudioInputMode.hasOwnProperty('ext://HDMI:1'))
digitalAudioInputMode=res.signageInfo.digitalAudioInputMode['ext://HDMI:1'];else if(res.signageInfo.digitalAudioInputMode.hasOwnProperty('ext://hdmi:1'))
digitalAudioInputMode=res.signageInfo.digitalAudioInputMode['ext://hdmi:1'];res.signageInfo.digitalAudioInputMode=digitalAudioInputMode}
successCallback(res.signageInfo)}},onFailure:function(result){delete result.returnValue;if(typeof errorCallback==='function'){errorCallback(result)}}})};Signage.prototype.enableCheckScreen=function(successCallback,errorCallback,options){var errorMessage;var checkOptions=function(options){if(typeof options.checkScreen!=="undefined"||options.checkScreen!==null){return!0}else{errorMessage="need options.checkScreen.";return!1}};if(checkOptions(options)){service.Request("luna://com.webos.service.commercial.scapadapter",{method:"signage/enableCheckScreen",parameters:options,onSuccess:function(result){if(typeof successCallback==='function'){successCallback()}},onFailure:function(result){delete result.returnValue;if(typeof errorCallback==='function'){errorCallback(result)}}});log("enableCheckScreen Done")}else{var cbObj={errorCode:"BAD_PARAMETER",errorText:errorMessage};errorCallback(cbObj)}};Signage.prototype.setIsmMethod=function(successCallback,errorCallback,options){service.Request("luna://com.webos.service.commercial.scapadapter/signage/",{method:"setIsmMethod",parameters:options,onSuccess:function(result){log("setIsmMethod: On Success");if(typeof successCallback==='function'){successCallback()}},onFailure:function(result){log("setIsmMethod: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"CSIM","Configuration.setIsmMethod returns failure.");errorCallback(result)}}})};Signage.prototype.setDigitalAudioInputMode=function(successCallback,errorCallback,options){var errorMessage;function checkOptions(options){if(options.hasOwnProperty('digitalAudioInputList')){return!1}else if(options.hasOwnProperty('digitalAudioInput')){return!0}else{errorMessage="digitalAudioInputList  does not exist.";return!1}}
if(checkOptions(options)){service.Request("luna://com.webos.service.commercial.scapadapter/",{method:"setDigitalAudioInputList",parameters:{digitalAudioInputList:{'ext://hdmi:1':options.digitalAudioInput}},onSuccess:function(){if(typeof successCallback==='function'){successCallback()}},onFailure:function(result){delete result.returnValue;if(typeof errorCallback==='function'){errorCallback(result)}}})}else{var cbObj={errorCode:"BAD_PARAMETER",errorText:errorMessage};errorCallback(cbObj)}};var _gDoBlock=!1;Signage.prototype.registerSystemMonitor=function(successCallback,errorCallback,options){var keys=['fan','signal','lamp','screen','temperature'];var errorMessage;var errorCode="BAD_PARAMETER";log("Listeners are: "+JSON.stringify(_gSystemMonitoringSetup,null,3));function checkOptions(options){if(_gDoBlock===!0){errorMessage="Not ready to register monitor now.";errorCode="SYSTEM_ERROR";return!1}
log("options are: "+JSON.stringify(options,null,3));if(typeof options.eventHandler!=='function'){errorMessage="No event handler was given or event hadnler is not a function";return!1}
if(options.monitorConfiguration){for(var key in options.monitorConfiguration){if(key){var found=!1;for(var i=0;i<keys.length;++i){if(key===keys[i]){log("Found key: "+keys[i]);found=!0}}
if(!found){errorMessage="Invalid Monitoring source  : "+key;return!1}
var value=options.monitorConfiguration[key];log("value: "+value);if(typeof value!=='boolean'){errorMessage="Invalid value  : "+value;return!1}}}
return!0}
else{errorMessage="monitorConfiguration  does not exist.";return!1}}
if(checkOptions(options)){var cancelSuccess=function(){log("Canceled all previous message subscriptions");var handler=options.eventHandler;for(var key in options.monitorConfiguration){if(key){var value=options.monitorConfiguration[key];if(value===!0){log("Add listener for : "+key);addSignageEventListener(key,handler)}}}
log("Monitoring Setup : "+JSON.stringify(_gSystemMonitoringSetup,null,3));log("Start Polling : ");service.Request("luna://com.webos.service.commercial.scapadapter",{method:"systemMonitor/startMonitor",parameters:{},onSuccess:function(result){log("On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){successCallback()}}
else{if(typeof errorCallback==='function'){errorCallback(result)}}
_gDoBlock=!1},onFailure:function(result){log("On Failure");delete result.returnValue;if(typeof errorCallback==='function'){errorCallback(result)}
_gDoBlock=!1}})};var cancelError=function(result){errorCallback(result)};log("Cancel all previous message subscriptions");_gDoBlock=!0;cancelAllSubscription(cancelSuccess,cancelError)}
else{var cbObj={errorCode:errorCode,errorText:errorMessage};errorCallback(cbObj)}};Signage.prototype.unregisterSystemMonitor=function(successCallback,errorCallback){cancelAllSubscription(successCallback,errorCallback);log("After unregister, _gSystemMonitoringSetup are: "+JSON.stringify(_gSystemMonitoringSetup,null,3))};function cancelAllSubscription(successCallback,errorCallback){log("cancelAllSubscription> setup are: "+JSON.stringify(_gSystemMonitoringSetup,null,3));for(var key in _gSystemMonitoringSetup){if(key){removeSignageEventListener(key)}}
log("Stop Polling");service.Request("luna://com.webos.service.commercial.scapadapter",{method:"systemMonitor/stopMonitor",parameters:{},onSuccess:function(result){log("On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){successCallback()}}
else{if(typeof errorCallback==='function'){errorCallback(result)}}},onFailure:function(result){log("On Failure");delete result.returnValue;if(typeof errorCallback==='function'){errorCallback(result)}}})}
Signage.prototype.getSystemMonitoringInfo=function(successCallback,errorCallback){if(_gSystemMonitoringSetup){successCallback({fan:_gSystemMonitoringSetup.fan.getEvent,signal:_gSystemMonitoringSetup.signal.getEvent,lamp:_gSystemMonitoringSetup.lamp.getEvent,screen:_gSystemMonitoringSetup.screen.getEvent,temperature:_gSystemMonitoringSetup.temperature.getEvent})}
else{var cbObj={errorCode:"ERROR",errorText:"Failed to get system monitoring setup"};errorCallback(cbObj)}};Signage.prototype.setPowerSaveMode=function(successCallback,errorCallback,options){var errorMessage;function checkOptions(options){if(options.powerSaveMode){for(var key in options.powerSaveMode){if(key){var value=options.powerSaveMode[key];if(key==='ses'||key==='do15MinOff'){if(typeof value!=='boolean'){errorMessage="Invalid value  : "+value;return!1}}
else if(key==='automaticStandby'){if(!isValidEnum(Signage.AutomaticStandbyMode,value)){errorMessage="Invalid automaticStandby value  : "+value;return!1}}
else if(key==='dpmMode'){if(!isValidEnum(Signage.DpmMode,value)){errorMessage="Invalid dpmMode value  : "+value;return!1}}
else{errorMessage="Unknown value  : "+key;return!1}}}
return!0}
else{errorMessage="powerSaveMode  does not exist.";return!1}}
if(checkOptions(options)){log(options.powerSaveMode);service.Request("luna://com.webos.service.commercial.scapadapter",{method:"setPowerSaveMode",parameters:{mode:options.powerSaveMode},onSuccess:function(result){log("onSuccess");if(result.returnValue){successCallback(result.mode)}
else{log("FAILED: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){log("onFailure");log("FAILED: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})}
else{var cbObj={errorCode:"BAD_PARAMETER",errorText:errorMessage};errorCallback(cbObj)}};Signage.prototype.getPowerSaveMode=function(successCallback,errorCallback){service.Request("luna://com.webos.service.commercial.scapadapter",{method:"getPowerSaveMode",parameters:{},onSuccess:function(result){log("onSuccess");if(result.returnValue){successCallback(result.mode)}
else{log("FAILED: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){log("onFailure");log("FAILED: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})};Signage.prototype.setUsagePermission=function(successCallback,errorCallback,options){service.Request("luna://com.webos.service.commercial.scapadapter/signage/",{method:"setUsagePermission",parameters:options,onSuccess:function(result){delete result.returnValue;if(typeof successCallback==='function'){successCallback()}},onFailure:function(result){delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SSUP","Signage.setUsagePermission returns failure.");errorCallback(result)}}})};Signage.prototype.getUsagePermission=function(successCallback,errorCallback){service.Request("luna://com.webos.service.commercial.scapadapter/signage/",{method:"getUsagePermission",parameters:{},onSuccess:function(result){delete result.returnValue;if(typeof successCallback==='function'){successCallback(result)}},onFailure:function(result){delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SGUP","Signage.getUsagePermission returns failure.");errorCallback(result)}}})};Signage.prototype.getUsageData=function(successCallback,errorCallback){service.Request("luna://com.webos.service.commercial.scapadapter/signage",{method:"getUsageData",parameters:{},onSuccess:function(result){console.log("On getUsageData Success");delete result.returnValue;successCallback(result)},onFailure:function(result){console.log("On getUsageData Failure");delete result.returnValue;errorCallback(result)}})};Signage.prototype.captureScreen=function(successCallback,errorCallback,options){var param={save:(options===undefined||options===null||options.save===undefined?!1:options.save)};if(options!==undefined&&options!==null&&options.thumbnail!==undefined&&options.thumbnail===!0){param.width=128;param.height=72}
else if(options.imgResolution===Signage.ImgResolution.FHD){param.width=1920;param.height=1080}
else{param.width=1280;param.height=720}
service.Request("luna://com.webos.service.commercial.scapadapter",{method:"captureScreen",parameters:param,onSuccess:function(result){log("On Success");if(result.returnValue===!0){successCallback({data:result.data,size:result.size,encoding:result.encoding})}
else{errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){log("On Failure");errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})};Signage.prototype.setIntelligentAuto=function(successCallback,errorCallback,options){service.Request("luna://com.webos.service.commercial.scapadapter/signage/",{method:"setIntelligentAuto",parameters:{enabled:options.enabled},onSuccess:function(result){log("setIntelligentAuto: On Success");delete result.returnValue;if(typeof successCallback==='function'){successCallback()}},onFailure:function(result){log("setIntelligentAuto: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SSIA","Signage.setIntelligentAuto returns failure.");errorCallback(result)}}})};Signage.prototype.getIntelligentAuto=function(successCallback,errorCallback){service.Request("luna://com.webos.service.commercial.scapadapter/signage/",{method:"getIntelligentAuto",parameters:{},onSuccess:function(result){log("getIntelligentAuto: On Success");delete result.returnValue;if(typeof successCallback==='function'){successCallback()}},onFailure:function(result){log("getIntelligentAuto: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SGIA","Signage.getIntelligentAuto returns failure.");errorCallback(result)}}})};Signage.prototype.setStudioMode=function(successCallback,errorCallback,options){var ret={};checkErrorCodeNText(ret,"DEPRECATED_API","This function is deprecated.");errorCallback(ret)};Signage.prototype.getStudioMode=function(successCallback,errorCallback){var ret={};checkErrorCodeNText(ret,"DEPRECATED_API","This function is deprecated.");errorCallback(ret)};Signage.prototype.setLanDaisyChain=function(successCallback,errorCallback,options){service.Request("luna://com.webos.service.commercial.scapadapter/signage/",{method:"setLanDaisyChain",parameters:options,onSuccess:function(result){log("setLanDaisyChain: On Success");delete result.returnValue;if(typeof successCallback==='function'){successCallback()}},onFailure:function(result){log("setLanDaisyChain: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SSLD","Signage.setLanDaisyChain returns failure.");errorCallback(result)}}})};Signage.prototype.getLanDaisyChain=function(successCallback,errorCallback){service.Request("luna://com.webos.service.commercial.scapadapter/signage/",{method:"getLanDaisyChain",parameters:{},onSuccess:function(result){log("getLanDaisyChain: On Success");delete result.returnValue;if(typeof successCallback==='function'){successCallback()}},onFailure:function(result){log("getLanDaisyChain: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SGLD","Signage.getLanDaisyChain returns failure.");errorCallback(result)}}})};Signage.prototype.registerRS232CEventListener=function(successCallback,errorCallback,options){if(typeof options.eventListener!=='function'){var cbObj={errorCode:"BAD_PARAMETER",errorText:"No event listener was given or event listener is not a function"};errorCallback(cbObj);return!1}
monitorRS232C(successCallback,errorCallback,options.eventListener)};Signage.prototype.unregisterRS232CEventListener=function(successCallback,errorCallback){if(removeSubscriptionEventInfo('RS232C')===!1){if(typeof errorCallback==='function'){errorCallback({errorCode:"BAD_PARAMETER",errorText:"Failed to remove event listener"})}
return}else{service.Request("luna://com.webos.service.commercial.scapadapter",{method:"systemMonitor/stopMonitorRS232C",parameters:{},onSuccess:function(result){log("On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){successCallback()}}else{if(typeof errorCallback==='function'){errorCallback(result)}}},onFailure:function(result){log("On Failure");delete result.returnValue;if(typeof errorCallback==='function'){errorCallback(result)}}})}};Signage.prototype.addEventListener=addSignageEventListener;Signage.prototype.removeEventListener=removeSignageEventListener;return Signage}())

/***/ }),
/* 16 */
/***/ (function(module, exports) {

Sound=(function(){var Sound,service;function log(msg){}
if(typeof window==='object'){cordova.define('cordova/plugin/sound',function(require,exports,module){Sound=function(){};var service;if(window.PalmSystem){log("Window.PalmSystem Available");service=require('cordova/plugin/webos/service')}else{service={Request:function(uri,params){log(uri+" invoked. But I am a dummy because PalmSystem is not available");if(typeof params.onFailure==='function'){params.onFailure({returnValue:!1,errorText:"PalmSystem Not Available. Cordova is not installed?"})}}}}
module.exports=Sound});Sound=cordova.require('cordova/plugin/sound')}
else{Sound=function(serviceInstance){service=serviceInstance;service.Request=function(serviceUri,reqParams){var commandURI=serviceUri+"/"+reqParams.method;var parameters={};if(reqParams.hasOwnProperty("parameters")===!0)
parameters=reqParams.parameters;var convertedRes={};var callback=function(res){console.log("res : "+JSON.stringify(res));if(res.payload.returnValue===!0){convertedRes=res.payload;reqParams.onSuccess(convertedRes)}else{convertedRes.returnValue=!1;convertedRes.errorCode=res.payload.errorCode;convertedRes.errorText=res.payload.errorText;reqParams.onFailure(convertedRes)}}
if(service){service.call(commandURI,parameters,callback)}}};module.exports=Sound}
function checkErrorCodeNText(result,errorCode,errorText){if(result.errorCode===undefined||result.errorCode===null){result.errorCode=errorCode}
if(result.errorText===undefined||result.errorText===null){result.errorText=errorText}}
Sound.SoundMode={Standard:"standard",Cinema:"movie",ClearVoice:"news",Sports:"sports",Music:"music",Game:"game"};Sound.SpeakerType={SignageSpeaker:"tv_speaker",LGSoundSync:"bt_soundbar"};Sound.prototype.getSoundStatus=function(successCallback,errorCallback){log("getSoundStatus: ");service.Request("luna://com.webos.service.commercial.scapadapter/sound",{method:"getSoundStatus",onSuccess:function(result){if(result.returnValue===!0){delete result.returnValue;successCallback(result)}},onFailure:function(result){delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SGSS","Sound.getSoundStatus returns failure.");errorCallback(result)}}});log("Sound.getSoundStatus Done")};Sound.prototype.setVolumeLevel=function(successCallback,errorCallback,options){log("setVolumeLevel: "+JSON.stringify(options));service.Request("luna://com.webos.service.commercial.scapadapter/sound",{method:"setVolumeLevel",parameters:{level:options.level,volOsdEnabled:options.volOsdEnabled},onSuccess:function(result){log("setVolumeLevel: On Success");delete result.returnValue;if(typeof successCallback==='function')
successCallback()},onFailure:function(result){log("setVolumeLevel: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SSVL","Sound.setVolumeLevel returns failure.");errorCallback(result)}}});log("Sound.setVolumeLevel Done")};Sound.prototype.setExternalSpeaker=function(successCallback,errorCallback,options){service.Request("luna://com.webos.service.commercial.scapadapter/sound",{method:"setExternalSpeaker",parameters:options,onSuccess:function(result){log("setExternalSpeaker: On Success");delete result.returnValue;if(typeof successCallback==='function'){successCallback()}},onFailure:function(result){log("setExternalSpeaker: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SSES","Sound.setExternalSpeaker returns failure.");errorCallback(result)}}})};Sound.prototype.setMuted=function(successCallback,errorCallback,options){service.Request("luna://com.webos.service.commercial.scapadapter/sound",{method:"setMuted",parameters:{muted:options.muted},onSuccess:function(result){log("setMuted: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){successCallback()}}},onFailure:function(result){log("setMuted: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SSM","Sound.setMuted returns failure.");errorCallback(result)}}})};Sound.prototype.setSoundMode=function(successCallback,errorCallback,options){service.Request("luna://com.webos.service.commercial.scapadapter/sound",{method:"setSoundMode",parameters:options,onSuccess:function(result){log("setSoundMode: On Success");delete result.returnValue;if(typeof successCallback==='function'){successCallback()}},onFailure:function(result){log("setSoundMode: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SSSM","Sound.setSoundMode returns failure.");errorCallback(result)}}})};Sound.prototype.getSoundMode=function(successCallback,errorCallback){service.Request("luna://com.webos.service.commercial.scapadapter/sound",{method:"getSoundMode",onSuccess:function(result){if(result.returnValue===!0){delete result.returnValue;successCallback(result)}},onFailure:function(result){delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SGSM","Sound.getSoundMode returns failure.");errorCallback(result)}}})};Sound.prototype.setSoundOut=function(successCallback,errorCallback,options){service.Request("luna://com.webos.service.commercial.scapadapter/sound",{method:"setSoundOut",parameters:options,onSuccess:function(result){log("setSoundOut: On Success");delete result.returnValue;if(typeof successCallback==='function'){successCallback()}},onFailure:function(result){log("setSoundOut: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SSSO","Sound.setSoundOut returns failure.");errorCallback(result)}}})};Sound.prototype.getSoundOut=function(successCallback,errorCallback){service.Request("luna://com.webos.service.commercial.scapadapter/sound",{method:"getSoundOut",onSuccess:function(result){if(result.returnValue===!0){delete result.returnValue;successCallback(result)}},onFailure:function(result){delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"SGSO","Sound.getSoundOut returns failure.");errorCallback(result)}}})};return Sound}())

/***/ }),
/* 17 */
/***/ (function(module, exports) {

Storage=(function(){var Storage,service;function log(msg){}
if(typeof window==='object'){cordova.define('cordova/plugin/storage',function(require,exports,module){Storage=function(){};if(window.PalmSystem){log("Window.PalmSystem Available");service=require('cordova/plugin/webos/service')}else{service={Request:function(uri,params){log(uri+" invoked. But I am a dummy because PalmSystem is not available");if(typeof params.onFailure==='function'){params.onFailure({returnValue:!1,errorText:"PalmSystem Not Available. Cordova is not installed?"})}}}}
module.exports=Storage});Storage=cordova.require('cordova/plugin/storage')}
else{Storage=function(serviceInstance){service=serviceInstance;service.Request=function(serviceUri,reqParams){var commandURI=serviceUri+"/"+reqParams.method;var parameters={};if(reqParams.hasOwnProperty("parameters")===!0)
parameters=reqParams.parameters;var convertedRes={};var callback=function(res){console.log("res : "+JSON.stringify(res));if(res.payload.returnValue===!0){convertedRes=res.payload;reqParams.onSuccess(convertedRes)}else{convertedRes.returnValue=!1;convertedRes.errorCode=res.payload.errorCode;convertedRes.errorText=res.payload.errorText;reqParams.onFailure(convertedRes)}}
if(service){service.call(commandURI,parameters,callback)}}};module.exports=Storage}
function checkErrorCodeNText(result,errorCode,errorText){if(result.errorCode===undefined||result.errorCode===null){result.errorCode=errorCode}
if(result.errorText===undefined||result.errorText===null){result.errorText=errorText}}
function isValidFileURI(uri){if(uri){if(uri.indexOf("://")===-1){log("INVALID URI"+uri);return!1}else{log("GOOD URI");return!0}}else{log("NO URI"+uri);return!1}}
Error.ERROR_CODE={IO_ERROR:"IO_ERROR",DEVICE_ERROR:"DEVICE_ERROR",BAD_PARAMETER:"BAD_PARAMETER",SERVER_ERROR:"SERVER_ERROR",NETWORK_ERROR:"NETWORK_ERROR",SYSTEM_ERROR:"SYSTEM_ERROR",};Storage.SCAP_URI="";Storage.MAX_BUFFER_LENGTH=1024*10;Storage.AppMode={USB:"usb",LOCAL:"local"};Storage.AppType={IPK:"ipk",ZIP:"zip"};Storage.prototype.downloadFirmware=function(successCallback,errorCallback,options){service.Request("luna://com.webos.service.commercial.scapadapter",{method:"downloadFirmware",parameters:{uri:options.uri},onSuccess:function(result){if(result.returnValue===!0){successCallback()}else{errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})};Storage.prototype.upgradeFirmware=function(successCallback,errorCallback){service.Request("luna://com.webos.service.commercial.scapadapter",{method:"upgradeFirmware",parameters:{},onSuccess:function(result){if(result.returnValue===!0){successCallback()}else{errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})};Storage.prototype.getFirmwareUpgradeStatus=function(successCallback,errorCallback){service.Request("luna://com.webos.service.commercial.scapadapter",{method:"getFirmwareUpgradeStatus",parameters:{},onSuccess:function(result){if(result.returnValue===!0){successCallback({status:result.status,upgradeProgress:result.upgradeProgress,downloadProgress:result.downloadProgress})}else{errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})};Storage.prototype.changeLogoImage=function(successCallback,errorCallback,options){service.Request("luna://com.webos.service.commercial.scapadapter",{method:"changeLogoImage",parameters:{uri:options.uri},onSuccess:function(result){if(result.returnValue===!0){successCallback()}else{errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})};Storage.prototype.upgradeApplication=function(successCallback,errorCallback,options){var param={from:'remote',to:(options===undefined||options===null?Storage.AppMode.LOCAL:options.to),recovery:(options===undefined||options===null?!1:options.recovery),};if(options.hasOwnProperty('type')===!0&&options.type!==undefined)
param.type=options.type;service.Request("luna://com.webos.service.commercial.scapadapter",{method:"upgradeApplication",parameters:param,onSuccess:function(result){if(result.returnValue===!0){successCallback()}else{errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})};Storage.prototype.removeApplication=function(successCallback,errorCallback,options){service.Request("luna://com.webos.service.commercial.scapadapter",{method:"removeApplication",parameters:{to:options.to},onSuccess:function(result){if(result.returnValue===!0){successCallback()}else{errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})};Storage.prototype.copyFile=function(successCallback,errorCallback,options){log("Options: "+JSON.stringify(options,null,3));if(options.maxRedirection&&options.maxRedirection>5){log("Bad options TOO MANY REDIRECTION");errorCallback({errorCode:"BAD_PARAMETER",errorText:"Redirect cannot be more that 5"});return}
if(options.headers&&JSON.stringify(options.headers).length>1024){log("header too long header too long");errorCallback({errorCode:"BAD_PARAMETER",errorText:"Header data cannot be bigger than 1K"});return}
if(typeof options.httpOption==='undefined'){options.httpOption={}}
if(options.httpOption.headers&&JSON.stringify(options.httpOption.headers).length>1024){log("header too long header too long");errorCallback({errorCode:"BAD_PARAMETER",errorText:"Header data cannot be bigger than 1K"});return}
if(options.maxRedirection||options.headers){if(options.maxRedirection&&typeof options.httpOption.maxRedirection==='undefined'){options.httpOption.maxRedirection=options.maxRedirection}
if(options.headers&&typeof options.httpOption.headers==='undefined'){options.httpOption.headers=options.headers}}
if(typeof options.httpOption.maxRedirection!=='undefined'){if(typeof options.maxRedirection!=='undefined'){if(options.httpOption.maxRedirection!==options.maxRedirection){errorCallback({errorCode:"BAD_PARAMETER",errorText:"Both options.httpOption.maxRedirection and options.maxRedirection are exists,"+"but different value. What value you want to use?"});return}}else options.maxRedirection=options.httpOption.maxRedirection}
log(options);service.Request("luna://com.webos.service.commercial.scapadapter",{method:"fs/copyFile",parameters:{dest:options.destination,src:options.source,ftpOption:options.ftpOption,httpOption:options.httpOption},onSuccess:function(result){if(result.returnValue===!0){log("SUCCESS");successCallback()}else{log("Err: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){log("Err: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})};Storage.prototype.removeFile=function(successCallback,errorCallback,options){if(!(options&&isValidFileURI(options.file))){errorCallback({errorCode:"BAD_PARAMETER",errorText:"options.file is a mandatory parameter"});return}
var param={file:options.file};if(options.recursive===!0){param.recursive=!0}
service.Request("luna://com.webos.service.commercial.scapadapter",{method:"fs/removeFile",parameters:param,onSuccess:function(result){log("onSuccess");if(result.returnValue===!0){successCallback()}else{errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){log("onFailure");errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})};Storage.prototype.listFiles=function(successCallback,errorCallback,options){var param={};if(options&&options.path){if(isValidFileURI(options.path)){param.pathURI=options.path}else{errorCallback({errorCode:"BAD_PARAMETER",errorText:"File URI is not valid."});return}}else{param.pathURI="file://internal/"}
service.Request("luna://com.webos.service.commercial.scapadapter",{method:"fs/listFiles",parameters:param,onSuccess:function(result){if(result.returnValue===!0){var files=[];for(var i=0;i<result.files.length;++i){log(result.files[i]);var fileinfo={name:result.files[i].name,type:(result.files[i].type==='folder')?'folder':'file',size:result.files[i].size};files.push(fileinfo)}
var cbObj={files:files,totalCount:result.totalCount};successCallback(cbObj)}else{errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})};Storage.prototype.getStorageInfo=function(successCallback,errorCallback){service.Request("luna://com.webos.service.commercial.scapadapter",{method:"fs/storageInfo",parameters:{},onSuccess:function(result){log("returned : "+JSON.stringify(result,null,3));if(result.returnValue===!0){log("returned : "+JSON.stringify(result,null,3));var cbObj={free:result.spaceInfo.freeSize,total:result.spaceInfo.totalSize,used:result.spaceInfo.usedSize,externalMemory:result.externalStorage};successCallback(cbObj)}else{errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})};Storage.prototype.mkdir=function(successCallback,errorCallback,options){if(!(options&&isValidFileURI(options.path))){errorCallback({errorCode:"BAD_PARAMETER",errorText:"options.path is a mandatory parameter"});return}
var param={pathURI:options.path};service.Request("luna://com.webos.service.commercial.scapadapter",{method:"fs/mkdir",parameters:param,onSuccess:function(result){log("onSuccess");if(result.returnValue===!0){successCallback()}else{errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){log("onFailure");errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})};Storage.prototype.exists=function(successCallback,errorCallback,options){if(!(options&&isValidFileURI(options.path))){log("BAD_PARAMETER");errorCallback({errorCode:"BAD_PARAMETER",errorText:"options.path is a mandatory parameter"});return}
var param={pathURI:options.path};service.Request("luna://com.webos.service.commercial.scapadapter",{method:"fs/exists",parameters:param,onSuccess:function(result){log("onSuccess");if(result.returnValue===!0){log("returned : "+JSON.stringify(result,null,3));var cbObj={exists:result.exists};successCallback(cbObj)}else{errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){log("onFailure");errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})};Storage.prototype.readFile=function(successCallback,errorCallback,options){if(!options){errorCallback({errorCode:"BAD_PARAMETER",errorText:"options.path is a mandatory parameter"})}else if(!isValidFileURI(options.path)){errorCallback({errorCode:"BAD_PARAMETER",errorText:"options.path is a mandatory parameter"})}else if(options.length&&(options.length>Storage.MAX_BUFFER_LENGTH||options.length<1)){errorCallback({errorCode:"BAD_PARAMETER",errorText:"length should be > 0 and < "+Storage.MAX_BUFFER_LENGTH})}else if(options.position&&(options.position<0)){errorCallback({errorCode:"BAD_PARAMETER",errorText:"position should be > 0"})}else{var params={};params.path=options.path;params.length=options.length?options.length:Storage.MAX_BUFFER_LENGTH;params.position=options.position?options.position:0;params.encoding=options.encoding?options.encoding:'utf-8';service.Request("luna://com.webos.service.commercial.scapadapter",{method:"fs/readFile",parameters:params,onSuccess:function(result){if(result.returnValue){if(params.encoding==='binary'){var byteArray=result.data;var arrayView=new Uint8Array(byteArray.length);for(var i=0;i<byteArray.length;++i){arrayView[i]=byteArray[i]}
successCallback({data:arrayView.buffer})}else{successCallback({data:result.data})}}else{errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})}};Storage.prototype.writeFile=function(successCallback,errorCallback,options){if(!options){errorCallback({errorCode:"BAD_PARAMETER",errorText:"options.path is a mandatory parameter"})}else if(!isValidFileURI(options.path)){errorCallback({errorCode:"BAD_PARAMETER",errorText:"options.path is a is not valid"})}else if(!options.data){errorCallback({errorCode:"BAD_PARAMETER",errorText:"options.data is a mandatory parameter"})}else if(options.mode&&(options.mode!=='truncate'&&options.mode!=='append'&&options.mode!=='position')){errorCallback({errorCode:"BAD_PARAMETER",errorText:"mode should be 'truncate'|'append'|'position'"})}else if(options.position&&(options.position<0)){errorCallback({errorCode:"BAD_PARAMETER",errorText:"position should be > 0"})}else if(options.offset&&(options.offset<0)){errorCallback({errorCode:"BAD_PARAMETER",errorText:"offset should be > 0"})}else if(options.length&&(options.length>Storage.MAX_BUFFER_LENGTH||options.length<1)){errorCallback({errorCode:"BAD_PARAMETER",errorText:"length should be > 0 and < "+Storage.MAX_BUFFER_LENGTH})}else if(options.encoding&&(options.encoding!=='utf8'&&options.encoding!=='binary'&&options.encoding!=='base64')){errorCallback({errorCode:"BAD_PARAMETER",errorText:"Invalid encoding: "+options.encoding})}else{log("REQUEST");var params={};params.path=options.path;params.mode=options.mode?options.mode:'truncate';params.position=options.position?options.position:0;params.encoding=options.encoding?options.encoding:'utf8';var offset=options.offset?options.offset:0;if(params.encoding==='binary'){log("binary, size is: "+options.data.byteLength);var uint8View=new Uint8Array(options.data);log("uint8View: "+uint8View);var maxLength=options.length?options.length:Storage.MAX_BUFFER_LENGTH;var array=[];var count=0;for(var i=offset;i<uint8View.length&&count<maxLength;++i,count++){array[count]=uint8View[i]}
log("array length: "+count);params.data=array;params.length=count;params.offset=0}
else if(params.encoding==='base64'){var maxLength2=options.length?options.length:Storage.MAX_BUFFER_LENGTH;log("base64, size is: "+options.data.length);var base64Str=options.data;var decodedRaw=window.atob(base64Str);var decoded=decodedRaw.substring(offset,offset+maxLength2);var arrayView=new Uint8Array(decoded.length);var j;for(j=0;j<decoded.length;j++){arrayView[j]=decoded.charCodeAt(j)}
var array2=[];for(j=0;j<arrayView.length;++j){array2[j]=arrayView[j]}
params.data=array2;params.length=array2.length;params.offset=0}
else{var maxLength3=options.length?options.length:Storage.MAX_BUFFER_LENGTH;params.data=options.data.substring(offset,offset+maxLength3);params.length=params.data.length;params.offset=0}
try{service.Request("luna://com.webos.service.commercial.scapadapter",{method:"fs/writeFile",parameters:params,onSuccess:function(result){log("onSuccess");if(result.returnValue){successCallback({written:result.written})}else{log("FAILED: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){log("onFailure");log("FAILED: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})}catch(err){log("EXCEPTION"+err);errorCallback({errorCode:'STWF',errorText:'Storage.writeFile() error is occured during operation.'})}}};Storage.prototype.statFile=function(successCallback,errorCallback,options){if(!(options&&isValidFileURI(options.path))){errorCallback({errorCode:"BAD_PARAMETER",errorText:"options.path is a mandatory parameter"})}else if(!options.path){errorCallback({errorCode:"BAD_PARAMETER",errorText:"options.path is a mandatory parameter"})}else{try{service.Request("luna://com.webos.service.commercial.scapadapter",{method:"fs/statFile",parameters:{path:options.path},onSuccess:function(result){log("onSuccess");if(result.returnValue){successCallback(result.stat)}else{log("FAILED: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){log("onFailure");log("FAILED: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})}catch(err){log("EXCEPTION"+err);errorCallback({errorCode:'STSF',errorText:'Storage.statFile() error is occured during operation.'})}}};Storage.prototype.removeAll=function(successCallback,errorCallback,options){if(!options){errorCallback({errorCode:"BAD_PARAMETER",errorText:"options.device is a mandatory parameter"})}else if(!options.device){errorCallback({errorCode:"BAD_PARAMETER",errorText:"options.device is a mandatory parameter"})}else{try{service.Request("luna://com.webos.service.commercial.scapadapter",{method:"fs/removeAll",parameters:{device:options.device},onSuccess:function(result){log("onSuccess");if(result.returnValue){successCallback()}else{log("FAILED: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){log("onFailure");log("FAILED: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})}catch(err){log("EXCEPTION"+err);errorCallback({errorCode:'STRA',errorText:'Storage.removeAll() error is occured during operation.'})}}};Storage.prototype.fsync=function(successCallback,errorCallback,options){try{var params={};if(options&&options.path){if(isValidFileURI(options.path)){params.path=options.path}else{errorCallback({errorCode:"BAD_PARAMETER",errorText:"Invalid File URI"});return}}
service.Request("luna://com.webos.service.commercial.scapadapter",{method:"fs/fsyncFile",parameters:params,onSuccess:function(result){log("onSuccess");if(result.returnValue){successCallback()}else{log("FAILED: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){log("onFailure");log("FAILED: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})}catch(err){log("EXCEPTION"+err);errorCallback({errorCode:'STFS',errorText:'Storage.fsync() error is occured during operation.'})}};Storage.prototype.moveFile=function(successCallback,errorCallback,options){if(!options){errorCallback({errorCode:"BAD_PARAMETER",errorText:"options.path is a mandatory parameter"})}else if(!isValidFileURI(options.oldPath)){errorCallback({errorCode:"BAD_PARAMETER",errorText:"options.oldpath is a mandatory parameter"})}else if(!isValidFileURI(options.newPath)){errorCallback({errorCode:"BAD_PARAMETER",errorText:"options.newPath is a mandatory parameter"})}else{try{service.Request("luna://com.webos.service.commercial.scapadapter",{method:"fs/moveFile",parameters:{oldPath:options.oldPath,newPath:options.newPath},onSuccess:function(result){log("onSuccess");if(result.returnValue){successCallback()}else{log("FAILED: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){log("onFailur");log("FAILED: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})}catch(err){log("EXCEPTION"+err);errorCallback({errorCode:'STMF',errorText:'Storage.moveFile() error is occured during operation.'})}}};Storage.prototype.unzipFile=function(successCallback,errorCallback,options){if(!options){errorCallback({errorCode:"BAD_PARAMETER",errorText:"options.path is a mandatory parameter"})}else if(!isValidFileURI(options.zipPath)){errorCallback({errorCode:"BAD_PARAMETER",errorText:"options.zipPath is a mandatory parameter"})}else if(!isValidFileURI(options.targetPath)){errorCallback({errorCode:"BAD_PARAMETER",errorText:"options.targetPath is a mandatory parameter"})}else{try{service.Request("luna://com.webos.service.commercial.scapadapter",{method:"fs/unzip",parameters:{zipPath:options.zipPath,targetPath:options.targetPath},onSuccess:function(result){log("onSuccess");if(result.returnValue){successCallback()}else{log("FAILED: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}},onFailure:function(result){log("onFailure");log("FAILED: "+result.errorText);errorCallback({errorCode:result.errorCode,errorText:result.errorText})}})}catch(err){log("EXCEPTION"+err);errorCallback({errorCode:'STUF',errorText:'Storage.unzipFile() error is occured during operation.'})}}};Storage.prototype.getMD5Hash=function(successCallback,errorCallback,options){log("getMD5Hash: ");if(!(options&&isValidFileURI(options.filePath))){errorCallback({errorCode:"BAD_PARAMETER",errorText:"options.filePath is a mandatory parameter"});return}
service.Request('luna://com.webos.service.commercial.scapadapter',{method:'fs/getMD5Hash',parameters:{filePath:options.filePath},onSuccess:function(result){if(typeof successCallback==='function'){delete result.returnValue;successCallback(result)}},onFailure:function(error){log("getMD5Hash: onFailure");delete error.returnValue;if(typeof errorCallback==='function'){errorCallback(error)}}});log("Storage.getMD5Hash Done")};Storage.prototype.decryptFile=function(successCallback,errorCallback,options){log("decryptFile: ");service.Request('luna://com.webos.service.commercial.scapadapter',{method:'fs/decryptFile',parameters:{cipher_mode:options.cipher_mode,password:options.password,inputPath:options.inputPath,outputFileName:options.outputFileName},onSuccess:function(result){if(typeof successCallback==='function'){delete result.returnValue;successCallback(result)}},onFailure:function(error){log("decryptFile: onFailure");delete error.returnValue;if(typeof errorCallback==='function'){errorCallback(error)}}});log("Storage.decryptFile Done")};return Storage}())

/***/ }),
/* 18 */
/***/ (function(module, exports) {

Time=(function(){var Time,service;function log(msg){}
if(typeof window==='object'){cordova.define('cordova/plugin/time',function(require,exports,module){Time=function(){};var service;if(window.PalmSystem){log("Window.PalmSystem Available");service=require('cordova/plugin/webos/service')}else{service={Request:function(uri,params){log(uri+" invoked. But I am a dummy because PalmSystem is not available");if(typeof params.onFailure==='function'){params.onFailure({returnValue:!1,errorText:"PalmSystem Not Available. Cordova is not installed?"})}}}}
module.exports=Time});Time=cordova.require('cordova/plugin/time')}
else{Time=function(serviceInstance){service=serviceInstance;service.Request=function(serviceUri,reqParams){var commandURI=serviceUri+"/"+reqParams.method;var parameters={};if(reqParams.hasOwnProperty("parameters")===!0)
parameters=reqParams.parameters;var convertedRes={};var callback=function(res){console.log("res : "+JSON.stringify(res));if(res.payload.returnValue===!0){convertedRes=res.payload;reqParams.onSuccess(convertedRes)}else{convertedRes.returnValue=!1;convertedRes.errorCode=res.payload.errorCode;convertedRes.errorText=res.payload.errorText;reqParams.onFailure(convertedRes)}}
if(service){service.call(commandURI,parameters,callback)}}};module.exports=Time}
Time.TimerType={ONTIMER:"ONTIMER",OFFTIMER:"OFFTIMER"};Time.TimerWeek={MONDAY:1,TUESDAY:2,WEDNESDAY:4,THURSDAY:8,FRIDAY:16,SATURDAY:32,SUNDAY:64,EVERYDAY:127};function checkErrorCodeNText(result,errorCode,errorText){if(result.errorCode===undefined||result.errorCode===null){result.errorCode=errorCode}
if(result.errorText===undefined||result.errorText===null){result.errorText=errorText}}
Time.prototype.reserveOnOffTimer=function(successCallback,errorCallback,options){service.Request('luna://com.webos.service.commercial.scapadapter/time/',{method:'reserveOnOffTimer',parameters:options,onSuccess:function(result){log("reserveOnOffTimer: onSuccess");if(typeof successCallback==='function'){successCallback()}},onFailure:function(error){log("reserveOnOffTimer: onFailure");delete error.returnValue;if(typeof errorCallback==='function'){errorCallback(error)}}})};Time.prototype.clearAllOnOffTimers=function(successCallback,errorCallback){service.Request('luna://com.webos.service.commercial.scapadapter/time/',{method:'clearAllOnOffTimers',parameters:{},onSuccess:function(result){log("clearAllOnOffTimers: onSuccess");if(typeof successCallback==='function'){successCallback()}},onFailure:function(error){log("clearAllOnOffTimers: onFailure");delete error.returnValue;if(typeof errorCallback==='function'){errorCallback(error)}}})};Time.prototype.cancelOnOffTimer=function(successCallback,errorCallback,options){service.Request('luna://com.webos.service.commercial.scapadapter/time/',{method:'cancelOnOffTimer',parameters:options,onSuccess:function(result){log("cancelOnOffTimer: onSuccess");if(typeof successCallback==='function'){successCallback()}},onFailure:function(error){log("cancelOnOffTimer: onFailure");delete error.returnValue;if(typeof errorCallback==='function'){errorCallback(error)}}})};Time.prototype.getAllOnOffTimers=function(successCallback,errorCallback){service.Request('luna://com.webos.service.commercial.scapadapter/time/',{method:'getAllOnOffTimers',parameters:{},onSuccess:function(result){log("getAllOnOffTimers: onSuccess");delete result.returnValue;if(typeof successCallback==='function'){successCallback(result)}},onFailure:function(error){log("getAllOnOffTimers: onFailure");delete error.returnValue;if(typeof errorCallback==='function'){errorCallback(error)}}})};Time.prototype.setHolidayScheduleMode=function(successCallback,errorCallback,options){var ret={};checkErrorCodeNText(ret,"DEPRECATED_API","This function is deprecated.");errorCallback(ret)};Time.prototype.getHolidayScheduleMode=function(successCallback,errorCallback){var ret={};checkErrorCodeNText(ret,"DEPRECATED_API","This function is deprecated.");errorCallback(ret)};Time.prototype.addHolidaySchedule=function(successCallback,errorCallback,options){var ret={};checkErrorCodeNText(ret,"DEPRECATED_API","This function is deprecated.");errorCallback(ret)};Time.prototype.delHolidaySchedule=function(successCallback,errorCallback,options){var ret={};checkErrorCodeNText(ret,"DEPRECATED_API","This function is deprecated.");errorCallback(ret)};Time.prototype.delAllHolidaySchedules=function(successCallback,errorCallback){var ret={};checkErrorCodeNText(ret,"DEPRECATED_API","This function is deprecated.");errorCallback(ret)};Time.prototype.getAllHolidaySchedules=function(successCallback,errorCallback){var ret={};checkErrorCodeNText(ret,"DEPRECATED_API","This function is deprecated.");errorCallback(ret)};Time.prototype.getHolidaySchedule=function(successCallback,errorCallback){log("getHolidaySchedule: ");service.Request("luna://com.webos.service.commercial.scapadapter/",{method:"getHolidaySchedule",parameters:{},onSuccess:function(result){log("getHolidaySchedule: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){var cbObj={};cbObj.holidayScheduleList=result.settings.holidaySchedule;if(typeof successCallback==='function'){successCallback(cbObj)}}}},onFailure:function(result){log("getHolidaySchedule: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"TGAS","Time.getHolidaySchedule returns failure.");errorCallback(result)}}});log("Time.getHolidaySchedule Done")};Time.prototype.setHolidaySchedule=function(successCallback,errorCallback,params){log("setHolidaySchedule: ");service.Request("luna://com.webos.service.commercial.scapadapter/",{method:"setHolidaySchedule",parameters:params,onSuccess:function(result){log("setHolidaySchedule: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){if(typeof successCallback==='function'){successCallback()}}}},onFailure:function(result){log("setHolidaySchedule: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"TGAS","Time.setHolidaySchedule returns failure.");errorCallback(result)}}});log("Time.setHolidaySchedule Done")};Time.prototype.unsetHolidaySchedule=function(successCallback,errorCallback){log("unsetHolidaySchedule: ");service.Request("luna://com.webos.service.commercial.scapadapter/",{method:"unsetHolidaySchedule",parameters:{},onSuccess:function(result){log("unsetHolidaySchedule: On Success");if(result.returnValue===!0){if(typeof successCallback==='function'){if(typeof successCallback==='function'){successCallback()}}}},onFailure:function(result){log("unsetHolidaySchedule: On Failure");delete result.returnValue;if(typeof errorCallback==='function'){checkErrorCodeNText(result,"TGAS","Time.unsetHolidaySchedule returns failure.");errorCallback(result)}}});log("Time.unsetHolidaySchedule Done")};return Time}())

/***/ }),
/* 19 */
/***/ (function(module, exports) {

Utility=(function(){var b,a;function d(e){}if(typeof window==="object"){cordova.define("cordova/plugin/utility",function(f,e,g){b=function(){};if(window.PalmSystem){d("Window.PalmSystem Available");a=f("cordova/plugin/webos/service")}else{a={Request:function(h,i){d(h+" invoked. But I am a dummy because PalmSystem is not available");if(typeof i.onFailure==="function"){i.onFailure({returnValue:false,errorText:"PalmSystem Not Available. Cordova is not installed?"})}}}}g.exports=b});b=cordova.require("cordova/plugin/utility")}else{b=function(e){a=e;a.Request=function(f,h){var g=f+"/"+h.method;var i={};if(h.hasOwnProperty("parameters")===true){i=h.parameters}var j={};var k=function(l){console.log("res : "+JSON.stringify(l));if(l.payload.returnValue===true){j=l.payload;h.onSuccess(j)}else{j.returnValue=false;j.errorCode=l.payload.errorCode;j.errorText=l.payload.errorText;h.onFailure(j)}};if(a){a.call(g,i,k)}}};module.exports=b}function c(f,g,e){if(f.errorCode===undefined||f.errorCode===null){f.errorCode=g}if(f.errorText===undefined||f.errorText===null){f.errorText=e}}b.prototype.createToast=function(f,g,h){d("createToast: "+h.msg);if(h.msg===null&&typeof g==="function"){var e={};c(e,"UTCT","Utility.createToast returns failure. command was not defined.");g(e);d("Utility.createToast invalid ");return}a.Request("luna://com.webos.service.commercial.scapadapter/",{method:"createToast",parameters:{text:h.msg},onSuccess:function(i){d("createToast: On Success");if(i.returnValue===true){if(typeof f==="function"){d("call successCallback");f()}}},onFailure:function(i){d("createToast: On Failure");delete i.returnValue;if(typeof g==="function"){c(i,"UTCT","Utility.createToast returns failure.");1;g(i)}}});d("Utility.createToast Done")};return b}());

/***/ })
/******/ ]);